/**********************************************************************************************
 * Filename:       BQ27426_Fuel_Gauge_Service.c
 *
 * Description:    This file contains the implementation of the service.
 *
 *                 Generated by:
 *                 BDS version: 1.1.3066.0
 *                 Plugin:      Texas Instruments CC26xx BLE SDK v2.1 GATT Server plugin 1.0.5 beta
 *                 Time:        Mon Dec 05 2016 18:09:19 GMT-06:00
 *

 * Copyright (c) 2015, Texas Instruments Incorporated
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * *  Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * *  Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * *  Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *************************************************************************************************/


/*********************************************************************
 * INCLUDES
 */
#include <string.h>

#include "bcomdef.h"
#include "OSAL.h"
#include "linkdb.h"
#include "att.h"
#include "gatt.h"
#include "gatt_uuid.h"
#include "gattservapp.h"
#include "gapbondmgr.h"

#include "BQ27426_Fuel_Gauge_Service.h"

/*********************************************************************
 * MACROS
 */

/*********************************************************************
 * CONSTANTS
 */

/*********************************************************************
 * TYPEDEFS
 */

/*********************************************************************
* GLOBAL VARIABLES
*/

// BQ27426_Fuel_Gauge_Service Service UUID
CONST uint8_t Bq27426FuelGaugeServiceUUID[ATT_UUID_SIZE] =
{
  BQ27426_FUEL_GAUGE_SERVICE_SERV_UUID_BASE128(BQ27426_FUEL_GAUGE_SERVICE_SERV_UUID)
};

// Remaining_Capacity_Unfiltered UUID
CONST uint8_t bfgs_Remaining_Capacity_UnfilteredUUID[ATT_UUID_SIZE] =
{
  BFGS_REMAINING_CAPACITY_UNFILTERED_UUID_BASE128(BFGS_REMAINING_CAPACITY_UNFILTERED_UUID)
};
// Average_Power UUID
CONST uint8_t bfgs_Average_PowerUUID[ATT_UUID_SIZE] =
{
  BFGS_AVERAGE_POWER_UUID_BASE128(BFGS_AVERAGE_POWER_UUID)
};
// Full_Charge_Capacity UUID
CONST uint8_t bfgs_Full_Charge_CapacityUUID[ATT_UUID_SIZE] =
{
  BFGS_FULL_CHARGE_CAPACITY_UUID_BASE128(BFGS_FULL_CHARGE_CAPACITY_UUID)
};
// State_of_Health UUID
CONST uint8_t bfgs_State_of_HealthUUID[ATT_UUID_SIZE] =
{
  BFGS_STATE_OF_HEALTH_UUID_BASE128(BFGS_STATE_OF_HEALTH_UUID)
};
// Internal_Temperature UUID
CONST uint8_t bfgs_Internal_TemperatureUUID[ATT_UUID_SIZE] =
{
  BFGS_INTERNAL_TEMPERATURE_UUID_BASE128(BFGS_INTERNAL_TEMPERATURE_UUID)
};
// State_of_Charge UUID
CONST uint8_t bfgs_State_of_ChargeUUID[ATT_UUID_SIZE] =
{
  BFGS_STATE_OF_CHARGE_UUID_BASE128(BFGS_STATE_OF_CHARGE_UUID)
};
// Full_Charge_Capacity_Filtered UUID
CONST uint8_t bfgs_Full_Charge_Capacity_FilteredUUID[ATT_UUID_SIZE] =
{
  BFGS_FULL_CHARGE_CAPACITY_FILTERED_UUID_BASE128(BFGS_FULL_CHARGE_CAPACITY_FILTERED_UUID)
};
// Remaining_Capacity_Filtered UUID
CONST uint8_t bfgs_Remaining_Capacity_FilteredUUID[ATT_UUID_SIZE] =
{
  BFGS_REMAINING_CAPACITY_FILTERED_UUID_BASE128(BFGS_REMAINING_CAPACITY_FILTERED_UUID)
};
// Average_Current UUID
CONST uint8_t bfgs_Average_CurrentUUID[ATT_UUID_SIZE] =
{
  BFGS_AVERAGE_CURRENT_UUID_BASE128(BFGS_AVERAGE_CURRENT_UUID)
};
// Remaining_Capacity UUID
CONST uint8_t bfgs_Remaining_CapacityUUID[ATT_UUID_SIZE] =
{
  BFGS_REMAINING_CAPACITY_UUID_BASE128(BFGS_REMAINING_CAPACITY_UUID)
};
// Full_Available_Capacity UUID
CONST uint8_t bfgs_Full_Available_CapacityUUID[ATT_UUID_SIZE] =
{
  BFGS_FULL_AVAILABLE_CAPACITY_UUID_BASE128(BFGS_FULL_AVAILABLE_CAPACITY_UUID)
};
// Voltage UUID
CONST uint8_t bfgs_VoltageUUID[ATT_UUID_SIZE] =
{
  BFGS_VOLTAGE_UUID_BASE128(BFGS_VOLTAGE_UUID)
};
// Temperature UUID
CONST uint8_t bfgs_TemperatureUUID[ATT_UUID_SIZE] =
{
  BFGS_TEMPERATURE_UUID_BASE128(BFGS_TEMPERATURE_UUID)
};
// Nominal_Available_Capacity UUID
CONST uint8_t bfgs_Nominal_Available_CapacityUUID[ATT_UUID_SIZE] =
{
  BFGS_NOMINAL_AVAILABLE_CAPACITY_UUID_BASE128(BFGS_NOMINAL_AVAILABLE_CAPACITY_UUID)
};
// Full_Charge_Capacity_Unfiltered UUID
CONST uint8_t bfgs_Full_Charge_Capacity_UnfilteredUUID[ATT_UUID_SIZE] =
{
  BFGS_FULL_CHARGE_CAPACITY_UNFILTERED_UUID_BASE128(BFGS_FULL_CHARGE_CAPACITY_UNFILTERED_UUID)
};
// State_of_Charge_Unfiltered UUID
CONST uint8_t bfgs_State_of_Charge_UnfilteredUUID[ATT_UUID_SIZE] =
{
  BFGS_STATE_OF_CHARGE_UNFILTERED_UUID_BASE128(BFGS_STATE_OF_CHARGE_UNFILTERED_UUID)
};
// Flags UUID
CONST uint8_t bfgs_FlagsUUID[ATT_UUID_SIZE] =
{
  BFGS_FLAGS_UUID_BASE128(BFGS_FLAGS_UUID)
};
// Initialize_Fuel_Gauge UUID
CONST uint8_t bfgs_Initialize_Fuel_GaugeUUID[ATT_UUID_SIZE] =
{
  BFGS_INITIALIZE_FUEL_GAUGE_UUID_BASE128(BFGS_INITIALIZE_FUEL_GAUGE_UUID)
};
// Reserved_1 UUID
CONST uint8_t bfgs_Reserved_1UUID[ATT_UUID_SIZE] =
{
  BFGS_RESERVED_1_UUID_BASE128(BFGS_RESERVED_1_UUID)
};

/*********************************************************************
 * LOCAL VARIABLES
 */

static Bq27426FuelGaugeServiceCBs_t *pAppCBs = NULL;

/*********************************************************************
* Profile Attributes - variables
*/

// Service declaration
static CONST gattAttrType_t Bq27426FuelGaugeServiceDecl = { ATT_UUID_SIZE, Bq27426FuelGaugeServiceUUID };

// Characteristic "Remaining_Capacity_Unfiltered" Properties (for declaration)
static uint8_t bfgs_Remaining_Capacity_UnfilteredProps = GATT_PROP_NOTIFY | GATT_PROP_READ;

// Characteristic "Remaining_Capacity_Unfiltered" Value variable
static uint8_t bfgs_Remaining_Capacity_UnfilteredVal[BFGS_REMAINING_CAPACITY_UNFILTERED_LEN] = {0};

// Length of data in characteristic "Remaining_Capacity_Unfiltered" Value variable, initialized to minimal size.
static uint16_t bfgs_Remaining_Capacity_UnfilteredValLen = BFGS_REMAINING_CAPACITY_UNFILTERED_LEN_MIN;

// Characteristic "Remaining_Capacity_Unfiltered" CCCD
static gattCharCfg_t *bfgs_Remaining_Capacity_UnfilteredConfig;

// Characteristic "Average_Power" Properties (for declaration)
static uint8_t bfgs_Average_PowerProps = GATT_PROP_NOTIFY | GATT_PROP_READ;

// Characteristic "Average_Power" Value variable
static uint8_t bfgs_Average_PowerVal[BFGS_AVERAGE_POWER_LEN] = {0};

// Length of data in characteristic "Average_Power" Value variable, initialized to minimal size.
static uint16_t bfgs_Average_PowerValLen = BFGS_AVERAGE_POWER_LEN_MIN;

// Characteristic "Average_Power" CCCD
static gattCharCfg_t *bfgs_Average_PowerConfig;

// Characteristic "Full_Charge_Capacity" Properties (for declaration)
static uint8_t bfgs_Full_Charge_CapacityProps = GATT_PROP_NOTIFY | GATT_PROP_READ;

// Characteristic "Full_Charge_Capacity" Value variable
static uint8_t bfgs_Full_Charge_CapacityVal[BFGS_FULL_CHARGE_CAPACITY_LEN] = {0};

// Length of data in characteristic "Full_Charge_Capacity" Value variable, initialized to minimal size.
static uint16_t bfgs_Full_Charge_CapacityValLen = BFGS_FULL_CHARGE_CAPACITY_LEN_MIN;

// Characteristic "Full_Charge_Capacity" CCCD
static gattCharCfg_t *bfgs_Full_Charge_CapacityConfig;

// Characteristic "State_of_Health" Properties (for declaration)
static uint8_t bfgs_State_of_HealthProps = GATT_PROP_NOTIFY | GATT_PROP_READ;

// Characteristic "State_of_Health" Value variable
static uint8_t bfgs_State_of_HealthVal[BFGS_STATE_OF_HEALTH_LEN] = {0};

// Length of data in characteristic "State_of_Health" Value variable, initialized to minimal size.
static uint16_t bfgs_State_of_HealthValLen = BFGS_STATE_OF_HEALTH_LEN_MIN;

// Characteristic "State_of_Health" CCCD
static gattCharCfg_t *bfgs_State_of_HealthConfig;

// Characteristic "Internal_Temperature" Properties (for declaration)
static uint8_t bfgs_Internal_TemperatureProps = GATT_PROP_NOTIFY | GATT_PROP_READ;

// Characteristic "Internal_Temperature" Value variable
static uint8_t bfgs_Internal_TemperatureVal[BFGS_INTERNAL_TEMPERATURE_LEN] = {0};

// Length of data in characteristic "Internal_Temperature" Value variable, initialized to minimal size.
static uint16_t bfgs_Internal_TemperatureValLen = BFGS_INTERNAL_TEMPERATURE_LEN_MIN;

// Characteristic "Internal_Temperature" CCCD
static gattCharCfg_t *bfgs_Internal_TemperatureConfig;

// Characteristic "State_of_Charge" Properties (for declaration)
static uint8_t bfgs_State_of_ChargeProps = GATT_PROP_NOTIFY | GATT_PROP_READ;

// Characteristic "State_of_Charge" Value variable
static uint8_t bfgs_State_of_ChargeVal[BFGS_STATE_OF_CHARGE_LEN] = {0};

// Length of data in characteristic "State_of_Charge" Value variable, initialized to minimal size.
static uint16_t bfgs_State_of_ChargeValLen = BFGS_STATE_OF_CHARGE_LEN_MIN;

// Characteristic "State_of_Charge" CCCD
static gattCharCfg_t *bfgs_State_of_ChargeConfig;

// Characteristic "Full_Charge_Capacity_Filtered" Properties (for declaration)
static uint8_t bfgs_Full_Charge_Capacity_FilteredProps = GATT_PROP_NOTIFY | GATT_PROP_READ;

// Characteristic "Full_Charge_Capacity_Filtered" Value variable
static uint8_t bfgs_Full_Charge_Capacity_FilteredVal[BFGS_FULL_CHARGE_CAPACITY_FILTERED_LEN] = {0};

// Length of data in characteristic "Full_Charge_Capacity_Filtered" Value variable, initialized to minimal size.
static uint16_t bfgs_Full_Charge_Capacity_FilteredValLen = BFGS_FULL_CHARGE_CAPACITY_FILTERED_LEN_MIN;

// Characteristic "Full_Charge_Capacity_Filtered" CCCD
static gattCharCfg_t *bfgs_Full_Charge_Capacity_FilteredConfig;

// Characteristic "Remaining_Capacity_Filtered" Properties (for declaration)
static uint8_t bfgs_Remaining_Capacity_FilteredProps = GATT_PROP_NOTIFY | GATT_PROP_READ;

// Characteristic "Remaining_Capacity_Filtered" Value variable
static uint8_t bfgs_Remaining_Capacity_FilteredVal[BFGS_REMAINING_CAPACITY_FILTERED_LEN] = {0};

// Length of data in characteristic "Remaining_Capacity_Filtered" Value variable, initialized to minimal size.
static uint16_t bfgs_Remaining_Capacity_FilteredValLen = BFGS_REMAINING_CAPACITY_FILTERED_LEN_MIN;

// Characteristic "Remaining_Capacity_Filtered" CCCD
static gattCharCfg_t *bfgs_Remaining_Capacity_FilteredConfig;

// Characteristic "Average_Current" Properties (for declaration)
static uint8_t bfgs_Average_CurrentProps = GATT_PROP_NOTIFY | GATT_PROP_READ;

// Characteristic "Average_Current" Value variable
static uint8_t bfgs_Average_CurrentVal[BFGS_AVERAGE_CURRENT_LEN] = {0};

// Length of data in characteristic "Average_Current" Value variable, initialized to minimal size.
static uint16_t bfgs_Average_CurrentValLen = BFGS_AVERAGE_CURRENT_LEN_MIN;

// Characteristic "Average_Current" CCCD
static gattCharCfg_t *bfgs_Average_CurrentConfig;

// Characteristic "Remaining_Capacity" Properties (for declaration)
static uint8_t bfgs_Remaining_CapacityProps = GATT_PROP_NOTIFY | GATT_PROP_READ;

// Characteristic "Remaining_Capacity" Value variable
static uint8_t bfgs_Remaining_CapacityVal[BFGS_REMAINING_CAPACITY_LEN] = {0};

// Length of data in characteristic "Remaining_Capacity" Value variable, initialized to minimal size.
static uint16_t bfgs_Remaining_CapacityValLen = BFGS_REMAINING_CAPACITY_LEN_MIN;

// Characteristic "Remaining_Capacity" CCCD
static gattCharCfg_t *bfgs_Remaining_CapacityConfig;

// Characteristic "Full_Available_Capacity" Properties (for declaration)
static uint8_t bfgs_Full_Available_CapacityProps = GATT_PROP_NOTIFY | GATT_PROP_READ;

// Characteristic "Full_Available_Capacity" Value variable
static uint8_t bfgs_Full_Available_CapacityVal[BFGS_FULL_AVAILABLE_CAPACITY_LEN] = {0};

// Length of data in characteristic "Full_Available_Capacity" Value variable, initialized to minimal size.
static uint16_t bfgs_Full_Available_CapacityValLen = BFGS_FULL_AVAILABLE_CAPACITY_LEN_MIN;

// Characteristic "Full_Available_Capacity" CCCD
static gattCharCfg_t *bfgs_Full_Available_CapacityConfig;

// Characteristic "Voltage" Properties (for declaration)
static uint8_t bfgs_VoltageProps = GATT_PROP_NOTIFY | GATT_PROP_READ;

// Characteristic "Voltage" Value variable
static uint8_t bfgs_VoltageVal[BFGS_VOLTAGE_LEN] = {0};

// Length of data in characteristic "Voltage" Value variable, initialized to minimal size.
static uint16_t bfgs_VoltageValLen = BFGS_VOLTAGE_LEN_MIN;

// Characteristic "Voltage" CCCD
static gattCharCfg_t *bfgs_VoltageConfig;

// Characteristic "Temperature" Properties (for declaration)
static uint8_t bfgs_TemperatureProps = GATT_PROP_NOTIFY | GATT_PROP_READ;

// Characteristic "Temperature" Value variable
static uint8_t bfgs_TemperatureVal[BFGS_TEMPERATURE_LEN] = {0};

// Length of data in characteristic "Temperature" Value variable, initialized to minimal size.
static uint16_t bfgs_TemperatureValLen = BFGS_TEMPERATURE_LEN_MIN;

// Characteristic "Temperature" CCCD
static gattCharCfg_t *bfgs_TemperatureConfig;

// Characteristic "Nominal_Available_Capacity" Properties (for declaration)
static uint8_t bfgs_Nominal_Available_CapacityProps = GATT_PROP_NOTIFY | GATT_PROP_READ;

// Characteristic "Nominal_Available_Capacity" Value variable
static uint8_t bfgs_Nominal_Available_CapacityVal[BFGS_NOMINAL_AVAILABLE_CAPACITY_LEN] = {0};

// Length of data in characteristic "Nominal_Available_Capacity" Value variable, initialized to minimal size.
static uint16_t bfgs_Nominal_Available_CapacityValLen = BFGS_NOMINAL_AVAILABLE_CAPACITY_LEN_MIN;

// Characteristic "Nominal_Available_Capacity" CCCD
static gattCharCfg_t *bfgs_Nominal_Available_CapacityConfig;

// Characteristic "Full_Charge_Capacity_Unfiltered" Properties (for declaration)
static uint8_t bfgs_Full_Charge_Capacity_UnfilteredProps = GATT_PROP_NOTIFY | GATT_PROP_READ;

// Characteristic "Full_Charge_Capacity_Unfiltered" Value variable
static uint8_t bfgs_Full_Charge_Capacity_UnfilteredVal[BFGS_FULL_CHARGE_CAPACITY_UNFILTERED_LEN] = {0};

// Length of data in characteristic "Full_Charge_Capacity_Unfiltered" Value variable, initialized to minimal size.
static uint16_t bfgs_Full_Charge_Capacity_UnfilteredValLen = BFGS_FULL_CHARGE_CAPACITY_UNFILTERED_LEN_MIN;

// Characteristic "Full_Charge_Capacity_Unfiltered" CCCD
static gattCharCfg_t *bfgs_Full_Charge_Capacity_UnfilteredConfig;

// Characteristic "State_of_Charge_Unfiltered" Properties (for declaration)
static uint8_t bfgs_State_of_Charge_UnfilteredProps = GATT_PROP_NOTIFY | GATT_PROP_READ;

// Characteristic "State_of_Charge_Unfiltered" Value variable
static uint8_t bfgs_State_of_Charge_UnfilteredVal[BFGS_STATE_OF_CHARGE_UNFILTERED_LEN] = {0};

// Length of data in characteristic "State_of_Charge_Unfiltered" Value variable, initialized to minimal size.
static uint16_t bfgs_State_of_Charge_UnfilteredValLen = BFGS_STATE_OF_CHARGE_UNFILTERED_LEN_MIN;

// Characteristic "State_of_Charge_Unfiltered" CCCD
static gattCharCfg_t *bfgs_State_of_Charge_UnfilteredConfig;

// Characteristic "Flags" Properties (for declaration)
static uint8_t bfgs_FlagsProps = GATT_PROP_NOTIFY | GATT_PROP_READ;

// Characteristic "Flags" Value variable
static uint8_t bfgs_FlagsVal[BFGS_FLAGS_LEN] = {0};

// Length of data in characteristic "Flags" Value variable, initialized to minimal size.
static uint16_t bfgs_FlagsValLen = BFGS_FLAGS_LEN_MIN;

// Characteristic "Flags" CCCD
static gattCharCfg_t *bfgs_FlagsConfig;

// Characteristic "Initialize_Fuel_Gauge" Properties (for declaration)
static uint8_t bfgs_Initialize_Fuel_GaugeProps = GATT_PROP_WRITE;

// Characteristic "Initialize_Fuel_Gauge" Value variable
static uint8_t bfgs_Initialize_Fuel_GaugeVal[BFGS_INITIALIZE_FUEL_GAUGE_LEN] = {0};

// Length of data in characteristic "Initialize_Fuel_Gauge" Value variable, initialized to minimal size.
static uint16_t bfgs_Initialize_Fuel_GaugeValLen = BFGS_INITIALIZE_FUEL_GAUGE_LEN_MIN;

// Characteristic "Reserved_1" Properties (for declaration)
static uint8_t bfgs_Reserved_1Props = GATT_PROP_NOTIFY | GATT_PROP_READ | GATT_PROP_WRITE;

// Characteristic "Reserved_1" Value variable
static uint8_t bfgs_Reserved_1Val[BFGS_RESERVED_1_LEN] = {0};

// Length of data in characteristic "Reserved_1" Value variable, initialized to minimal size.
static uint16_t bfgs_Reserved_1ValLen = BFGS_RESERVED_1_LEN_MIN;

// Characteristic "Reserved_1" CCCD
static gattCharCfg_t *bfgs_Reserved_1Config;

/*********************************************************************
* Profile Attributes - Table
*/

static gattAttribute_t BQ27426_Fuel_Gauge_ServiceAttrTbl[] = 
{
  // BQ27426_Fuel_Gauge_Service Service Declaration
  {
    { ATT_BT_UUID_SIZE, primaryServiceUUID },
    GATT_PERMIT_READ,
    0,
    (uint8_t *)&Bq27426FuelGaugeServiceDecl
  },
    // Remaining_Capacity_Unfiltered Characteristic Declaration
    {
      { ATT_BT_UUID_SIZE, characterUUID },
      GATT_PERMIT_READ,
      0,
      &bfgs_Remaining_Capacity_UnfilteredProps
    },
      // Remaining_Capacity_Unfiltered Characteristic Value
      {
        { ATT_UUID_SIZE, bfgs_Remaining_Capacity_UnfilteredUUID },
        GATT_PERMIT_READ | GATT_PERMIT_READ,
        0,
        bfgs_Remaining_Capacity_UnfilteredVal
      },
      // Remaining_Capacity_Unfiltered CCCD
      {
        { ATT_BT_UUID_SIZE, clientCharCfgUUID },
        GATT_PERMIT_READ | GATT_PERMIT_WRITE,
        0,
        (uint8_t *)&bfgs_Remaining_Capacity_UnfilteredConfig
      },
    // Average_Power Characteristic Declaration
    {
      { ATT_BT_UUID_SIZE, characterUUID },
      GATT_PERMIT_READ,
      0,
      &bfgs_Average_PowerProps
    },
      // Average_Power Characteristic Value
      {
        { ATT_UUID_SIZE, bfgs_Average_PowerUUID },
        GATT_PERMIT_READ | GATT_PERMIT_READ,
        0,
        bfgs_Average_PowerVal
      },
      // Average_Power CCCD
      {
        { ATT_BT_UUID_SIZE, clientCharCfgUUID },
        GATT_PERMIT_READ | GATT_PERMIT_WRITE,
        0,
        (uint8_t *)&bfgs_Average_PowerConfig
      },
    // Full_Charge_Capacity Characteristic Declaration
    {
      { ATT_BT_UUID_SIZE, characterUUID },
      GATT_PERMIT_READ,
      0,
      &bfgs_Full_Charge_CapacityProps
    },
      // Full_Charge_Capacity Characteristic Value
      {
        { ATT_UUID_SIZE, bfgs_Full_Charge_CapacityUUID },
        GATT_PERMIT_READ | GATT_PERMIT_READ,
        0,
        bfgs_Full_Charge_CapacityVal
      },
      // Full_Charge_Capacity CCCD
      {
        { ATT_BT_UUID_SIZE, clientCharCfgUUID },
        GATT_PERMIT_READ | GATT_PERMIT_WRITE,
        0,
        (uint8_t *)&bfgs_Full_Charge_CapacityConfig
      },
    // State_of_Health Characteristic Declaration
    {
      { ATT_BT_UUID_SIZE, characterUUID },
      GATT_PERMIT_READ,
      0,
      &bfgs_State_of_HealthProps
    },
      // State_of_Health Characteristic Value
      {
        { ATT_UUID_SIZE, bfgs_State_of_HealthUUID },
        GATT_PERMIT_READ | GATT_PERMIT_READ,
        0,
        bfgs_State_of_HealthVal
      },
      // State_of_Health CCCD
      {
        { ATT_BT_UUID_SIZE, clientCharCfgUUID },
        GATT_PERMIT_READ | GATT_PERMIT_WRITE,
        0,
        (uint8_t *)&bfgs_State_of_HealthConfig
      },
    // Internal_Temperature Characteristic Declaration
    {
      { ATT_BT_UUID_SIZE, characterUUID },
      GATT_PERMIT_READ,
      0,
      &bfgs_Internal_TemperatureProps
    },
      // Internal_Temperature Characteristic Value
      {
        { ATT_UUID_SIZE, bfgs_Internal_TemperatureUUID },
        GATT_PERMIT_READ | GATT_PERMIT_READ,
        0,
        bfgs_Internal_TemperatureVal
      },
      // Internal_Temperature CCCD
      {
        { ATT_BT_UUID_SIZE, clientCharCfgUUID },
        GATT_PERMIT_READ | GATT_PERMIT_WRITE,
        0,
        (uint8_t *)&bfgs_Internal_TemperatureConfig
      },
    // State_of_Charge Characteristic Declaration
    {
      { ATT_BT_UUID_SIZE, characterUUID },
      GATT_PERMIT_READ,
      0,
      &bfgs_State_of_ChargeProps
    },
      // State_of_Charge Characteristic Value
      {
        { ATT_UUID_SIZE, bfgs_State_of_ChargeUUID },
        GATT_PERMIT_READ | GATT_PERMIT_READ,
        0,
        bfgs_State_of_ChargeVal
      },
      // State_of_Charge CCCD
      {
        { ATT_BT_UUID_SIZE, clientCharCfgUUID },
        GATT_PERMIT_READ | GATT_PERMIT_WRITE,
        0,
        (uint8_t *)&bfgs_State_of_ChargeConfig
      },
    // Full_Charge_Capacity_Filtered Characteristic Declaration
    {
      { ATT_BT_UUID_SIZE, characterUUID },
      GATT_PERMIT_READ,
      0,
      &bfgs_Full_Charge_Capacity_FilteredProps
    },
      // Full_Charge_Capacity_Filtered Characteristic Value
      {
        { ATT_UUID_SIZE, bfgs_Full_Charge_Capacity_FilteredUUID },
        GATT_PERMIT_READ | GATT_PERMIT_READ,
        0,
        bfgs_Full_Charge_Capacity_FilteredVal
      },
      // Full_Charge_Capacity_Filtered CCCD
      {
        { ATT_BT_UUID_SIZE, clientCharCfgUUID },
        GATT_PERMIT_READ | GATT_PERMIT_WRITE,
        0,
        (uint8_t *)&bfgs_Full_Charge_Capacity_FilteredConfig
      },
    // Remaining_Capacity_Filtered Characteristic Declaration
    {
      { ATT_BT_UUID_SIZE, characterUUID },
      GATT_PERMIT_READ,
      0,
      &bfgs_Remaining_Capacity_FilteredProps
    },
      // Remaining_Capacity_Filtered Characteristic Value
      {
        { ATT_UUID_SIZE, bfgs_Remaining_Capacity_FilteredUUID },
        GATT_PERMIT_READ | GATT_PERMIT_READ,
        0,
        bfgs_Remaining_Capacity_FilteredVal
      },
      // Remaining_Capacity_Filtered CCCD
      {
        { ATT_BT_UUID_SIZE, clientCharCfgUUID },
        GATT_PERMIT_READ | GATT_PERMIT_WRITE,
        0,
        (uint8_t *)&bfgs_Remaining_Capacity_FilteredConfig
      },
    // Average_Current Characteristic Declaration
    {
      { ATT_BT_UUID_SIZE, characterUUID },
      GATT_PERMIT_READ,
      0,
      &bfgs_Average_CurrentProps
    },
      // Average_Current Characteristic Value
      {
        { ATT_UUID_SIZE, bfgs_Average_CurrentUUID },
        GATT_PERMIT_READ | GATT_PERMIT_READ,
        0,
        bfgs_Average_CurrentVal
      },
      // Average_Current CCCD
      {
        { ATT_BT_UUID_SIZE, clientCharCfgUUID },
        GATT_PERMIT_READ | GATT_PERMIT_WRITE,
        0,
        (uint8_t *)&bfgs_Average_CurrentConfig
      },
    // Remaining_Capacity Characteristic Declaration
    {
      { ATT_BT_UUID_SIZE, characterUUID },
      GATT_PERMIT_READ,
      0,
      &bfgs_Remaining_CapacityProps
    },
      // Remaining_Capacity Characteristic Value
      {
        { ATT_UUID_SIZE, bfgs_Remaining_CapacityUUID },
        GATT_PERMIT_READ | GATT_PERMIT_READ,
        0,
        bfgs_Remaining_CapacityVal
      },
      // Remaining_Capacity CCCD
      {
        { ATT_BT_UUID_SIZE, clientCharCfgUUID },
        GATT_PERMIT_READ | GATT_PERMIT_WRITE,
        0,
        (uint8_t *)&bfgs_Remaining_CapacityConfig
      },
    // Full_Available_Capacity Characteristic Declaration
    {
      { ATT_BT_UUID_SIZE, characterUUID },
      GATT_PERMIT_READ,
      0,
      &bfgs_Full_Available_CapacityProps
    },
      // Full_Available_Capacity Characteristic Value
      {
        { ATT_UUID_SIZE, bfgs_Full_Available_CapacityUUID },
        GATT_PERMIT_READ | GATT_PERMIT_READ,
        0,
        bfgs_Full_Available_CapacityVal
      },
      // Full_Available_Capacity CCCD
      {
        { ATT_BT_UUID_SIZE, clientCharCfgUUID },
        GATT_PERMIT_READ | GATT_PERMIT_WRITE,
        0,
        (uint8_t *)&bfgs_Full_Available_CapacityConfig
      },
    // Voltage Characteristic Declaration
    {
      { ATT_BT_UUID_SIZE, characterUUID },
      GATT_PERMIT_READ,
      0,
      &bfgs_VoltageProps
    },
      // Voltage Characteristic Value
      {
        { ATT_UUID_SIZE, bfgs_VoltageUUID },
        GATT_PERMIT_READ | GATT_PERMIT_READ,
        0,
        bfgs_VoltageVal
      },
      // Voltage CCCD
      {
        { ATT_BT_UUID_SIZE, clientCharCfgUUID },
        GATT_PERMIT_READ | GATT_PERMIT_WRITE,
        0,
        (uint8_t *)&bfgs_VoltageConfig
      },
    // Temperature Characteristic Declaration
    {
      { ATT_BT_UUID_SIZE, characterUUID },
      GATT_PERMIT_READ,
      0,
      &bfgs_TemperatureProps
    },
      // Temperature Characteristic Value
      {
        { ATT_UUID_SIZE, bfgs_TemperatureUUID },
        GATT_PERMIT_READ | GATT_PERMIT_READ,
        0,
        bfgs_TemperatureVal
      },
      // Temperature CCCD
      {
        { ATT_BT_UUID_SIZE, clientCharCfgUUID },
        GATT_PERMIT_READ | GATT_PERMIT_WRITE,
        0,
        (uint8_t *)&bfgs_TemperatureConfig
      },
    // Nominal_Available_Capacity Characteristic Declaration
    {
      { ATT_BT_UUID_SIZE, characterUUID },
      GATT_PERMIT_READ,
      0,
      &bfgs_Nominal_Available_CapacityProps
    },
      // Nominal_Available_Capacity Characteristic Value
      {
        { ATT_UUID_SIZE, bfgs_Nominal_Available_CapacityUUID },
        GATT_PERMIT_READ | GATT_PERMIT_READ,
        0,
        bfgs_Nominal_Available_CapacityVal
      },
      // Nominal_Available_Capacity CCCD
      {
        { ATT_BT_UUID_SIZE, clientCharCfgUUID },
        GATT_PERMIT_READ | GATT_PERMIT_WRITE,
        0,
        (uint8_t *)&bfgs_Nominal_Available_CapacityConfig
      },
    // Full_Charge_Capacity_Unfiltered Characteristic Declaration
    {
      { ATT_BT_UUID_SIZE, characterUUID },
      GATT_PERMIT_READ,
      0,
      &bfgs_Full_Charge_Capacity_UnfilteredProps
    },
      // Full_Charge_Capacity_Unfiltered Characteristic Value
      {
        { ATT_UUID_SIZE, bfgs_Full_Charge_Capacity_UnfilteredUUID },
        GATT_PERMIT_READ | GATT_PERMIT_READ,
        0,
        bfgs_Full_Charge_Capacity_UnfilteredVal
      },
      // Full_Charge_Capacity_Unfiltered CCCD
      {
        { ATT_BT_UUID_SIZE, clientCharCfgUUID },
        GATT_PERMIT_READ | GATT_PERMIT_WRITE,
        0,
        (uint8_t *)&bfgs_Full_Charge_Capacity_UnfilteredConfig
      },
    // State_of_Charge_Unfiltered Characteristic Declaration
    {
      { ATT_BT_UUID_SIZE, characterUUID },
      GATT_PERMIT_READ,
      0,
      &bfgs_State_of_Charge_UnfilteredProps
    },
      // State_of_Charge_Unfiltered Characteristic Value
      {
        { ATT_UUID_SIZE, bfgs_State_of_Charge_UnfilteredUUID },
        GATT_PERMIT_READ | GATT_PERMIT_READ,
        0,
        bfgs_State_of_Charge_UnfilteredVal
      },
      // State_of_Charge_Unfiltered CCCD
      {
        { ATT_BT_UUID_SIZE, clientCharCfgUUID },
        GATT_PERMIT_READ | GATT_PERMIT_WRITE,
        0,
        (uint8_t *)&bfgs_State_of_Charge_UnfilteredConfig
      },
    // Flags Characteristic Declaration
    {
      { ATT_BT_UUID_SIZE, characterUUID },
      GATT_PERMIT_READ,
      0,
      &bfgs_FlagsProps
    },
      // Flags Characteristic Value
      {
        { ATT_UUID_SIZE, bfgs_FlagsUUID },
        GATT_PERMIT_READ | GATT_PERMIT_READ,
        0,
        bfgs_FlagsVal
      },
      // Flags CCCD
      {
        { ATT_BT_UUID_SIZE, clientCharCfgUUID },
        GATT_PERMIT_READ | GATT_PERMIT_WRITE,
        0,
        (uint8_t *)&bfgs_FlagsConfig
      },
    // Initialize_Fuel_Gauge Characteristic Declaration
    {
      { ATT_BT_UUID_SIZE, characterUUID },
      GATT_PERMIT_READ,
      0,
      &bfgs_Initialize_Fuel_GaugeProps
    },
      // Initialize_Fuel_Gauge Characteristic Value
      {
        { ATT_UUID_SIZE, bfgs_Initialize_Fuel_GaugeUUID },
        GATT_PERMIT_WRITE,
        0,
        bfgs_Initialize_Fuel_GaugeVal
      },
    // Reserved_1 Characteristic Declaration
    {
      { ATT_BT_UUID_SIZE, characterUUID },
      GATT_PERMIT_READ,
      0,
      &bfgs_Reserved_1Props
    },
      // Reserved_1 Characteristic Value
      {
        { ATT_UUID_SIZE, bfgs_Reserved_1UUID },
        GATT_PERMIT_READ | GATT_PERMIT_READ | GATT_PERMIT_WRITE,
        0,
        bfgs_Reserved_1Val
      },
      // Reserved_1 CCCD
      {
        { ATT_BT_UUID_SIZE, clientCharCfgUUID },
        GATT_PERMIT_READ | GATT_PERMIT_WRITE,
        0,
        (uint8_t *)&bfgs_Reserved_1Config
      },
};

/*********************************************************************
 * LOCAL FUNCTIONS
 */
static bStatus_t BQ27426_Fuel_Gauge_Service_ReadAttrCB( uint16_t connHandle, gattAttribute_t *pAttr, 
                                           uint8_t *pValue, uint16_t *pLen, uint16_t offset,
                                           uint16_t maxLen, uint8_t method );
static bStatus_t BQ27426_Fuel_Gauge_Service_WriteAttrCB( uint16_t connHandle, gattAttribute_t *pAttr,
                                            uint8_t *pValue, uint16_t len, uint16_t offset,
                                            uint8_t method );

/*********************************************************************
 * PROFILE CALLBACKS
 */
// Simple Profile Service Callbacks
CONST gattServiceCBs_t BQ27426_Fuel_Gauge_ServiceCBs =
{
  BQ27426_Fuel_Gauge_Service_ReadAttrCB,  // Read callback function pointer
  BQ27426_Fuel_Gauge_Service_WriteAttrCB, // Write callback function pointer
  NULL                       // Authorization callback function pointer
};

/*********************************************************************
* PUBLIC FUNCTIONS
*/

/*
 * Bq27426FuelGaugeService_AddService- Initializes the Bq27426FuelGaugeService service by registering
 *          GATT attributes with the GATT server.
 *
 */
bStatus_t Bq27426FuelGaugeService_AddService( void )
{
  uint8_t status;

  // Allocate Client Characteristic Configuration table
  bfgs_Remaining_Capacity_UnfilteredConfig = (gattCharCfg_t *)ICall_malloc( sizeof(gattCharCfg_t) * linkDBNumConns );
  if ( bfgs_Remaining_Capacity_UnfilteredConfig == NULL )
  {     
    return ( bleMemAllocError );
  }
  
  // Initialize Client Characteristic Configuration attributes
  GATTServApp_InitCharCfg( INVALID_CONNHANDLE, bfgs_Remaining_Capacity_UnfilteredConfig );
  // Allocate Client Characteristic Configuration table
  bfgs_Average_PowerConfig = (gattCharCfg_t *)ICall_malloc( sizeof(gattCharCfg_t) * linkDBNumConns );
  if ( bfgs_Average_PowerConfig == NULL )
  {     
    return ( bleMemAllocError );
  }
  
  // Initialize Client Characteristic Configuration attributes
  GATTServApp_InitCharCfg( INVALID_CONNHANDLE, bfgs_Average_PowerConfig );
  // Allocate Client Characteristic Configuration table
  bfgs_Full_Charge_CapacityConfig = (gattCharCfg_t *)ICall_malloc( sizeof(gattCharCfg_t) * linkDBNumConns );
  if ( bfgs_Full_Charge_CapacityConfig == NULL )
  {     
    return ( bleMemAllocError );
  }
  
  // Initialize Client Characteristic Configuration attributes
  GATTServApp_InitCharCfg( INVALID_CONNHANDLE, bfgs_Full_Charge_CapacityConfig );
  // Allocate Client Characteristic Configuration table
  bfgs_State_of_HealthConfig = (gattCharCfg_t *)ICall_malloc( sizeof(gattCharCfg_t) * linkDBNumConns );
  if ( bfgs_State_of_HealthConfig == NULL )
  {     
    return ( bleMemAllocError );
  }
  
  // Initialize Client Characteristic Configuration attributes
  GATTServApp_InitCharCfg( INVALID_CONNHANDLE, bfgs_State_of_HealthConfig );
  // Allocate Client Characteristic Configuration table
  bfgs_Internal_TemperatureConfig = (gattCharCfg_t *)ICall_malloc( sizeof(gattCharCfg_t) * linkDBNumConns );
  if ( bfgs_Internal_TemperatureConfig == NULL )
  {     
    return ( bleMemAllocError );
  }
  
  // Initialize Client Characteristic Configuration attributes
  GATTServApp_InitCharCfg( INVALID_CONNHANDLE, bfgs_Internal_TemperatureConfig );
  // Allocate Client Characteristic Configuration table
  bfgs_State_of_ChargeConfig = (gattCharCfg_t *)ICall_malloc( sizeof(gattCharCfg_t) * linkDBNumConns );
  if ( bfgs_State_of_ChargeConfig == NULL )
  {     
    return ( bleMemAllocError );
  }
  
  // Initialize Client Characteristic Configuration attributes
  GATTServApp_InitCharCfg( INVALID_CONNHANDLE, bfgs_State_of_ChargeConfig );
  // Allocate Client Characteristic Configuration table
  bfgs_Full_Charge_Capacity_FilteredConfig = (gattCharCfg_t *)ICall_malloc( sizeof(gattCharCfg_t) * linkDBNumConns );
  if ( bfgs_Full_Charge_Capacity_FilteredConfig == NULL )
  {     
    return ( bleMemAllocError );
  }
  
  // Initialize Client Characteristic Configuration attributes
  GATTServApp_InitCharCfg( INVALID_CONNHANDLE, bfgs_Full_Charge_Capacity_FilteredConfig );
  // Allocate Client Characteristic Configuration table
  bfgs_Remaining_Capacity_FilteredConfig = (gattCharCfg_t *)ICall_malloc( sizeof(gattCharCfg_t) * linkDBNumConns );
  if ( bfgs_Remaining_Capacity_FilteredConfig == NULL )
  {     
    return ( bleMemAllocError );
  }
  
  // Initialize Client Characteristic Configuration attributes
  GATTServApp_InitCharCfg( INVALID_CONNHANDLE, bfgs_Remaining_Capacity_FilteredConfig );
  // Allocate Client Characteristic Configuration table
  bfgs_Average_CurrentConfig = (gattCharCfg_t *)ICall_malloc( sizeof(gattCharCfg_t) * linkDBNumConns );
  if ( bfgs_Average_CurrentConfig == NULL )
  {     
    return ( bleMemAllocError );
  }
  
  // Initialize Client Characteristic Configuration attributes
  GATTServApp_InitCharCfg( INVALID_CONNHANDLE, bfgs_Average_CurrentConfig );
  // Allocate Client Characteristic Configuration table
  bfgs_Remaining_CapacityConfig = (gattCharCfg_t *)ICall_malloc( sizeof(gattCharCfg_t) * linkDBNumConns );
  if ( bfgs_Remaining_CapacityConfig == NULL )
  {     
    return ( bleMemAllocError );
  }
  
  // Initialize Client Characteristic Configuration attributes
  GATTServApp_InitCharCfg( INVALID_CONNHANDLE, bfgs_Remaining_CapacityConfig );
  // Allocate Client Characteristic Configuration table
  bfgs_Full_Available_CapacityConfig = (gattCharCfg_t *)ICall_malloc( sizeof(gattCharCfg_t) * linkDBNumConns );
  if ( bfgs_Full_Available_CapacityConfig == NULL )
  {     
    return ( bleMemAllocError );
  }
  
  // Initialize Client Characteristic Configuration attributes
  GATTServApp_InitCharCfg( INVALID_CONNHANDLE, bfgs_Full_Available_CapacityConfig );
  // Allocate Client Characteristic Configuration table
  bfgs_VoltageConfig = (gattCharCfg_t *)ICall_malloc( sizeof(gattCharCfg_t) * linkDBNumConns );
  if ( bfgs_VoltageConfig == NULL )
  {     
    return ( bleMemAllocError );
  }
  
  // Initialize Client Characteristic Configuration attributes
  GATTServApp_InitCharCfg( INVALID_CONNHANDLE, bfgs_VoltageConfig );
  // Allocate Client Characteristic Configuration table
  bfgs_TemperatureConfig = (gattCharCfg_t *)ICall_malloc( sizeof(gattCharCfg_t) * linkDBNumConns );
  if ( bfgs_TemperatureConfig == NULL )
  {     
    return ( bleMemAllocError );
  }
  
  // Initialize Client Characteristic Configuration attributes
  GATTServApp_InitCharCfg( INVALID_CONNHANDLE, bfgs_TemperatureConfig );
  // Allocate Client Characteristic Configuration table
  bfgs_Nominal_Available_CapacityConfig = (gattCharCfg_t *)ICall_malloc( sizeof(gattCharCfg_t) * linkDBNumConns );
  if ( bfgs_Nominal_Available_CapacityConfig == NULL )
  {     
    return ( bleMemAllocError );
  }
  
  // Initialize Client Characteristic Configuration attributes
  GATTServApp_InitCharCfg( INVALID_CONNHANDLE, bfgs_Nominal_Available_CapacityConfig );
  // Allocate Client Characteristic Configuration table
  bfgs_Full_Charge_Capacity_UnfilteredConfig = (gattCharCfg_t *)ICall_malloc( sizeof(gattCharCfg_t) * linkDBNumConns );
  if ( bfgs_Full_Charge_Capacity_UnfilteredConfig == NULL )
  {     
    return ( bleMemAllocError );
  }
  
  // Initialize Client Characteristic Configuration attributes
  GATTServApp_InitCharCfg( INVALID_CONNHANDLE, bfgs_Full_Charge_Capacity_UnfilteredConfig );
  // Allocate Client Characteristic Configuration table
  bfgs_State_of_Charge_UnfilteredConfig = (gattCharCfg_t *)ICall_malloc( sizeof(gattCharCfg_t) * linkDBNumConns );
  if ( bfgs_State_of_Charge_UnfilteredConfig == NULL )
  {     
    return ( bleMemAllocError );
  }
  
  // Initialize Client Characteristic Configuration attributes
  GATTServApp_InitCharCfg( INVALID_CONNHANDLE, bfgs_State_of_Charge_UnfilteredConfig );
  // Allocate Client Characteristic Configuration table
  bfgs_FlagsConfig = (gattCharCfg_t *)ICall_malloc( sizeof(gattCharCfg_t) * linkDBNumConns );
  if ( bfgs_FlagsConfig == NULL )
  {     
    return ( bleMemAllocError );
  }
  
  // Initialize Client Characteristic Configuration attributes
  GATTServApp_InitCharCfg( INVALID_CONNHANDLE, bfgs_FlagsConfig );
  // Allocate Client Characteristic Configuration table
  bfgs_Reserved_1Config = (gattCharCfg_t *)ICall_malloc( sizeof(gattCharCfg_t) * linkDBNumConns );
  if ( bfgs_Reserved_1Config == NULL )
  {     
    return ( bleMemAllocError );
  }
  
  // Initialize Client Characteristic Configuration attributes
  GATTServApp_InitCharCfg( INVALID_CONNHANDLE, bfgs_Reserved_1Config );
  // Register GATT attribute list and CBs with GATT Server App
  status = GATTServApp_RegisterService( BQ27426_Fuel_Gauge_ServiceAttrTbl, 
                                        GATT_NUM_ATTRS( BQ27426_Fuel_Gauge_ServiceAttrTbl ),
                                        GATT_MAX_ENCRYPT_KEY_SIZE,
                                        &BQ27426_Fuel_Gauge_ServiceCBs );

  return ( status );
}

/*
 * Bq27426FuelGaugeService_RegisterAppCBs - Registers the application callback function.
 *                    Only call this function once.
 *
 *    appCallbacks - pointer to application callbacks.
 */
bStatus_t Bq27426FuelGaugeService_RegisterAppCBs( Bq27426FuelGaugeServiceCBs_t *appCallbacks )
{
  if ( appCallbacks )
  {
    pAppCBs = appCallbacks;
    
    return ( SUCCESS );
  }
  else
  {
    return ( bleAlreadyInRequestedMode );
  }
}

/*
 * Bq27426FuelGaugeService_SetParameter - Set a Bq27426FuelGaugeService parameter.
 *
 *    param - Profile parameter ID
 *    len   - length of data to write
 *    value - pointer to data to write.  This is dependent on
 *            the parameter ID and may be cast to the appropriate 
 *            data type (example: data type of uint16_t will be cast to 
 *            uint16_t pointer).
 */
bStatus_t Bq27426FuelGaugeService_SetParameter( uint8_t param, uint16_t len, void *value )
{
  bStatus_t ret = SUCCESS;
  switch ( param )
  {
    case BFGS_REMAINING_CAPACITY_UNFILTERED_ID:
      if ( len <= BFGS_REMAINING_CAPACITY_UNFILTERED_LEN &&
           len >= BFGS_REMAINING_CAPACITY_UNFILTERED_LEN_MIN ) 
      {
        memcpy(bfgs_Remaining_Capacity_UnfilteredVal, value, len);
        bfgs_Remaining_Capacity_UnfilteredValLen = len; // Update length for read and get.

        // Try to send notification.
        GATTServApp_ProcessCharCfg( bfgs_Remaining_Capacity_UnfilteredConfig, (uint8_t *)&bfgs_Remaining_Capacity_UnfilteredVal, FALSE,
                                    BQ27426_Fuel_Gauge_ServiceAttrTbl, GATT_NUM_ATTRS( BQ27426_Fuel_Gauge_ServiceAttrTbl ),
                                    INVALID_TASK_ID,  BQ27426_Fuel_Gauge_Service_ReadAttrCB);
      }
      else
      {
        ret = bleInvalidRange;
      }
      break;

    case BFGS_AVERAGE_POWER_ID:
      if ( len <= BFGS_AVERAGE_POWER_LEN &&
           len >= BFGS_AVERAGE_POWER_LEN_MIN ) 
      {
        memcpy(bfgs_Average_PowerVal, value, len);
        bfgs_Average_PowerValLen = len; // Update length for read and get.

        // Try to send notification.
        GATTServApp_ProcessCharCfg( bfgs_Average_PowerConfig, (uint8_t *)&bfgs_Average_PowerVal, FALSE,
                                    BQ27426_Fuel_Gauge_ServiceAttrTbl, GATT_NUM_ATTRS( BQ27426_Fuel_Gauge_ServiceAttrTbl ),
                                    INVALID_TASK_ID,  BQ27426_Fuel_Gauge_Service_ReadAttrCB);
      }
      else
      {
        ret = bleInvalidRange;
      }
      break;

    case BFGS_FULL_CHARGE_CAPACITY_ID:
      if ( len <= BFGS_FULL_CHARGE_CAPACITY_LEN &&
           len >= BFGS_FULL_CHARGE_CAPACITY_LEN_MIN ) 
      {
        memcpy(bfgs_Full_Charge_CapacityVal, value, len);
        bfgs_Full_Charge_CapacityValLen = len; // Update length for read and get.

        // Try to send notification.
        GATTServApp_ProcessCharCfg( bfgs_Full_Charge_CapacityConfig, (uint8_t *)&bfgs_Full_Charge_CapacityVal, FALSE,
                                    BQ27426_Fuel_Gauge_ServiceAttrTbl, GATT_NUM_ATTRS( BQ27426_Fuel_Gauge_ServiceAttrTbl ),
                                    INVALID_TASK_ID,  BQ27426_Fuel_Gauge_Service_ReadAttrCB);
      }
      else
      {
        ret = bleInvalidRange;
      }
      break;

    case BFGS_STATE_OF_HEALTH_ID:
      if ( len <= BFGS_STATE_OF_HEALTH_LEN &&
           len >= BFGS_STATE_OF_HEALTH_LEN_MIN ) 
      {
        memcpy(bfgs_State_of_HealthVal, value, len);
        bfgs_State_of_HealthValLen = len; // Update length for read and get.

        // Try to send notification.
        GATTServApp_ProcessCharCfg( bfgs_State_of_HealthConfig, (uint8_t *)&bfgs_State_of_HealthVal, FALSE,
                                    BQ27426_Fuel_Gauge_ServiceAttrTbl, GATT_NUM_ATTRS( BQ27426_Fuel_Gauge_ServiceAttrTbl ),
                                    INVALID_TASK_ID,  BQ27426_Fuel_Gauge_Service_ReadAttrCB);
      }
      else
      {
        ret = bleInvalidRange;
      }
      break;

    case BFGS_INTERNAL_TEMPERATURE_ID:
      if ( len <= BFGS_INTERNAL_TEMPERATURE_LEN &&
           len >= BFGS_INTERNAL_TEMPERATURE_LEN_MIN ) 
      {
        memcpy(bfgs_Internal_TemperatureVal, value, len);
        bfgs_Internal_TemperatureValLen = len; // Update length for read and get.

        // Try to send notification.
        GATTServApp_ProcessCharCfg( bfgs_Internal_TemperatureConfig, (uint8_t *)&bfgs_Internal_TemperatureVal, FALSE,
                                    BQ27426_Fuel_Gauge_ServiceAttrTbl, GATT_NUM_ATTRS( BQ27426_Fuel_Gauge_ServiceAttrTbl ),
                                    INVALID_TASK_ID,  BQ27426_Fuel_Gauge_Service_ReadAttrCB);
      }
      else
      {
        ret = bleInvalidRange;
      }
      break;

    case BFGS_STATE_OF_CHARGE_ID:
      if ( len <= BFGS_STATE_OF_CHARGE_LEN &&
           len >= BFGS_STATE_OF_CHARGE_LEN_MIN ) 
      {
        memcpy(bfgs_State_of_ChargeVal, value, len);
        bfgs_State_of_ChargeValLen = len; // Update length for read and get.

        // Try to send notification.
        GATTServApp_ProcessCharCfg( bfgs_State_of_ChargeConfig, (uint8_t *)&bfgs_State_of_ChargeVal, FALSE,
                                    BQ27426_Fuel_Gauge_ServiceAttrTbl, GATT_NUM_ATTRS( BQ27426_Fuel_Gauge_ServiceAttrTbl ),
                                    INVALID_TASK_ID,  BQ27426_Fuel_Gauge_Service_ReadAttrCB);
      }
      else
      {
        ret = bleInvalidRange;
      }
      break;

    case BFGS_FULL_CHARGE_CAPACITY_FILTERED_ID:
      if ( len <= BFGS_FULL_CHARGE_CAPACITY_FILTERED_LEN &&
           len >= BFGS_FULL_CHARGE_CAPACITY_FILTERED_LEN_MIN ) 
      {
        memcpy(bfgs_Full_Charge_Capacity_FilteredVal, value, len);
        bfgs_Full_Charge_Capacity_FilteredValLen = len; // Update length for read and get.

        // Try to send notification.
        GATTServApp_ProcessCharCfg( bfgs_Full_Charge_Capacity_FilteredConfig, (uint8_t *)&bfgs_Full_Charge_Capacity_FilteredVal, FALSE,
                                    BQ27426_Fuel_Gauge_ServiceAttrTbl, GATT_NUM_ATTRS( BQ27426_Fuel_Gauge_ServiceAttrTbl ),
                                    INVALID_TASK_ID,  BQ27426_Fuel_Gauge_Service_ReadAttrCB);
      }
      else
      {
        ret = bleInvalidRange;
      }
      break;

    case BFGS_REMAINING_CAPACITY_FILTERED_ID:
      if ( len <= BFGS_REMAINING_CAPACITY_FILTERED_LEN &&
           len >= BFGS_REMAINING_CAPACITY_FILTERED_LEN_MIN ) 
      {
        memcpy(bfgs_Remaining_Capacity_FilteredVal, value, len);
        bfgs_Remaining_Capacity_FilteredValLen = len; // Update length for read and get.

        // Try to send notification.
        GATTServApp_ProcessCharCfg( bfgs_Remaining_Capacity_FilteredConfig, (uint8_t *)&bfgs_Remaining_Capacity_FilteredVal, FALSE,
                                    BQ27426_Fuel_Gauge_ServiceAttrTbl, GATT_NUM_ATTRS( BQ27426_Fuel_Gauge_ServiceAttrTbl ),
                                    INVALID_TASK_ID,  BQ27426_Fuel_Gauge_Service_ReadAttrCB);
      }
      else
      {
        ret = bleInvalidRange;
      }
      break;

    case BFGS_AVERAGE_CURRENT_ID:
      if ( len <= BFGS_AVERAGE_CURRENT_LEN &&
           len >= BFGS_AVERAGE_CURRENT_LEN_MIN ) 
      {
        memcpy(bfgs_Average_CurrentVal, value, len);
        bfgs_Average_CurrentValLen = len; // Update length for read and get.

        // Try to send notification.
        GATTServApp_ProcessCharCfg( bfgs_Average_CurrentConfig, (uint8_t *)&bfgs_Average_CurrentVal, FALSE,
                                    BQ27426_Fuel_Gauge_ServiceAttrTbl, GATT_NUM_ATTRS( BQ27426_Fuel_Gauge_ServiceAttrTbl ),
                                    INVALID_TASK_ID,  BQ27426_Fuel_Gauge_Service_ReadAttrCB);
      }
      else
      {
        ret = bleInvalidRange;
      }
      break;

    case BFGS_REMAINING_CAPACITY_ID:
      if ( len <= BFGS_REMAINING_CAPACITY_LEN &&
           len >= BFGS_REMAINING_CAPACITY_LEN_MIN ) 
      {
        memcpy(bfgs_Remaining_CapacityVal, value, len);
        bfgs_Remaining_CapacityValLen = len; // Update length for read and get.

        // Try to send notification.
        GATTServApp_ProcessCharCfg( bfgs_Remaining_CapacityConfig, (uint8_t *)&bfgs_Remaining_CapacityVal, FALSE,
                                    BQ27426_Fuel_Gauge_ServiceAttrTbl, GATT_NUM_ATTRS( BQ27426_Fuel_Gauge_ServiceAttrTbl ),
                                    INVALID_TASK_ID,  BQ27426_Fuel_Gauge_Service_ReadAttrCB);
      }
      else
      {
        ret = bleInvalidRange;
      }
      break;

    case BFGS_FULL_AVAILABLE_CAPACITY_ID:
      if ( len <= BFGS_FULL_AVAILABLE_CAPACITY_LEN &&
           len >= BFGS_FULL_AVAILABLE_CAPACITY_LEN_MIN ) 
      {
        memcpy(bfgs_Full_Available_CapacityVal, value, len);
        bfgs_Full_Available_CapacityValLen = len; // Update length for read and get.

        // Try to send notification.
        GATTServApp_ProcessCharCfg( bfgs_Full_Available_CapacityConfig, (uint8_t *)&bfgs_Full_Available_CapacityVal, FALSE,
                                    BQ27426_Fuel_Gauge_ServiceAttrTbl, GATT_NUM_ATTRS( BQ27426_Fuel_Gauge_ServiceAttrTbl ),
                                    INVALID_TASK_ID,  BQ27426_Fuel_Gauge_Service_ReadAttrCB);
      }
      else
      {
        ret = bleInvalidRange;
      }
      break;

    case BFGS_VOLTAGE_ID:
      if ( len <= BFGS_VOLTAGE_LEN &&
           len >= BFGS_VOLTAGE_LEN_MIN ) 
      {
        memcpy(bfgs_VoltageVal, value, len);
        bfgs_VoltageValLen = len; // Update length for read and get.

        // Try to send notification.
        GATTServApp_ProcessCharCfg( bfgs_VoltageConfig, (uint8_t *)&bfgs_VoltageVal, FALSE,
                                    BQ27426_Fuel_Gauge_ServiceAttrTbl, GATT_NUM_ATTRS( BQ27426_Fuel_Gauge_ServiceAttrTbl ),
                                    INVALID_TASK_ID,  BQ27426_Fuel_Gauge_Service_ReadAttrCB);
      }
      else
      {
        ret = bleInvalidRange;
      }
      break;

    case BFGS_TEMPERATURE_ID:
      if ( len <= BFGS_TEMPERATURE_LEN &&
           len >= BFGS_TEMPERATURE_LEN_MIN ) 
      {
        memcpy(bfgs_TemperatureVal, value, len);
        bfgs_TemperatureValLen = len; // Update length for read and get.

        // Try to send notification.
        GATTServApp_ProcessCharCfg( bfgs_TemperatureConfig, (uint8_t *)&bfgs_TemperatureVal, FALSE,
                                    BQ27426_Fuel_Gauge_ServiceAttrTbl, GATT_NUM_ATTRS( BQ27426_Fuel_Gauge_ServiceAttrTbl ),
                                    INVALID_TASK_ID,  BQ27426_Fuel_Gauge_Service_ReadAttrCB);
      }
      else
      {
        ret = bleInvalidRange;
      }
      break;

    case BFGS_NOMINAL_AVAILABLE_CAPACITY_ID:
      if ( len <= BFGS_NOMINAL_AVAILABLE_CAPACITY_LEN &&
           len >= BFGS_NOMINAL_AVAILABLE_CAPACITY_LEN_MIN ) 
      {
        memcpy(bfgs_Nominal_Available_CapacityVal, value, len);
        bfgs_Nominal_Available_CapacityValLen = len; // Update length for read and get.

        // Try to send notification.
        GATTServApp_ProcessCharCfg( bfgs_Nominal_Available_CapacityConfig, (uint8_t *)&bfgs_Nominal_Available_CapacityVal, FALSE,
                                    BQ27426_Fuel_Gauge_ServiceAttrTbl, GATT_NUM_ATTRS( BQ27426_Fuel_Gauge_ServiceAttrTbl ),
                                    INVALID_TASK_ID,  BQ27426_Fuel_Gauge_Service_ReadAttrCB);
      }
      else
      {
        ret = bleInvalidRange;
      }
      break;

    case BFGS_FULL_CHARGE_CAPACITY_UNFILTERED_ID:
      if ( len <= BFGS_FULL_CHARGE_CAPACITY_UNFILTERED_LEN &&
           len >= BFGS_FULL_CHARGE_CAPACITY_UNFILTERED_LEN_MIN ) 
      {
        memcpy(bfgs_Full_Charge_Capacity_UnfilteredVal, value, len);
        bfgs_Full_Charge_Capacity_UnfilteredValLen = len; // Update length for read and get.

        // Try to send notification.
        GATTServApp_ProcessCharCfg( bfgs_Full_Charge_Capacity_UnfilteredConfig, (uint8_t *)&bfgs_Full_Charge_Capacity_UnfilteredVal, FALSE,
                                    BQ27426_Fuel_Gauge_ServiceAttrTbl, GATT_NUM_ATTRS( BQ27426_Fuel_Gauge_ServiceAttrTbl ),
                                    INVALID_TASK_ID,  BQ27426_Fuel_Gauge_Service_ReadAttrCB);
      }
      else
      {
        ret = bleInvalidRange;
      }
      break;

    case BFGS_STATE_OF_CHARGE_UNFILTERED_ID:
      if ( len <= BFGS_STATE_OF_CHARGE_UNFILTERED_LEN &&
           len >= BFGS_STATE_OF_CHARGE_UNFILTERED_LEN_MIN ) 
      {
        memcpy(bfgs_State_of_Charge_UnfilteredVal, value, len);
        bfgs_State_of_Charge_UnfilteredValLen = len; // Update length for read and get.

        // Try to send notification.
        GATTServApp_ProcessCharCfg( bfgs_State_of_Charge_UnfilteredConfig, (uint8_t *)&bfgs_State_of_Charge_UnfilteredVal, FALSE,
                                    BQ27426_Fuel_Gauge_ServiceAttrTbl, GATT_NUM_ATTRS( BQ27426_Fuel_Gauge_ServiceAttrTbl ),
                                    INVALID_TASK_ID,  BQ27426_Fuel_Gauge_Service_ReadAttrCB);
      }
      else
      {
        ret = bleInvalidRange;
      }
      break;

    case BFGS_FLAGS_ID:
      if ( len <= BFGS_FLAGS_LEN &&
           len >= BFGS_FLAGS_LEN_MIN ) 
      {
        memcpy(bfgs_FlagsVal, value, len);
        bfgs_FlagsValLen = len; // Update length for read and get.

        // Try to send notification.
        GATTServApp_ProcessCharCfg( bfgs_FlagsConfig, (uint8_t *)&bfgs_FlagsVal, FALSE,
                                    BQ27426_Fuel_Gauge_ServiceAttrTbl, GATT_NUM_ATTRS( BQ27426_Fuel_Gauge_ServiceAttrTbl ),
                                    INVALID_TASK_ID,  BQ27426_Fuel_Gauge_Service_ReadAttrCB);
      }
      else
      {
        ret = bleInvalidRange;
      }
      break;

    case BFGS_RESERVED_1_ID:
      if ( len <= BFGS_RESERVED_1_LEN &&
           len >= BFGS_RESERVED_1_LEN_MIN ) 
      {
        memcpy(bfgs_Reserved_1Val, value, len);
        bfgs_Reserved_1ValLen = len; // Update length for read and get.

        // Try to send notification.
        GATTServApp_ProcessCharCfg( bfgs_Reserved_1Config, (uint8_t *)&bfgs_Reserved_1Val, FALSE,
                                    BQ27426_Fuel_Gauge_ServiceAttrTbl, GATT_NUM_ATTRS( BQ27426_Fuel_Gauge_ServiceAttrTbl ),
                                    INVALID_TASK_ID,  BQ27426_Fuel_Gauge_Service_ReadAttrCB);
      }
      else
      {
        ret = bleInvalidRange;
      }
      break;

    default:
      ret = INVALIDPARAMETER;
      break;
  }
  return ret;
}


/*
 * Bq27426FuelGaugeService_GetParameter - Get a Bq27426FuelGaugeService parameter.
 *
 *    param - Profile parameter ID
 *    len   - pointer to a variable that contains the maximum length that can be written to *value.
              After the call, this value will contain the actual returned length.
 *    value - pointer to data to write.  This is dependent on
 *            the parameter ID and may be cast to the appropriate 
 *            data type (example: data type of uint16_t will be cast to 
 *            uint16_t pointer).
 */
bStatus_t Bq27426FuelGaugeService_GetParameter( uint8_t param, uint16_t *len, void *value )
{
  bStatus_t ret = SUCCESS;
  switch ( param )
  {
    case BFGS_INITIALIZE_FUEL_GAUGE_ID:
      *len = MIN(*len, bfgs_Initialize_Fuel_GaugeValLen);
      memcpy(value, bfgs_Initialize_Fuel_GaugeVal, *len);
      break;

    case BFGS_RESERVED_1_ID:
      *len = MIN(*len, bfgs_Reserved_1ValLen);
      memcpy(value, bfgs_Reserved_1Val, *len);
      break;

    default:
      ret = INVALIDPARAMETER;
      break;
  }
  return ret;
}


/*********************************************************************
 * @fn          BQ27426_Fuel_Gauge_Service_ReadAttrCB
 *
 * @brief       Read an attribute.
 *
 * @param       connHandle - connection message was received on
 * @param       pAttr - pointer to attribute
 * @param       pValue - pointer to data to be read
 * @param       pLen - length of data to be read
 * @param       offset - offset of the first octet to be read
 * @param       maxLen - maximum length of data to be read
 * @param       method - type of read message
 *
 * @return      SUCCESS, blePending or Failure
 */
static bStatus_t BQ27426_Fuel_Gauge_Service_ReadAttrCB( uint16_t connHandle, gattAttribute_t *pAttr, 
                                       uint8_t *pValue, uint16_t *pLen, uint16_t offset,
                                       uint16_t maxLen, uint8_t method )
{
  bStatus_t status = SUCCESS;

  // See if request is regarding the Remaining_Capacity_Unfiltered Characteristic Value
if ( ! memcmp(pAttr->type.uuid, bfgs_Remaining_Capacity_UnfilteredUUID, pAttr->type.len) )
  {
    if ( offset > bfgs_Remaining_Capacity_UnfilteredValLen )  // Prevent malicious ATT ReadBlob offsets.
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else
    {
      *pLen = MIN(maxLen, bfgs_Remaining_Capacity_UnfilteredValLen - offset);  // Transmit as much as possible
      memcpy(pValue, pAttr->pValue + offset, *pLen);
    }
  }
  // See if request is regarding the Average_Power Characteristic Value
else if ( ! memcmp(pAttr->type.uuid, bfgs_Average_PowerUUID, pAttr->type.len) )
  {
    if ( offset > bfgs_Average_PowerValLen )  // Prevent malicious ATT ReadBlob offsets.
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else
    {
      *pLen = MIN(maxLen, bfgs_Average_PowerValLen - offset);  // Transmit as much as possible
      memcpy(pValue, pAttr->pValue + offset, *pLen);
    }
  }
  // See if request is regarding the Full_Charge_Capacity Characteristic Value
else if ( ! memcmp(pAttr->type.uuid, bfgs_Full_Charge_CapacityUUID, pAttr->type.len) )
  {
    if ( offset > bfgs_Full_Charge_CapacityValLen )  // Prevent malicious ATT ReadBlob offsets.
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else
    {
      *pLen = MIN(maxLen, bfgs_Full_Charge_CapacityValLen - offset);  // Transmit as much as possible
      memcpy(pValue, pAttr->pValue + offset, *pLen);
    }
  }
  // See if request is regarding the State_of_Health Characteristic Value
else if ( ! memcmp(pAttr->type.uuid, bfgs_State_of_HealthUUID, pAttr->type.len) )
  {
    if ( offset > bfgs_State_of_HealthValLen )  // Prevent malicious ATT ReadBlob offsets.
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else
    {
      *pLen = MIN(maxLen, bfgs_State_of_HealthValLen - offset);  // Transmit as much as possible
      memcpy(pValue, pAttr->pValue + offset, *pLen);
    }
  }
  // See if request is regarding the Internal_Temperature Characteristic Value
else if ( ! memcmp(pAttr->type.uuid, bfgs_Internal_TemperatureUUID, pAttr->type.len) )
  {
    if ( offset > bfgs_Internal_TemperatureValLen )  // Prevent malicious ATT ReadBlob offsets.
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else
    {
      *pLen = MIN(maxLen, bfgs_Internal_TemperatureValLen - offset);  // Transmit as much as possible
      memcpy(pValue, pAttr->pValue + offset, *pLen);
    }
  }
  // See if request is regarding the State_of_Charge Characteristic Value
else if ( ! memcmp(pAttr->type.uuid, bfgs_State_of_ChargeUUID, pAttr->type.len) )
  {
    if ( offset > bfgs_State_of_ChargeValLen )  // Prevent malicious ATT ReadBlob offsets.
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else
    {
      *pLen = MIN(maxLen, bfgs_State_of_ChargeValLen - offset);  // Transmit as much as possible
      memcpy(pValue, pAttr->pValue + offset, *pLen);
    }
  }
  // See if request is regarding the Full_Charge_Capacity_Filtered Characteristic Value
else if ( ! memcmp(pAttr->type.uuid, bfgs_Full_Charge_Capacity_FilteredUUID, pAttr->type.len) )
  {
    if ( offset > bfgs_Full_Charge_Capacity_FilteredValLen )  // Prevent malicious ATT ReadBlob offsets.
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else
    {
      *pLen = MIN(maxLen, bfgs_Full_Charge_Capacity_FilteredValLen - offset);  // Transmit as much as possible
      memcpy(pValue, pAttr->pValue + offset, *pLen);
    }
  }
  // See if request is regarding the Remaining_Capacity_Filtered Characteristic Value
else if ( ! memcmp(pAttr->type.uuid, bfgs_Remaining_Capacity_FilteredUUID, pAttr->type.len) )
  {
    if ( offset > bfgs_Remaining_Capacity_FilteredValLen )  // Prevent malicious ATT ReadBlob offsets.
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else
    {
      *pLen = MIN(maxLen, bfgs_Remaining_Capacity_FilteredValLen - offset);  // Transmit as much as possible
      memcpy(pValue, pAttr->pValue + offset, *pLen);
    }
  }
  // See if request is regarding the Average_Current Characteristic Value
else if ( ! memcmp(pAttr->type.uuid, bfgs_Average_CurrentUUID, pAttr->type.len) )
  {
    if ( offset > bfgs_Average_CurrentValLen )  // Prevent malicious ATT ReadBlob offsets.
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else
    {
      *pLen = MIN(maxLen, bfgs_Average_CurrentValLen - offset);  // Transmit as much as possible
      memcpy(pValue, pAttr->pValue + offset, *pLen);
    }
  }
  // See if request is regarding the Remaining_Capacity Characteristic Value
else if ( ! memcmp(pAttr->type.uuid, bfgs_Remaining_CapacityUUID, pAttr->type.len) )
  {
    if ( offset > bfgs_Remaining_CapacityValLen )  // Prevent malicious ATT ReadBlob offsets.
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else
    {
      *pLen = MIN(maxLen, bfgs_Remaining_CapacityValLen - offset);  // Transmit as much as possible
      memcpy(pValue, pAttr->pValue + offset, *pLen);
    }
  }
  // See if request is regarding the Full_Available_Capacity Characteristic Value
else if ( ! memcmp(pAttr->type.uuid, bfgs_Full_Available_CapacityUUID, pAttr->type.len) )
  {
    if ( offset > bfgs_Full_Available_CapacityValLen )  // Prevent malicious ATT ReadBlob offsets.
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else
    {
      *pLen = MIN(maxLen, bfgs_Full_Available_CapacityValLen - offset);  // Transmit as much as possible
      memcpy(pValue, pAttr->pValue + offset, *pLen);
    }
  }
  // See if request is regarding the Voltage Characteristic Value
else if ( ! memcmp(pAttr->type.uuid, bfgs_VoltageUUID, pAttr->type.len) )
  {
    if ( offset > bfgs_VoltageValLen )  // Prevent malicious ATT ReadBlob offsets.
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else
    {
      *pLen = MIN(maxLen, bfgs_VoltageValLen - offset);  // Transmit as much as possible
      memcpy(pValue, pAttr->pValue + offset, *pLen);
    }
  }
  // See if request is regarding the Temperature Characteristic Value
else if ( ! memcmp(pAttr->type.uuid, bfgs_TemperatureUUID, pAttr->type.len) )
  {
    if ( offset > bfgs_TemperatureValLen )  // Prevent malicious ATT ReadBlob offsets.
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else
    {
      *pLen = MIN(maxLen, bfgs_TemperatureValLen - offset);  // Transmit as much as possible
      memcpy(pValue, pAttr->pValue + offset, *pLen);
    }
  }
  // See if request is regarding the Nominal_Available_Capacity Characteristic Value
else if ( ! memcmp(pAttr->type.uuid, bfgs_Nominal_Available_CapacityUUID, pAttr->type.len) )
  {
    if ( offset > bfgs_Nominal_Available_CapacityValLen )  // Prevent malicious ATT ReadBlob offsets.
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else
    {
      *pLen = MIN(maxLen, bfgs_Nominal_Available_CapacityValLen - offset);  // Transmit as much as possible
      memcpy(pValue, pAttr->pValue + offset, *pLen);
    }
  }
  // See if request is regarding the Full_Charge_Capacity_Unfiltered Characteristic Value
else if ( ! memcmp(pAttr->type.uuid, bfgs_Full_Charge_Capacity_UnfilteredUUID, pAttr->type.len) )
  {
    if ( offset > bfgs_Full_Charge_Capacity_UnfilteredValLen )  // Prevent malicious ATT ReadBlob offsets.
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else
    {
      *pLen = MIN(maxLen, bfgs_Full_Charge_Capacity_UnfilteredValLen - offset);  // Transmit as much as possible
      memcpy(pValue, pAttr->pValue + offset, *pLen);
    }
  }
  // See if request is regarding the State_of_Charge_Unfiltered Characteristic Value
else if ( ! memcmp(pAttr->type.uuid, bfgs_State_of_Charge_UnfilteredUUID, pAttr->type.len) )
  {
    if ( offset > bfgs_State_of_Charge_UnfilteredValLen )  // Prevent malicious ATT ReadBlob offsets.
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else
    {
      *pLen = MIN(maxLen, bfgs_State_of_Charge_UnfilteredValLen - offset);  // Transmit as much as possible
      memcpy(pValue, pAttr->pValue + offset, *pLen);
    }
  }
  // See if request is regarding the Flags Characteristic Value
else if ( ! memcmp(pAttr->type.uuid, bfgs_FlagsUUID, pAttr->type.len) )
  {
    if ( offset > bfgs_FlagsValLen )  // Prevent malicious ATT ReadBlob offsets.
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else
    {
      *pLen = MIN(maxLen, bfgs_FlagsValLen - offset);  // Transmit as much as possible
      memcpy(pValue, pAttr->pValue + offset, *pLen);
    }
  }
  // See if request is regarding the Reserved_1 Characteristic Value
else if ( ! memcmp(pAttr->type.uuid, bfgs_Reserved_1UUID, pAttr->type.len) )
  {
    if ( offset > bfgs_Reserved_1ValLen )  // Prevent malicious ATT ReadBlob offsets.
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else
    {
      *pLen = MIN(maxLen, bfgs_Reserved_1ValLen - offset);  // Transmit as much as possible
      memcpy(pValue, pAttr->pValue + offset, *pLen);
    }
  }
  else
  {
    // If we get here, that means you've forgotten to add an if clause for a
    // characteristic value attribute in the attribute table that has READ permissions.
    *pLen = 0;
    status = ATT_ERR_ATTR_NOT_FOUND;
  }

  return status;
}


/*********************************************************************
 * @fn      BQ27426_Fuel_Gauge_Service_WriteAttrCB
 *
 * @brief   Validate attribute data prior to a write operation
 *
 * @param   connHandle - connection message was received on
 * @param   pAttr - pointer to attribute
 * @param   pValue - pointer to data to be written
 * @param   len - length of data
 * @param   offset - offset of the first octet to be written
 * @param   method - type of write message
 *
 * @return  SUCCESS, blePending or Failure
 */
static bStatus_t BQ27426_Fuel_Gauge_Service_WriteAttrCB( uint16_t connHandle, gattAttribute_t *pAttr,
                                        uint8_t *pValue, uint16_t len, uint16_t offset,
                                        uint8_t method )
{
  bStatus_t status  = SUCCESS;
  uint8_t   paramID = 0xFF;

  // See if request is regarding a Client Characterisic Configuration
  if ( ! memcmp(pAttr->type.uuid, clientCharCfgUUID, pAttr->type.len) )
  {
    // Allow notification and indication, but do not check if really allowed per CCCD.
    status = GATTServApp_ProcessCCCWriteReq( connHandle, pAttr, pValue, len,
                                             offset, GATT_CLIENT_CFG_NOTIFY |
                                                     GATT_CLIENT_CFG_INDICATE );
  }
  // See if request is regarding the Initialize_Fuel_Gauge Characteristic Value
  else if ( ! memcmp(pAttr->type.uuid, bfgs_Initialize_Fuel_GaugeUUID, pAttr->type.len) )
  {
    if ( offset >= BFGS_INITIALIZE_FUEL_GAUGE_LEN )
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else if ( offset + len > BFGS_INITIALIZE_FUEL_GAUGE_LEN )
    {
      status = ATT_ERR_INVALID_VALUE_SIZE;
    }
    else if ( offset + len < BFGS_INITIALIZE_FUEL_GAUGE_LEN_MIN && 
              ( method == ATT_EXECUTE_WRITE_REQ || method == ATT_WRITE_REQ ) )
    {
      // Refuse writes that are lower than minimum.
      // Note: Cannot determine if a Reliable Write (to several chars) is finished, so those will
      //       only be refused if this attribute is the last in the queue (method is execute).
      //       Otherwise, reliable writes are accepted and parsed piecemeal.
      status = ATT_ERR_INVALID_VALUE_SIZE;
    }
    else
    {
      // Copy pValue into the variable we point to from the attribute table.
      memcpy(pAttr->pValue + offset, pValue, len);

      // Only notify application and update length if enough data is written.
      //
      // Note: If reliable writes are used (meaning several attributes are written to using ATT PrepareWrite),
      //       the application will get a callback for every write with an offset + len larger than _LEN_MIN.
      // Note: For Long Writes (ATT Prepare + Execute towards only one attribute) only one callback will be issued,
      //       because the write fragments are concatenated before being sent here.
      if ( offset + len >= BFGS_INITIALIZE_FUEL_GAUGE_LEN_MIN)
      {
        paramID = BFGS_INITIALIZE_FUEL_GAUGE_ID;
        bfgs_Initialize_Fuel_GaugeValLen = offset + len; // Update data length.
      }
    }
  }
  // See if request is regarding the Reserved_1 Characteristic Value
  else if ( ! memcmp(pAttr->type.uuid, bfgs_Reserved_1UUID, pAttr->type.len) )
  {
    if ( offset >= BFGS_RESERVED_1_LEN )
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else if ( offset + len > BFGS_RESERVED_1_LEN )
    {
      status = ATT_ERR_INVALID_VALUE_SIZE;
    }
    else if ( offset + len < BFGS_RESERVED_1_LEN_MIN && 
              ( method == ATT_EXECUTE_WRITE_REQ || method == ATT_WRITE_REQ ) )
    {
      // Refuse writes that are lower than minimum.
      // Note: Cannot determine if a Reliable Write (to several chars) is finished, so those will
      //       only be refused if this attribute is the last in the queue (method is execute).
      //       Otherwise, reliable writes are accepted and parsed piecemeal.
      status = ATT_ERR_INVALID_VALUE_SIZE;
    }
    else
    {
      // Copy pValue into the variable we point to from the attribute table.
      memcpy(pAttr->pValue + offset, pValue, len);

      // Only notify application and update length if enough data is written.
      //
      // Note: If reliable writes are used (meaning several attributes are written to using ATT PrepareWrite),
      //       the application will get a callback for every write with an offset + len larger than _LEN_MIN.
      // Note: For Long Writes (ATT Prepare + Execute towards only one attribute) only one callback will be issued,
      //       because the write fragments are concatenated before being sent here.
      if ( offset + len >= BFGS_RESERVED_1_LEN_MIN)
      {
        paramID = BFGS_RESERVED_1_ID;
        bfgs_Reserved_1ValLen = offset + len; // Update data length.
      }
    }
  }
  else
  {
    // If we get here, that means you've forgotten to add an if clause for a
    // characteristic value attribute in the attribute table that has WRITE permissions.
    status = ATT_ERR_ATTR_NOT_FOUND;
  }

  // Let the application know something changed (if it did) by using the
   // callback it registered earlier (if it did).
   if (paramID != 0xFF)
     if ( pAppCBs && pAppCBs->pfnChangeCb )
     	pAppCBs->pfnChangeCb( connHandle, BQ27426_FUEL_GAUGE_SERVICE_SERV_UUID, paramID, pValue, len+offset ); // Call app function from stack task context.

   return status;
}
