/**********************************************************************************************
 * Filename:       BQ27426_Fuel_Gauge_Service.h
 *
 * Description:    This file contains the BQ27426_Fuel_Gauge_Service service definitions and
 *                 prototypes.
 *
 *                 Generated by:
 *                 BDS version: 1.1.3066.0
 *                 Plugin:      Texas Instruments CC26xx BLE SDK v2.1 GATT Server plugin 1.0.5 beta
 *                 Time:        Mon Dec 05 2016 18:09:19 GMT-06:00
 *

 * Copyright (c) 2015, Texas Instruments Incorporated
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * *  Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * *  Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * *  Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *************************************************************************************************/

#ifndef _BQ27426_FUEL_GAUGE_SERVICE_H_
#define _BQ27426_FUEL_GAUGE_SERVICE_H_

#ifdef __cplusplus
extern "C"
{
#endif

/*********************************************************************
 * INCLUDES
 */

/*********************************************************************
 * CONSTANTS
 */

/*********************************************************************
* CONSTANTS
*/
// Service UUID
#define BQ27426_FUEL_GAUGE_SERVICE_SERV_UUID 0x7C12
#define BQ27426_FUEL_GAUGE_SERVICE_SERV_UUID_BASE128(uuid) 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB0, 0x00, 0x40, 0x51, 0x04, LO_UINT16(uuid), HI_UINT16(uuid), 0x00, 0xF0

// Remaining_Capacity_Unfiltered Characteristic defines
#define BFGS_REMAINING_CAPACITY_UNFILTERED_ID                 0
#define BFGS_REMAINING_CAPACITY_UNFILTERED_UUID               0x6B54
#define BFGS_REMAINING_CAPACITY_UNFILTERED_UUID_BASE128(uuid) 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB0, 0x00, 0x40, 0x51, 0x04, LO_UINT16(uuid), HI_UINT16(uuid), 0x00, 0xF0
#define BFGS_REMAINING_CAPACITY_UNFILTERED_LEN                2
#define BFGS_REMAINING_CAPACITY_UNFILTERED_LEN_MIN            2

// Average_Power Characteristic defines
#define BFGS_AVERAGE_POWER_ID                 1
#define BFGS_AVERAGE_POWER_UUID               0x2CEC
#define BFGS_AVERAGE_POWER_UUID_BASE128(uuid) 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB0, 0x00, 0x40, 0x51, 0x04, LO_UINT16(uuid), HI_UINT16(uuid), 0x00, 0xF0
#define BFGS_AVERAGE_POWER_LEN                2
#define BFGS_AVERAGE_POWER_LEN_MIN            2

// Full_Charge_Capacity Characteristic defines
#define BFGS_FULL_CHARGE_CAPACITY_ID                 2
#define BFGS_FULL_CHARGE_CAPACITY_UUID               0xCE36
#define BFGS_FULL_CHARGE_CAPACITY_UUID_BASE128(uuid) 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB0, 0x00, 0x40, 0x51, 0x04, LO_UINT16(uuid), HI_UINT16(uuid), 0x00, 0xF0
#define BFGS_FULL_CHARGE_CAPACITY_LEN                2
#define BFGS_FULL_CHARGE_CAPACITY_LEN_MIN            2

// State_of_Health Characteristic defines
#define BFGS_STATE_OF_HEALTH_ID                 3
#define BFGS_STATE_OF_HEALTH_UUID               0xDD2A
#define BFGS_STATE_OF_HEALTH_UUID_BASE128(uuid) 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB0, 0x00, 0x40, 0x51, 0x04, LO_UINT16(uuid), HI_UINT16(uuid), 0x00, 0xF0
#define BFGS_STATE_OF_HEALTH_LEN                2
#define BFGS_STATE_OF_HEALTH_LEN_MIN            2

// Internal_Temperature Characteristic defines
#define BFGS_INTERNAL_TEMPERATURE_ID                 4
#define BFGS_INTERNAL_TEMPERATURE_UUID               0x219D
#define BFGS_INTERNAL_TEMPERATURE_UUID_BASE128(uuid) 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB0, 0x00, 0x40, 0x51, 0x04, LO_UINT16(uuid), HI_UINT16(uuid), 0x00, 0xF0
#define BFGS_INTERNAL_TEMPERATURE_LEN                2
#define BFGS_INTERNAL_TEMPERATURE_LEN_MIN            2

// State_of_Charge Characteristic defines
#define BFGS_STATE_OF_CHARGE_ID                 5
#define BFGS_STATE_OF_CHARGE_UUID               0x316D
#define BFGS_STATE_OF_CHARGE_UUID_BASE128(uuid) 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB0, 0x00, 0x40, 0x51, 0x04, LO_UINT16(uuid), HI_UINT16(uuid), 0x00, 0xF0
#define BFGS_STATE_OF_CHARGE_LEN                2
#define BFGS_STATE_OF_CHARGE_LEN_MIN            2

// Full_Charge_Capacity_Filtered Characteristic defines
#define BFGS_FULL_CHARGE_CAPACITY_FILTERED_ID                 6
#define BFGS_FULL_CHARGE_CAPACITY_FILTERED_UUID               0xA3FB
#define BFGS_FULL_CHARGE_CAPACITY_FILTERED_UUID_BASE128(uuid) 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB0, 0x00, 0x40, 0x51, 0x04, LO_UINT16(uuid), HI_UINT16(uuid), 0x00, 0xF0
#define BFGS_FULL_CHARGE_CAPACITY_FILTERED_LEN                2
#define BFGS_FULL_CHARGE_CAPACITY_FILTERED_LEN_MIN            2

// Remaining_Capacity_Filtered Characteristic defines
#define BFGS_REMAINING_CAPACITY_FILTERED_ID                 7
#define BFGS_REMAINING_CAPACITY_FILTERED_UUID               0x68D5
#define BFGS_REMAINING_CAPACITY_FILTERED_UUID_BASE128(uuid) 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB0, 0x00, 0x40, 0x51, 0x04, LO_UINT16(uuid), HI_UINT16(uuid), 0x00, 0xF0
#define BFGS_REMAINING_CAPACITY_FILTERED_LEN                2
#define BFGS_REMAINING_CAPACITY_FILTERED_LEN_MIN            2

// Average_Current Characteristic defines
#define BFGS_AVERAGE_CURRENT_ID                 8
#define BFGS_AVERAGE_CURRENT_UUID               0xB77B
#define BFGS_AVERAGE_CURRENT_UUID_BASE128(uuid) 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB0, 0x00, 0x40, 0x51, 0x04, LO_UINT16(uuid), HI_UINT16(uuid), 0x00, 0xF0
#define BFGS_AVERAGE_CURRENT_LEN                2
#define BFGS_AVERAGE_CURRENT_LEN_MIN            2

// Remaining_Capacity Characteristic defines
#define BFGS_REMAINING_CAPACITY_ID                 9
#define BFGS_REMAINING_CAPACITY_UUID               0x927A
#define BFGS_REMAINING_CAPACITY_UUID_BASE128(uuid) 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB0, 0x00, 0x40, 0x51, 0x04, LO_UINT16(uuid), HI_UINT16(uuid), 0x00, 0xF0
#define BFGS_REMAINING_CAPACITY_LEN                2
#define BFGS_REMAINING_CAPACITY_LEN_MIN            2

// Full_Available_Capacity Characteristic defines
#define BFGS_FULL_AVAILABLE_CAPACITY_ID                 10
#define BFGS_FULL_AVAILABLE_CAPACITY_UUID               0xF2C0
#define BFGS_FULL_AVAILABLE_CAPACITY_UUID_BASE128(uuid) 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB0, 0x00, 0x40, 0x51, 0x04, LO_UINT16(uuid), HI_UINT16(uuid), 0x00, 0xF0
#define BFGS_FULL_AVAILABLE_CAPACITY_LEN                2
#define BFGS_FULL_AVAILABLE_CAPACITY_LEN_MIN            2

// Voltage Characteristic defines
#define BFGS_VOLTAGE_ID                 11
#define BFGS_VOLTAGE_UUID               0x0B44
#define BFGS_VOLTAGE_UUID_BASE128(uuid) 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB0, 0x00, 0x40, 0x51, 0x04, LO_UINT16(uuid), HI_UINT16(uuid), 0x00, 0xF0
#define BFGS_VOLTAGE_LEN                2
#define BFGS_VOLTAGE_LEN_MIN            2

// Temperature Characteristic defines
#define BFGS_TEMPERATURE_ID                 12
#define BFGS_TEMPERATURE_UUID               0xF0F3
#define BFGS_TEMPERATURE_UUID_BASE128(uuid) 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB0, 0x00, 0x40, 0x51, 0x04, LO_UINT16(uuid), HI_UINT16(uuid), 0x00, 0xF0
#define BFGS_TEMPERATURE_LEN                2
#define BFGS_TEMPERATURE_LEN_MIN            2

// Nominal_Available_Capacity Characteristic defines
#define BFGS_NOMINAL_AVAILABLE_CAPACITY_ID                 13
#define BFGS_NOMINAL_AVAILABLE_CAPACITY_UUID               0x26A5
#define BFGS_NOMINAL_AVAILABLE_CAPACITY_UUID_BASE128(uuid) 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB0, 0x00, 0x40, 0x51, 0x04, LO_UINT16(uuid), HI_UINT16(uuid), 0x00, 0xF0
#define BFGS_NOMINAL_AVAILABLE_CAPACITY_LEN                2
#define BFGS_NOMINAL_AVAILABLE_CAPACITY_LEN_MIN            2

// Full_Charge_Capacity_Unfiltered Characteristic defines
#define BFGS_FULL_CHARGE_CAPACITY_UNFILTERED_ID                 14
#define BFGS_FULL_CHARGE_CAPACITY_UNFILTERED_UUID               0x8C88
#define BFGS_FULL_CHARGE_CAPACITY_UNFILTERED_UUID_BASE128(uuid) 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB0, 0x00, 0x40, 0x51, 0x04, LO_UINT16(uuid), HI_UINT16(uuid), 0x00, 0xF0
#define BFGS_FULL_CHARGE_CAPACITY_UNFILTERED_LEN                2
#define BFGS_FULL_CHARGE_CAPACITY_UNFILTERED_LEN_MIN            2

// State_of_Charge_Unfiltered Characteristic defines
#define BFGS_STATE_OF_CHARGE_UNFILTERED_ID                 15
#define BFGS_STATE_OF_CHARGE_UNFILTERED_UUID               0x91F2
#define BFGS_STATE_OF_CHARGE_UNFILTERED_UUID_BASE128(uuid) 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB0, 0x00, 0x40, 0x51, 0x04, LO_UINT16(uuid), HI_UINT16(uuid), 0x00, 0xF0
#define BFGS_STATE_OF_CHARGE_UNFILTERED_LEN                2
#define BFGS_STATE_OF_CHARGE_UNFILTERED_LEN_MIN            2

// Flags Characteristic defines
#define BFGS_FLAGS_ID                 16
#define BFGS_FLAGS_UUID               0x6FED
#define BFGS_FLAGS_UUID_BASE128(uuid) 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB0, 0x00, 0x40, 0x51, 0x04, LO_UINT16(uuid), HI_UINT16(uuid), 0x00, 0xF0
#define BFGS_FLAGS_LEN                2
#define BFGS_FLAGS_LEN_MIN            2

// Initialize_Fuel_Gauge Characteristic defines
#define BFGS_INITIALIZE_FUEL_GAUGE_ID                 17
#define BFGS_INITIALIZE_FUEL_GAUGE_UUID               0x6C8E
#define BFGS_INITIALIZE_FUEL_GAUGE_UUID_BASE128(uuid) 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB0, 0x00, 0x40, 0x51, 0x04, LO_UINT16(uuid), HI_UINT16(uuid), 0x00, 0xF0
#define BFGS_INITIALIZE_FUEL_GAUGE_LEN                1
#define BFGS_INITIALIZE_FUEL_GAUGE_LEN_MIN            1

// Reserved_1 Characteristic defines
#define BFGS_RESERVED_1_ID                 18
#define BFGS_RESERVED_1_UUID               0x6C22
#define BFGS_RESERVED_1_UUID_BASE128(uuid) 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB0, 0x00, 0x40, 0x51, 0x04, LO_UINT16(uuid), HI_UINT16(uuid), 0x00, 0xF0
#define BFGS_RESERVED_1_LEN                8
#define BFGS_RESERVED_1_LEN_MIN            8

/*********************************************************************
 * TYPEDEFS
 */
//
// Fields in characteristic "Remaining_Capacity_Unfiltered"
//   Field "Battery_Level" format: uint16, bits: 16
//
// Fields in characteristic "Average_Power"
//   Field "Battery_Level" format: uint16, bits: 16
//
// Fields in characteristic "Full_Charge_Capacity"
//   Field "Battery_Level" format: uint16, bits: 16
//
// Fields in characteristic "State_of_Health"
//   Field "Battery_Level" format: uint16, bits: 16
//
// Fields in characteristic "Internal_Temperature"
//   Field "Battery_Level" format: uint16, bits: 16
//
// Fields in characteristic "State_of_Charge"
//   Field "Battery_Level" format: uint16, bits: 16
//
// Fields in characteristic "Full_Charge_Capacity_Filtered"
//   Field "Battery_Level" format: uint16, bits: 16
//
// Fields in characteristic "Remaining_Capacity_Filtered"
//   Field "Battery_Level" format: uint16, bits: 16
//
// Fields in characteristic "Average_Current"
//   Field "Battery_Level" format: uint16, bits: 16
//
// Fields in characteristic "Remaining_Capacity"
//   Field "Battery_Level" format: uint16, bits: 16
//
// Fields in characteristic "Full_Available_Capacity"
//   Field "Battery_Level" format: uint16, bits: 16
//
// Fields in characteristic "Voltage"
//   Field "Battery_Level" format: uint16, bits: 16
//
// Fields in characteristic "Temperature"
//   Field "Battery_Level" format: uint16, bits: 16
//
// Fields in characteristic "Nominal_Available_Capacity"
//   Field "Battery_Level" format: uint16, bits: 16
//
// Fields in characteristic "Full_Charge_Capacity_Unfiltered"
//   Field "Battery_Level" format: uint16, bits: 16
//
// Fields in characteristic "State_of_Charge_Unfiltered"
//   Field "Battery_Level" format: uint16, bits: 16
//
// Fields in characteristic "Flags"
//   Field "Battery_Level" format: uint16, bits: 16
//
// Fields in characteristic "Initialize_Fuel_Gauge"
//   Field "Battery_Level" format: uint8, bits: 8
//
// Fields in characteristic "Reserved_1"
//   Field "Data_Type" format: sint64, bits: 64
/*********************************************************************
 * MACROS
 */

/*********************************************************************
 * Profile Callbacks
 */

typedef void (*Bq27426FuelGaugeServiceChange_t)( uint16_t connHandle, uint16_t svcUuid, uint8_t paramID, uint8_t *pValue, uint16_t len );

typedef struct
{
	Bq27426FuelGaugeServiceChange_t        pfnChangeCb;     // Called when characteristic value changes
	Bq27426FuelGaugeServiceChange_t        pfnCfgChangeCb;  // Called when characteristic CCCD changes
} Bq27426FuelGaugeServiceCBs_t;

/*********************************************************************
 * API FUNCTIONS 
 */


/*
 * Bq27426FuelGaugeService_AddService- Initializes the Bq27426FuelGaugeService service by registering
 *          GATT attributes with the GATT server.
 *
 */
extern bStatus_t Bq27426FuelGaugeService_AddService( void );

/*
 * Bq27426FuelGaugeService_RegisterAppCBs - Registers the application callback function.
 *                    Only call this function once.
 *
 *    appCallbacks - pointer to application callbacks.
 */
extern bStatus_t Bq27426FuelGaugeService_RegisterAppCBs( Bq27426FuelGaugeServiceCBs_t *appCallbacks );

/*
 * Bq27426FuelGaugeService_SetParameter - Set a Bq27426FuelGaugeService parameter.
 *
 *    param - Profile parameter ID
 *    len   - length of data to write
 *    value - pointer to data to write.  This is dependent on
 *            the parameter ID and may be cast to the appropriate 
 *            data type (example: data type of uint16_t will be cast to 
 *            uint16_t pointer).
 */
extern bStatus_t Bq27426FuelGaugeService_SetParameter( uint8_t param, uint16_t len, void *value );
  
/*
 * Bq27426FuelGaugeService_GetParameter - Get a Bq27426FuelGaugeService parameter.
 *
 *    param - Profile parameter ID
 *    len   - pointer to a variable that contains the maximum length that can be written to *value.
              After the call, this value will contain the actual returned length.
 *    value - pointer to data to write.  This is dependent on
 *            the parameter ID and may be cast to the appropriate 
 *            data type (example: data type of uint16_t will be cast to 
 *            uint16_t pointer).
 */
extern bStatus_t Bq27426FuelGaugeService_GetParameter( uint8_t param, uint16_t *len, void *value );

/*********************************************************************
*********************************************************************/

#ifdef __cplusplus
}
#endif

#endif /* _BQ27426_FUEL_GAUGE_SERVICE_H_ */
