/**********************************************************************************************
 * Filename:       WDMM_Service.c
 *
 * Description:    This file contains the implementation of the service.
 *
 *                 Generated by:
 *                 BDS version: 1.1.3066.0
 *                 Plugin:      Texas Instruments CC26xx BLE SDK v2.1 GATT Server plugin 1.0.5 beta
 *                 Time:        Thu Nov 10 2016 15:16:39 GMT-06:00
 *

 * Copyright (c) 2015, Texas Instruments Incorporated
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * *  Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * *  Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * *  Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *************************************************************************************************/


/*********************************************************************
 * INCLUDES
 */
#include <string.h>

#include "bcomdef.h"
#include "OSAL.h"
#include "linkdb.h"
#include "att.h"
#include "gatt.h"
#include "gatt_uuid.h"
#include "gattservapp.h"
#include "gapbondmgr.h"

#include "WDMM_Service.h"

/*********************************************************************
 * MACROS
 */

/*********************************************************************
 * CONSTANTS
 */

/*********************************************************************
 * TYPEDEFS
 */

/*********************************************************************
* GLOBAL VARIABLES
*/

// WDMM_Service Service UUID
CONST uint8_t WdmmServiceUUID[ATT_UUID_SIZE] =
{
  WDMM_SERVICE_SERV_UUID_BASE128(WDMM_SERVICE_SERV_UUID)
};

// DC_Reading UUID
CONST uint8_t ws_DC_ReadingUUID[ATT_UUID_SIZE] =
{
  WS_DC_READING_UUID_BASE128(WS_DC_READING_UUID)
};
// AC_Reading UUID
CONST uint8_t ws_AC_ReadingUUID[ATT_UUID_SIZE] =
{
  WS_AC_READING_UUID_BASE128(WS_AC_READING_UUID)
};
// Voltage_Range_1_Cal_Constants UUID
CONST uint8_t ws_Voltage_Range_1_Cal_ConstantsUUID[ATT_UUID_SIZE] =
{
  WS_VOLTAGE_RANGE_1_CAL_CONSTANTS_UUID_BASE128(WS_VOLTAGE_RANGE_1_CAL_CONSTANTS_UUID)
};
// Voltage_Range_2_Cal_Constants UUID
CONST uint8_t ws_Voltage_Range_2_Cal_ConstantsUUID[ATT_UUID_SIZE] =
{
  WS_VOLTAGE_RANGE_2_CAL_CONSTANTS_UUID_BASE128(WS_VOLTAGE_RANGE_2_CAL_CONSTANTS_UUID)
};
// Voltage_Range_3_Cal_Constants UUID
CONST uint8_t ws_Voltage_Range_3_Cal_ConstantsUUID[ATT_UUID_SIZE] =
{
  WS_VOLTAGE_RANGE_3_CAL_CONSTANTS_UUID_BASE128(WS_VOLTAGE_RANGE_3_CAL_CONSTANTS_UUID)
};
// Voltage_Range_4_Cal_Constants UUID
CONST uint8_t ws_Voltage_Range_4_Cal_ConstantsUUID[ATT_UUID_SIZE] =
{
  WS_VOLTAGE_RANGE_4_CAL_CONSTANTS_UUID_BASE128(WS_VOLTAGE_RANGE_4_CAL_CONSTANTS_UUID)
};
// Current_Range_1_Cal_Constants UUID
CONST uint8_t ws_Current_Range_1_Cal_ConstantsUUID[ATT_UUID_SIZE] =
{
  WS_CURRENT_RANGE_1_CAL_CONSTANTS_UUID_BASE128(WS_CURRENT_RANGE_1_CAL_CONSTANTS_UUID)
};
// Current_Range_2_Cal_Constants UUID
CONST uint8_t ws_Current_Range_2_Cal_ConstantsUUID[ATT_UUID_SIZE] =
{
  WS_CURRENT_RANGE_2_CAL_CONSTANTS_UUID_BASE128(WS_CURRENT_RANGE_2_CAL_CONSTANTS_UUID)
};
// Initiate_Power_Down UUID
CONST uint8_t ws_Initiate_Power_DownUUID[ATT_UUID_SIZE] =
{
  WS_INITIATE_POWER_DOWN_UUID_BASE128(WS_INITIATE_POWER_DOWN_UUID)
};
// Voltage_Range_Select UUID
CONST uint8_t ws_Voltage_Range_SelectUUID[ATT_UUID_SIZE] =
{
  WS_VOLTAGE_RANGE_SELECT_UUID_BASE128(WS_VOLTAGE_RANGE_SELECT_UUID)
};
// Voltage_Range_Mode UUID
CONST uint8_t ws_Voltage_Range_ModeUUID[ATT_UUID_SIZE] =
{
  WS_VOLTAGE_RANGE_MODE_UUID_BASE128(WS_VOLTAGE_RANGE_MODE_UUID)
};
// Measurement_Mode UUID
CONST uint8_t ws_Measurement_ModeUUID[ATT_UUID_SIZE] =
{
  WS_MEASUREMENT_MODE_UUID_BASE128(WS_MEASUREMENT_MODE_UUID)
};
// Current_Range_Select UUID
CONST uint8_t ws_Current_Range_SelectUUID[ATT_UUID_SIZE] =
{
  WS_CURRENT_RANGE_SELECT_UUID_BASE128(WS_CURRENT_RANGE_SELECT_UUID)
};
// Battery_Capacity_Level UUID
CONST uint8_t ws_Battery_Capacity_LevelUUID[ATT_UUID_SIZE] =
{
  WS_BATTERY_CAPACITY_LEVEL_UUID_BASE128(WS_BATTERY_CAPACITY_LEVEL_UUID)
};
// Battery_Voltage_Level UUID
CONST uint8_t ws_Battery_Voltage_LevelUUID[ATT_UUID_SIZE] =
{
  WS_BATTERY_VOLTAGE_LEVEL_UUID_BASE128(WS_BATTERY_VOLTAGE_LEVEL_UUID)
};
// CapTIvate_Sensing UUID
CONST uint8_t ws_CapTIvate_SensingUUID[ATT_UUID_SIZE] =
{
  WS_CAPTIVATE_SENSING_UUID_BASE128(WS_CAPTIVATE_SENSING_UUID)
};
// Sampling_Rate_Select UUID
CONST uint8_t ws_Sampling_Rate_SelectUUID[ATT_UUID_SIZE] =
{
  WS_SAMPLING_RATE_SELECT_UUID_BASE128(WS_SAMPLING_RATE_SELECT_UUID)
};
// Reporting_Rate_Select UUID
CONST uint8_t ws_Reporting_Rate_SelectUUID[ATT_UUID_SIZE] =
{
  WS_REPORTING_RATE_SELECT_UUID_BASE128(WS_REPORTING_RATE_SELECT_UUID)
};
// Temp_Comp_V1 UUID
CONST uint8_t ws_Temp_Comp_V1UUID[ATT_UUID_SIZE] =
{
  WS_TEMP_COMP_V1_UUID_BASE128(WS_TEMP_COMP_V1_UUID)
};
// Temp_Comp_V2 UUID
CONST uint8_t ws_Temp_Comp_V2UUID[ATT_UUID_SIZE] =
{
  WS_TEMP_COMP_V2_UUID_BASE128(WS_TEMP_COMP_V2_UUID)
};
// Temp_Comp_V3 UUID
CONST uint8_t ws_Temp_Comp_V3UUID[ATT_UUID_SIZE] =
{
  WS_TEMP_COMP_V3_UUID_BASE128(WS_TEMP_COMP_V3_UUID)
};
// Temp_Comp_V4 UUID
CONST uint8_t ws_Temp_Comp_V4UUID[ATT_UUID_SIZE] =
{
  WS_TEMP_COMP_V4_UUID_BASE128(WS_TEMP_COMP_V4_UUID)
};
// Temp_Comp_I1 UUID
CONST uint8_t ws_Temp_Comp_I1UUID[ATT_UUID_SIZE] =
{
  WS_TEMP_COMP_I1_UUID_BASE128(WS_TEMP_COMP_I1_UUID)
};
// Temp_Comp_I2 UUID
CONST uint8_t ws_Temp_Comp_I2UUID[ATT_UUID_SIZE] =
{
  WS_TEMP_COMP_I2_UUID_BASE128(WS_TEMP_COMP_I2_UUID)
};
// Reserved_1 UUID
CONST uint8_t ws_Reserved_1UUID[ATT_UUID_SIZE] =
{
  WS_RESERVED_1_UUID_BASE128(WS_RESERVED_1_UUID)
};
// Reserved_2 UUID
CONST uint8_t ws_Reserved_2UUID[ATT_UUID_SIZE] =
{
  WS_RESERVED_2_UUID_BASE128(WS_RESERVED_2_UUID)
};

/*********************************************************************
 * LOCAL VARIABLES
 */

static WdmmServiceCBs_t *pAppCBs = NULL;

/*********************************************************************
* Profile Attributes - variables
*/

// Service declaration
static CONST gattAttrType_t WdmmServiceDecl = { ATT_UUID_SIZE, WdmmServiceUUID };

// Characteristic "DC_Reading" Properties (for declaration)
static uint8_t ws_DC_ReadingProps = GATT_PROP_NOTIFY | GATT_PROP_READ;

// Characteristic "DC_Reading" Value variable
static uint8_t ws_DC_ReadingVal[WS_DC_READING_LEN] = {0};

// Length of data in characteristic "DC_Reading" Value variable, initialized to minimal size.
static uint16_t ws_DC_ReadingValLen = WS_DC_READING_LEN_MIN;

// Characteristic "DC_Reading" CCCD
static gattCharCfg_t *ws_DC_ReadingConfig;

// Characteristic "AC_Reading" Properties (for declaration)
static uint8_t ws_AC_ReadingProps = GATT_PROP_NOTIFY | GATT_PROP_READ;

// Characteristic "AC_Reading" Value variable
static uint8_t ws_AC_ReadingVal[WS_AC_READING_LEN] = {0};

// Length of data in characteristic "AC_Reading" Value variable, initialized to minimal size.
static uint16_t ws_AC_ReadingValLen = WS_AC_READING_LEN_MIN;

// Characteristic "AC_Reading" CCCD
static gattCharCfg_t *ws_AC_ReadingConfig;

// Characteristic "Voltage_Range_1_Cal_Constants" Properties (for declaration)
static uint8_t ws_Voltage_Range_1_Cal_ConstantsProps = GATT_PROP_READ | GATT_PROP_WRITE;

// Characteristic "Voltage_Range_1_Cal_Constants" Value variable
static uint8_t ws_Voltage_Range_1_Cal_ConstantsVal[WS_VOLTAGE_RANGE_1_CAL_CONSTANTS_LEN] = {0};

// Length of data in characteristic "Voltage_Range_1_Cal_Constants" Value variable, initialized to minimal size.
static uint16_t ws_Voltage_Range_1_Cal_ConstantsValLen = WS_VOLTAGE_RANGE_1_CAL_CONSTANTS_LEN_MIN;

// Characteristic "Voltage_Range_2_Cal_Constants" Properties (for declaration)
static uint8_t ws_Voltage_Range_2_Cal_ConstantsProps = GATT_PROP_READ | GATT_PROP_WRITE;

// Characteristic "Voltage_Range_2_Cal_Constants" Value variable
static uint8_t ws_Voltage_Range_2_Cal_ConstantsVal[WS_VOLTAGE_RANGE_2_CAL_CONSTANTS_LEN] = {0};

// Length of data in characteristic "Voltage_Range_2_Cal_Constants" Value variable, initialized to minimal size.
static uint16_t ws_Voltage_Range_2_Cal_ConstantsValLen = WS_VOLTAGE_RANGE_2_CAL_CONSTANTS_LEN_MIN;

// Characteristic "Voltage_Range_3_Cal_Constants" Properties (for declaration)
static uint8_t ws_Voltage_Range_3_Cal_ConstantsProps = GATT_PROP_READ | GATT_PROP_WRITE;

// Characteristic "Voltage_Range_3_Cal_Constants" Value variable
static uint8_t ws_Voltage_Range_3_Cal_ConstantsVal[WS_VOLTAGE_RANGE_3_CAL_CONSTANTS_LEN] = {0};

// Length of data in characteristic "Voltage_Range_3_Cal_Constants" Value variable, initialized to minimal size.
static uint16_t ws_Voltage_Range_3_Cal_ConstantsValLen = WS_VOLTAGE_RANGE_3_CAL_CONSTANTS_LEN_MIN;

// Characteristic "Voltage_Range_4_Cal_Constants" Properties (for declaration)
static uint8_t ws_Voltage_Range_4_Cal_ConstantsProps = GATT_PROP_READ | GATT_PROP_WRITE;

// Characteristic "Voltage_Range_4_Cal_Constants" Value variable
static uint8_t ws_Voltage_Range_4_Cal_ConstantsVal[WS_VOLTAGE_RANGE_4_CAL_CONSTANTS_LEN] = {0};

// Length of data in characteristic "Voltage_Range_4_Cal_Constants" Value variable, initialized to minimal size.
static uint16_t ws_Voltage_Range_4_Cal_ConstantsValLen = WS_VOLTAGE_RANGE_4_CAL_CONSTANTS_LEN_MIN;

// Characteristic "Current_Range_1_Cal_Constants" Properties (for declaration)
static uint8_t ws_Current_Range_1_Cal_ConstantsProps = GATT_PROP_READ | GATT_PROP_WRITE;

// Characteristic "Current_Range_1_Cal_Constants" Value variable
static uint8_t ws_Current_Range_1_Cal_ConstantsVal[WS_CURRENT_RANGE_1_CAL_CONSTANTS_LEN] = {0};

// Length of data in characteristic "Current_Range_1_Cal_Constants" Value variable, initialized to minimal size.
static uint16_t ws_Current_Range_1_Cal_ConstantsValLen = WS_CURRENT_RANGE_1_CAL_CONSTANTS_LEN_MIN;

// Characteristic "Current_Range_2_Cal_Constants" Properties (for declaration)
static uint8_t ws_Current_Range_2_Cal_ConstantsProps = GATT_PROP_READ | GATT_PROP_WRITE;

// Characteristic "Current_Range_2_Cal_Constants" Value variable
static uint8_t ws_Current_Range_2_Cal_ConstantsVal[WS_CURRENT_RANGE_2_CAL_CONSTANTS_LEN] = {0};

// Length of data in characteristic "Current_Range_2_Cal_Constants" Value variable, initialized to minimal size.
static uint16_t ws_Current_Range_2_Cal_ConstantsValLen = WS_CURRENT_RANGE_2_CAL_CONSTANTS_LEN_MIN;

// Characteristic "Initiate_Power_Down" Properties (for declaration)
static uint8_t ws_Initiate_Power_DownProps = GATT_PROP_WRITE;

// Characteristic "Initiate_Power_Down" Value variable
static uint8_t ws_Initiate_Power_DownVal[WS_INITIATE_POWER_DOWN_LEN] = {0};

// Length of data in characteristic "Initiate_Power_Down" Value variable, initialized to minimal size.
static uint16_t ws_Initiate_Power_DownValLen = WS_INITIATE_POWER_DOWN_LEN_MIN;

// Characteristic "Voltage_Range_Select" Properties (for declaration)
static uint8_t ws_Voltage_Range_SelectProps = GATT_PROP_WRITE;

// Characteristic "Voltage_Range_Select" Value variable
static uint8_t ws_Voltage_Range_SelectVal[WS_VOLTAGE_RANGE_SELECT_LEN] = {0};

// Length of data in characteristic "Voltage_Range_Select" Value variable, initialized to minimal size.
static uint16_t ws_Voltage_Range_SelectValLen = WS_VOLTAGE_RANGE_SELECT_LEN_MIN;

// Characteristic "Voltage_Range_Mode" Properties (for declaration)
static uint8_t ws_Voltage_Range_ModeProps = GATT_PROP_NOTIFY | GATT_PROP_READ;

// Characteristic "Voltage_Range_Mode" Value variable
static uint8_t ws_Voltage_Range_ModeVal[WS_VOLTAGE_RANGE_MODE_LEN] = {0};

// Length of data in characteristic "Voltage_Range_Mode" Value variable, initialized to minimal size.
static uint16_t ws_Voltage_Range_ModeValLen = WS_VOLTAGE_RANGE_MODE_LEN_MIN;

// Characteristic "Voltage_Range_Mode" CCCD
static gattCharCfg_t *ws_Voltage_Range_ModeConfig;

// Characteristic "Measurement_Mode" Properties (for declaration)
static uint8_t ws_Measurement_ModeProps = GATT_PROP_NOTIFY | GATT_PROP_READ;

// Characteristic "Measurement_Mode" Value variable
static uint8_t ws_Measurement_ModeVal[WS_MEASUREMENT_MODE_LEN] = {0};

// Length of data in characteristic "Measurement_Mode" Value variable, initialized to minimal size.
static uint16_t ws_Measurement_ModeValLen = WS_MEASUREMENT_MODE_LEN_MIN;

// Characteristic "Measurement_Mode" CCCD
static gattCharCfg_t *ws_Measurement_ModeConfig;

// Characteristic "Current_Range_Select" Properties (for declaration)
static uint8_t ws_Current_Range_SelectProps = GATT_PROP_WRITE;

// Characteristic "Current_Range_Select" Value variable
static uint8_t ws_Current_Range_SelectVal[WS_CURRENT_RANGE_SELECT_LEN] = {0};

// Length of data in characteristic "Current_Range_Select" Value variable, initialized to minimal size.
static uint16_t ws_Current_Range_SelectValLen = WS_CURRENT_RANGE_SELECT_LEN_MIN;

// Characteristic "Battery Capacity Level" Properties (for declaration)
static uint8_t ws_Battery_Capacity_LevelProps = GATT_PROP_NOTIFY | GATT_PROP_READ;

// Characteristic "Battery Capacity Level" Value variable
static uint8_t ws_Battery_Capacity_LevelVal[WS_BATTERY_CAPACITY_LEVEL_LEN] = {0};

// Length of data in characteristic "Battery Capacity Level" Value variable, initialized to minimal size.
static uint16_t ws_Battery_Capacity_LevelValLen = WS_BATTERY_CAPACITY_LEVEL_LEN_MIN;

// Characteristic "Battery Capacity Level" CCCD
static gattCharCfg_t *ws_Battery_Capacity_LevelConfig;

// Characteristic "Battery Voltage Level" Properties (for declaration)
static uint8_t ws_Battery_Voltage_LevelProps = GATT_PROP_NOTIFY | GATT_PROP_READ;

// Characteristic "Battery Voltage Level" Value variable
static uint8_t ws_Battery_Voltage_LevelVal[WS_BATTERY_VOLTAGE_LEVEL_LEN] = {0};

// Length of data in characteristic "Battery Voltage Level" Value variable, initialized to minimal size.
static uint16_t ws_Battery_Voltage_LevelValLen = WS_BATTERY_VOLTAGE_LEVEL_LEN_MIN;

// Characteristic "Battery Voltage Level" CCCD
static gattCharCfg_t *ws_Battery_Voltage_LevelConfig;

// Characteristic "CapTIvate Sensing" Properties (for declaration)
static uint8_t ws_CapTIvate_SensingProps = GATT_PROP_NOTIFY | GATT_PROP_READ;

// Characteristic "CapTIvate Sensing" Value variable
static uint8_t ws_CapTIvate_SensingVal[WS_CAPTIVATE_SENSING_LEN] = {0};

// Length of data in characteristic "CapTIvate Sensing" Value variable, initialized to minimal size.
static uint16_t ws_CapTIvate_SensingValLen = WS_CAPTIVATE_SENSING_LEN_MIN;

// Characteristic "CapTIvate Sensing" CCCD
static gattCharCfg_t *ws_CapTIvate_SensingConfig;

// Characteristic "Sampling_Rate_Select" Properties (for declaration)
static uint8_t ws_Sampling_Rate_SelectProps = GATT_PROP_WRITE;

// Characteristic "Sampling_Rate_Select" Value variable
static uint8_t ws_Sampling_Rate_SelectVal[WS_SAMPLING_RATE_SELECT_LEN] = {0};

// Length of data in characteristic "Sampling_Rate_Select" Value variable, initialized to minimal size.
static uint16_t ws_Sampling_Rate_SelectValLen = WS_SAMPLING_RATE_SELECT_LEN_MIN;

// Characteristic "Reporting_Rate_Select" Properties (for declaration)
static uint8_t ws_Reporting_Rate_SelectProps = GATT_PROP_WRITE;

// Characteristic "Reporting_Rate_Select" Value variable
static uint8_t ws_Reporting_Rate_SelectVal[WS_REPORTING_RATE_SELECT_LEN] = {0};

// Length of data in characteristic "Reporting_Rate_Select" Value variable, initialized to minimal size.
static uint16_t ws_Reporting_Rate_SelectValLen = WS_REPORTING_RATE_SELECT_LEN_MIN;

// Characteristic "Temp_Comp_V1" Properties (for declaration)
static uint8_t ws_Temp_Comp_V1Props = GATT_PROP_READ | GATT_PROP_WRITE;

// Characteristic "Temp_Comp_V1" Value variable
static uint8_t ws_Temp_Comp_V1Val[WS_TEMP_COMP_V1_LEN] = {0};

// Length of data in characteristic "Temp_Comp_V1" Value variable, initialized to minimal size.
static uint16_t ws_Temp_Comp_V1ValLen = WS_TEMP_COMP_V1_LEN_MIN;

// Characteristic "Temp_Comp_V2" Properties (for declaration)
static uint8_t ws_Temp_Comp_V2Props = GATT_PROP_READ | GATT_PROP_WRITE;

// Characteristic "Temp_Comp_V2" Value variable
static uint8_t ws_Temp_Comp_V2Val[WS_TEMP_COMP_V2_LEN] = {0};

// Length of data in characteristic "Temp_Comp_V2" Value variable, initialized to minimal size.
static uint16_t ws_Temp_Comp_V2ValLen = WS_TEMP_COMP_V2_LEN_MIN;

// Characteristic "Temp_Comp_V3" Properties (for declaration)
static uint8_t ws_Temp_Comp_V3Props = GATT_PROP_READ | GATT_PROP_WRITE;

// Characteristic "Temp_Comp_V3" Value variable
static uint8_t ws_Temp_Comp_V3Val[WS_TEMP_COMP_V3_LEN] = {0};

// Length of data in characteristic "Temp_Comp_V3" Value variable, initialized to minimal size.
static uint16_t ws_Temp_Comp_V3ValLen = WS_TEMP_COMP_V3_LEN_MIN;

// Characteristic "Temp_Comp_V4" Properties (for declaration)
static uint8_t ws_Temp_Comp_V4Props = GATT_PROP_READ | GATT_PROP_WRITE;

// Characteristic "Temp_Comp_V4" Value variable
static uint8_t ws_Temp_Comp_V4Val[WS_TEMP_COMP_V4_LEN] = {0};

// Length of data in characteristic "Temp_Comp_V4" Value variable, initialized to minimal size.
static uint16_t ws_Temp_Comp_V4ValLen = WS_TEMP_COMP_V4_LEN_MIN;

// Characteristic "Temp_Comp_I1" Properties (for declaration)
static uint8_t ws_Temp_Comp_I1Props = GATT_PROP_READ | GATT_PROP_WRITE;

// Characteristic "Temp_Comp_I1" Value variable
static uint8_t ws_Temp_Comp_I1Val[WS_TEMP_COMP_I1_LEN] = {0};

// Length of data in characteristic "Temp_Comp_I1" Value variable, initialized to minimal size.
static uint16_t ws_Temp_Comp_I1ValLen = WS_TEMP_COMP_I1_LEN_MIN;

// Characteristic "Temp_Comp_I2" Properties (for declaration)
static uint8_t ws_Temp_Comp_I2Props = GATT_PROP_READ | GATT_PROP_WRITE;

// Characteristic "Temp_Comp_I2" Value variable
static uint8_t ws_Temp_Comp_I2Val[WS_TEMP_COMP_I2_LEN] = {0};

// Length of data in characteristic "Temp_Comp_I2" Value variable, initialized to minimal size.
static uint16_t ws_Temp_Comp_I2ValLen = WS_TEMP_COMP_I2_LEN_MIN;

// Characteristic "Reserved_1" Properties (for declaration)
static uint8_t ws_Reserved_1Props = GATT_PROP_NOTIFY | GATT_PROP_READ;

// Characteristic "Reserved_1" Value variable
static uint8_t ws_Reserved_1Val[WS_RESERVED_1_LEN] = {0};

// Length of data in characteristic "Reserved_1" Value variable, initialized to minimal size.
static uint16_t ws_Reserved_1ValLen = WS_RESERVED_1_LEN_MIN;

// Characteristic "Reserved_1" CCCD
static gattCharCfg_t *ws_Reserved_1Config;

// Characteristic "Reserved_2" Properties (for declaration)
static uint8_t ws_Reserved_2Props = GATT_PROP_NOTIFY | GATT_PROP_READ;

// Characteristic "Reserved_2" Value variable
static uint8_t ws_Reserved_2Val[WS_RESERVED_2_LEN] = {0};

// Length of data in characteristic "Reserved_2" Value variable, initialized to minimal size.
static uint16_t ws_Reserved_2ValLen = WS_RESERVED_2_LEN_MIN;

// Characteristic "Reserved_2" CCCD
static gattCharCfg_t *ws_Reserved_2Config;

/*********************************************************************
* Profile Attributes - Table
*/

static gattAttribute_t WDMM_ServiceAttrTbl[] = 
{
  // WDMM_Service Service Declaration
  {
    { ATT_BT_UUID_SIZE, primaryServiceUUID },
    GATT_PERMIT_READ,
    0,
    (uint8_t *)&WdmmServiceDecl
  },
    // DC_Reading Characteristic Declaration
    {
      { ATT_BT_UUID_SIZE, characterUUID },
      GATT_PERMIT_READ,
      0,
      &ws_DC_ReadingProps
    },
      // DC_Reading Characteristic Value
      {
        { ATT_UUID_SIZE, ws_DC_ReadingUUID },
        GATT_PERMIT_READ | GATT_PERMIT_READ,
        0,
        ws_DC_ReadingVal
      },
      // DC_Reading CCCD
      {
        { ATT_BT_UUID_SIZE, clientCharCfgUUID },
        GATT_PERMIT_READ | GATT_PERMIT_WRITE,
        0,
        (uint8_t *)&ws_DC_ReadingConfig
      },
    // AC_Reading Characteristic Declaration
    {
      { ATT_BT_UUID_SIZE, characterUUID },
      GATT_PERMIT_READ,
      0,
      &ws_AC_ReadingProps
    },
      // AC_Reading Characteristic Value
      {
        { ATT_UUID_SIZE, ws_AC_ReadingUUID },
        GATT_PERMIT_READ | GATT_PERMIT_READ,
        0,
        ws_AC_ReadingVal
      },
      // AC_Reading CCCD
      {
        { ATT_BT_UUID_SIZE, clientCharCfgUUID },
        GATT_PERMIT_READ | GATT_PERMIT_WRITE,
        0,
        (uint8_t *)&ws_AC_ReadingConfig
      },
    // Voltage_Range_1_Cal_Constants Characteristic Declaration
    {
      { ATT_BT_UUID_SIZE, characterUUID },
      GATT_PERMIT_READ,
      0,
      &ws_Voltage_Range_1_Cal_ConstantsProps
    },
      // Voltage_Range_1_Cal_Constants Characteristic Value
      {
        { ATT_UUID_SIZE, ws_Voltage_Range_1_Cal_ConstantsUUID },
        GATT_PERMIT_READ | GATT_PERMIT_WRITE,
        0,
        ws_Voltage_Range_1_Cal_ConstantsVal
      },
    // Voltage_Range_2_Cal_Constants Characteristic Declaration
    {
      { ATT_BT_UUID_SIZE, characterUUID },
      GATT_PERMIT_READ,
      0,
      &ws_Voltage_Range_2_Cal_ConstantsProps
    },
      // Voltage_Range_2_Cal_Constants Characteristic Value
      {
        { ATT_UUID_SIZE, ws_Voltage_Range_2_Cal_ConstantsUUID },
        GATT_PERMIT_READ | GATT_PERMIT_WRITE,
        0,
        ws_Voltage_Range_2_Cal_ConstantsVal
      },
    // Voltage_Range_3_Cal_Constants Characteristic Declaration
    {
      { ATT_BT_UUID_SIZE, characterUUID },
      GATT_PERMIT_READ,
      0,
      &ws_Voltage_Range_3_Cal_ConstantsProps
    },
      // Voltage_Range_3_Cal_Constants Characteristic Value
      {
        { ATT_UUID_SIZE, ws_Voltage_Range_3_Cal_ConstantsUUID },
        GATT_PERMIT_READ | GATT_PERMIT_WRITE,
        0,
        ws_Voltage_Range_3_Cal_ConstantsVal
      },
    // Voltage_Range_4_Cal_Constants Characteristic Declaration
    {
      { ATT_BT_UUID_SIZE, characterUUID },
      GATT_PERMIT_READ,
      0,
      &ws_Voltage_Range_4_Cal_ConstantsProps
    },
      // Voltage_Range_4_Cal_Constants Characteristic Value
      {
        { ATT_UUID_SIZE, ws_Voltage_Range_4_Cal_ConstantsUUID },
        GATT_PERMIT_READ | GATT_PERMIT_WRITE,
        0,
        ws_Voltage_Range_4_Cal_ConstantsVal
      },
    // Current_Range_1_Cal_Constants Characteristic Declaration
    {
      { ATT_BT_UUID_SIZE, characterUUID },
      GATT_PERMIT_READ,
      0,
      &ws_Current_Range_1_Cal_ConstantsProps
    },
      // Current_Range_1_Cal_Constants Characteristic Value
      {
        { ATT_UUID_SIZE, ws_Current_Range_1_Cal_ConstantsUUID },
        GATT_PERMIT_READ | GATT_PERMIT_WRITE,
        0,
        ws_Current_Range_1_Cal_ConstantsVal
      },
    // Current_Range_2_Cal_Constants Characteristic Declaration
    {
      { ATT_BT_UUID_SIZE, characterUUID },
      GATT_PERMIT_READ,
      0,
      &ws_Current_Range_2_Cal_ConstantsProps
    },
      // Current_Range_2_Cal_Constants Characteristic Value
      {
        { ATT_UUID_SIZE, ws_Current_Range_2_Cal_ConstantsUUID },
        GATT_PERMIT_READ | GATT_PERMIT_WRITE,
        0,
        ws_Current_Range_2_Cal_ConstantsVal
      },
    // Initiate_Power_Down Characteristic Declaration
    {
      { ATT_BT_UUID_SIZE, characterUUID },
      GATT_PERMIT_READ,
      0,
      &ws_Initiate_Power_DownProps
    },
      // Initiate_Power_Down Characteristic Value
      {
        { ATT_UUID_SIZE, ws_Initiate_Power_DownUUID },
        GATT_PERMIT_WRITE,
        0,
        ws_Initiate_Power_DownVal
      },
    // Voltage_Range_Select Characteristic Declaration
    {
      { ATT_BT_UUID_SIZE, characterUUID },
      GATT_PERMIT_READ,
      0,
      &ws_Voltage_Range_SelectProps
    },
      // Voltage_Range_Select Characteristic Value
      {
        { ATT_UUID_SIZE, ws_Voltage_Range_SelectUUID },
        GATT_PERMIT_WRITE,
        0,
        ws_Voltage_Range_SelectVal
      },
    // Voltage_Range_Mode Characteristic Declaration
    {
      { ATT_BT_UUID_SIZE, characterUUID },
      GATT_PERMIT_READ,
      0,
      &ws_Voltage_Range_ModeProps
    },
      // Voltage_Range_Mode Characteristic Value
      {
        { ATT_UUID_SIZE, ws_Voltage_Range_ModeUUID },
        GATT_PERMIT_READ | GATT_PERMIT_READ,
        0,
        ws_Voltage_Range_ModeVal
      },
      // Voltage_Range_Mode CCCD
      {
        { ATT_BT_UUID_SIZE, clientCharCfgUUID },
        GATT_PERMIT_READ | GATT_PERMIT_WRITE,
        0,
        (uint8_t *)&ws_Voltage_Range_ModeConfig
      },
    // Measurement_Mode Characteristic Declaration
    {
      { ATT_BT_UUID_SIZE, characterUUID },
      GATT_PERMIT_READ,
      0,
      &ws_Measurement_ModeProps
    },
      // Measurement_Mode Characteristic Value
      {
        { ATT_UUID_SIZE, ws_Measurement_ModeUUID },
        GATT_PERMIT_READ | GATT_PERMIT_READ,
        0,
        ws_Measurement_ModeVal
      },
      // Measurement_Mode CCCD
      {
        { ATT_BT_UUID_SIZE, clientCharCfgUUID },
        GATT_PERMIT_READ | GATT_PERMIT_WRITE,
        0,
        (uint8_t *)&ws_Measurement_ModeConfig
      },
    // Current_Range_Select Characteristic Declaration
    {
      { ATT_BT_UUID_SIZE, characterUUID },
      GATT_PERMIT_READ,
      0,
      &ws_Current_Range_SelectProps
    },
      // Current_Range_Select Characteristic Value
      {
        { ATT_UUID_SIZE, ws_Current_Range_SelectUUID },
        GATT_PERMIT_WRITE,
        0,
        ws_Current_Range_SelectVal
      },
    // Battery Capacity Level Characteristic Declaration
    {
      { ATT_BT_UUID_SIZE, characterUUID },
      GATT_PERMIT_READ,
      0,
      &ws_Battery_Capacity_LevelProps
    },
      // Battery Capacity Level Characteristic Value
      {
        { ATT_UUID_SIZE, ws_Battery_Capacity_LevelUUID },
        GATT_PERMIT_READ | GATT_PERMIT_READ,
        0,
        ws_Battery_Capacity_LevelVal
      },
      // Battery Capacity Level CCCD
      {
        { ATT_BT_UUID_SIZE, clientCharCfgUUID },
        GATT_PERMIT_READ | GATT_PERMIT_WRITE,
        0,
        (uint8_t *)&ws_Battery_Capacity_LevelConfig
      },
    // Battery Voltage Level Characteristic Declaration
    {
      { ATT_BT_UUID_SIZE, characterUUID },
      GATT_PERMIT_READ,
      0,
      &ws_Battery_Voltage_LevelProps
    },
      // Battery Voltage Level Characteristic Value
      {
        { ATT_UUID_SIZE, ws_Battery_Voltage_LevelUUID },
        GATT_PERMIT_READ | GATT_PERMIT_READ,
        0,
        ws_Battery_Voltage_LevelVal
      },
      // Battery Voltage Level CCCD
      {
        { ATT_BT_UUID_SIZE, clientCharCfgUUID },
        GATT_PERMIT_READ | GATT_PERMIT_WRITE,
        0,
        (uint8_t *)&ws_Battery_Voltage_LevelConfig
      },
    // CapTIvate Sensing Characteristic Declaration
    {
      { ATT_BT_UUID_SIZE, characterUUID },
      GATT_PERMIT_READ,
      0,
      &ws_CapTIvate_SensingProps
    },
      // CapTIvate Sensing Characteristic Value
      {
        { ATT_UUID_SIZE, ws_CapTIvate_SensingUUID },
        GATT_PERMIT_READ | GATT_PERMIT_READ,
        0,
        ws_CapTIvate_SensingVal
      },
      // CapTIvate Sensing CCCD
      {
        { ATT_BT_UUID_SIZE, clientCharCfgUUID },
        GATT_PERMIT_READ | GATT_PERMIT_WRITE,
        0,
        (uint8_t *)&ws_CapTIvate_SensingConfig
      },
    // Sampling_Rate_Select Characteristic Declaration
    {
      { ATT_BT_UUID_SIZE, characterUUID },
      GATT_PERMIT_READ,
      0,
      &ws_Sampling_Rate_SelectProps
    },
      // Sampling_Rate_Select Characteristic Value
      {
        { ATT_UUID_SIZE, ws_Sampling_Rate_SelectUUID },
        GATT_PERMIT_WRITE,
        0,
        ws_Sampling_Rate_SelectVal
      },
    // Reporting_Rate_Select Characteristic Declaration
    {
      { ATT_BT_UUID_SIZE, characterUUID },
      GATT_PERMIT_READ,
      0,
      &ws_Reporting_Rate_SelectProps
    },
      // Reporting_Rate_Select Characteristic Value
      {
        { ATT_UUID_SIZE, ws_Reporting_Rate_SelectUUID },
        GATT_PERMIT_WRITE,
        0,
        ws_Reporting_Rate_SelectVal
      },
    // Temp_Comp_V1 Characteristic Declaration
    {
      { ATT_BT_UUID_SIZE, characterUUID },
      GATT_PERMIT_READ,
      0,
      &ws_Temp_Comp_V1Props
    },
      // Temp_Comp_V1 Characteristic Value
      {
        { ATT_UUID_SIZE, ws_Temp_Comp_V1UUID },
        GATT_PERMIT_READ | GATT_PERMIT_WRITE,
        0,
        ws_Temp_Comp_V1Val
      },
    // Temp_Comp_V2 Characteristic Declaration
    {
      { ATT_BT_UUID_SIZE, characterUUID },
      GATT_PERMIT_READ,
      0,
      &ws_Temp_Comp_V2Props
    },
      // Temp_Comp_V2 Characteristic Value
      {
        { ATT_UUID_SIZE, ws_Temp_Comp_V2UUID },
        GATT_PERMIT_READ | GATT_PERMIT_WRITE,
        0,
        ws_Temp_Comp_V2Val
      },
    // Temp_Comp_V3 Characteristic Declaration
    {
      { ATT_BT_UUID_SIZE, characterUUID },
      GATT_PERMIT_READ,
      0,
      &ws_Temp_Comp_V3Props
    },
      // Temp_Comp_V3 Characteristic Value
      {
        { ATT_UUID_SIZE, ws_Temp_Comp_V3UUID },
        GATT_PERMIT_READ | GATT_PERMIT_WRITE,
        0,
        ws_Temp_Comp_V3Val
      },
    // Temp_Comp_V4 Characteristic Declaration
    {
      { ATT_BT_UUID_SIZE, characterUUID },
      GATT_PERMIT_READ,
      0,
      &ws_Temp_Comp_V4Props
    },
      // Temp_Comp_V4 Characteristic Value
      {
        { ATT_UUID_SIZE, ws_Temp_Comp_V4UUID },
        GATT_PERMIT_READ | GATT_PERMIT_WRITE,
        0,
        ws_Temp_Comp_V4Val
      },
    // Temp_Comp_I1 Characteristic Declaration
    {
      { ATT_BT_UUID_SIZE, characterUUID },
      GATT_PERMIT_READ,
      0,
      &ws_Temp_Comp_I1Props
    },
      // Temp_Comp_I1 Characteristic Value
      {
        { ATT_UUID_SIZE, ws_Temp_Comp_I1UUID },
        GATT_PERMIT_READ | GATT_PERMIT_WRITE,
        0,
        ws_Temp_Comp_I1Val
      },
    // Temp_Comp_I2 Characteristic Declaration
    {
      { ATT_BT_UUID_SIZE, characterUUID },
      GATT_PERMIT_READ,
      0,
      &ws_Temp_Comp_I2Props
    },
      // Temp_Comp_I2 Characteristic Value
      {
        { ATT_UUID_SIZE, ws_Temp_Comp_I2UUID },
        GATT_PERMIT_READ | GATT_PERMIT_WRITE,
        0,
        ws_Temp_Comp_I2Val
      },
    // Reserved_1 Characteristic Declaration
    {
      { ATT_BT_UUID_SIZE, characterUUID },
      GATT_PERMIT_READ,
      0,
      &ws_Reserved_1Props
    },
      // Reserved_1 Characteristic Value
      {
        { ATT_UUID_SIZE, ws_Reserved_1UUID },
        GATT_PERMIT_READ | GATT_PERMIT_READ,
        0,
        ws_Reserved_1Val
      },
      // Reserved_1 CCCD
      {
        { ATT_BT_UUID_SIZE, clientCharCfgUUID },
        GATT_PERMIT_READ | GATT_PERMIT_WRITE,
        0,
        (uint8_t *)&ws_Reserved_1Config
      },
    // Reserved_2 Characteristic Declaration
    {
      { ATT_BT_UUID_SIZE, characterUUID },
      GATT_PERMIT_READ,
      0,
      &ws_Reserved_2Props
    },
      // Reserved_2 Characteristic Value
      {
        { ATT_UUID_SIZE, ws_Reserved_2UUID },
        GATT_PERMIT_READ | GATT_PERMIT_READ,
        0,
        ws_Reserved_2Val
      },
      // Reserved_2 CCCD
      {
        { ATT_BT_UUID_SIZE, clientCharCfgUUID },
        GATT_PERMIT_READ | GATT_PERMIT_WRITE,
        0,
        (uint8_t *)&ws_Reserved_2Config
      },
};

/*********************************************************************
 * LOCAL FUNCTIONS
 */
static bStatus_t WDMM_Service_ReadAttrCB( uint16_t connHandle, gattAttribute_t *pAttr, 
                                           uint8_t *pValue, uint16_t *pLen, uint16_t offset,
                                           uint16_t maxLen, uint8_t method );
static bStatus_t WDMM_Service_WriteAttrCB( uint16_t connHandle, gattAttribute_t *pAttr,
                                            uint8_t *pValue, uint16_t len, uint16_t offset,
                                            uint8_t method );

/*********************************************************************
 * PROFILE CALLBACKS
 */
// Simple Profile Service Callbacks
CONST gattServiceCBs_t WDMM_ServiceCBs =
{
  WDMM_Service_ReadAttrCB,  // Read callback function pointer
  WDMM_Service_WriteAttrCB, // Write callback function pointer
  NULL                       // Authorization callback function pointer
};

/*********************************************************************
* PUBLIC FUNCTIONS
*/

/*
 * WdmmService_AddService- Initializes the WdmmService service by registering
 *          GATT attributes with the GATT server.
 *
 */
bStatus_t WdmmService_AddService( void )
{
  uint8_t status;

  // Allocate Client Characteristic Configuration table
  ws_DC_ReadingConfig = (gattCharCfg_t *)ICall_malloc( sizeof(gattCharCfg_t) * linkDBNumConns );
  if ( ws_DC_ReadingConfig == NULL )
  {     
    return ( bleMemAllocError );
  }
  
  // Initialize Client Characteristic Configuration attributes
  GATTServApp_InitCharCfg( INVALID_CONNHANDLE, ws_DC_ReadingConfig );
  // Allocate Client Characteristic Configuration table
  ws_AC_ReadingConfig = (gattCharCfg_t *)ICall_malloc( sizeof(gattCharCfg_t) * linkDBNumConns );
  if ( ws_AC_ReadingConfig == NULL )
  {     
    return ( bleMemAllocError );
  }
  
  // Initialize Client Characteristic Configuration attributes
  GATTServApp_InitCharCfg( INVALID_CONNHANDLE, ws_AC_ReadingConfig );
  // Allocate Client Characteristic Configuration table
  ws_Voltage_Range_ModeConfig = (gattCharCfg_t *)ICall_malloc( sizeof(gattCharCfg_t) * linkDBNumConns );
  if ( ws_Voltage_Range_ModeConfig == NULL )
  {     
    return ( bleMemAllocError );
  }
  
  // Initialize Client Characteristic Configuration attributes
  GATTServApp_InitCharCfg( INVALID_CONNHANDLE, ws_Voltage_Range_ModeConfig );
  // Allocate Client Characteristic Configuration table
  ws_Measurement_ModeConfig = (gattCharCfg_t *)ICall_malloc( sizeof(gattCharCfg_t) * linkDBNumConns );
  if ( ws_Measurement_ModeConfig == NULL )
  {     
    return ( bleMemAllocError );
  }
  
  // Initialize Client Characteristic Configuration attributes
  GATTServApp_InitCharCfg( INVALID_CONNHANDLE, ws_Measurement_ModeConfig );
  // Allocate Client Characteristic Configuration table
  ws_Battery_Capacity_LevelConfig = (gattCharCfg_t *)ICall_malloc( sizeof(gattCharCfg_t) * linkDBNumConns );
  if ( ws_Battery_Capacity_LevelConfig == NULL )
  {     
    return ( bleMemAllocError );
  }
  
  // Initialize Client Characteristic Configuration attributes
  GATTServApp_InitCharCfg( INVALID_CONNHANDLE, ws_Battery_Capacity_LevelConfig );
  // Allocate Client Characteristic Configuration table
  ws_Battery_Voltage_LevelConfig = (gattCharCfg_t *)ICall_malloc( sizeof(gattCharCfg_t) * linkDBNumConns );
  if ( ws_Battery_Voltage_LevelConfig == NULL )
  {     
    return ( bleMemAllocError );
  }
  
  // Initialize Client Characteristic Configuration attributes
  GATTServApp_InitCharCfg( INVALID_CONNHANDLE, ws_Battery_Voltage_LevelConfig );
  // Allocate Client Characteristic Configuration table
  ws_CapTIvate_SensingConfig = (gattCharCfg_t *)ICall_malloc( sizeof(gattCharCfg_t) * linkDBNumConns );
  if ( ws_CapTIvate_SensingConfig == NULL )
  {     
    return ( bleMemAllocError );
  }
  
  // Initialize Client Characteristic Configuration attributes
  GATTServApp_InitCharCfg( INVALID_CONNHANDLE, ws_CapTIvate_SensingConfig );
  // Allocate Client Characteristic Configuration table
  ws_Reserved_1Config = (gattCharCfg_t *)ICall_malloc( sizeof(gattCharCfg_t) * linkDBNumConns );
  if ( ws_Reserved_1Config == NULL )
  {     
    return ( bleMemAllocError );
  }
  
  // Initialize Client Characteristic Configuration attributes
  GATTServApp_InitCharCfg( INVALID_CONNHANDLE, ws_Reserved_1Config );
  // Allocate Client Characteristic Configuration table
  ws_Reserved_2Config = (gattCharCfg_t *)ICall_malloc( sizeof(gattCharCfg_t) * linkDBNumConns );
  if ( ws_Reserved_2Config == NULL )
  {     
    return ( bleMemAllocError );
  }
  
  // Initialize Client Characteristic Configuration attributes
  GATTServApp_InitCharCfg( INVALID_CONNHANDLE, ws_Reserved_2Config );
  // Register GATT attribute list and CBs with GATT Server App
  status = GATTServApp_RegisterService( WDMM_ServiceAttrTbl, 
                                        GATT_NUM_ATTRS( WDMM_ServiceAttrTbl ),
                                        GATT_MAX_ENCRYPT_KEY_SIZE,
                                        &WDMM_ServiceCBs );

  return ( status );
}

/*
 * WdmmService_RegisterAppCBs - Registers the application callback function.
 *                    Only call this function once.
 *
 *    appCallbacks - pointer to application callbacks.
 */
bStatus_t WdmmService_RegisterAppCBs( WdmmServiceCBs_t *appCallbacks )
{
  if ( appCallbacks )
  {
    pAppCBs = appCallbacks;
    
    return ( SUCCESS );
  }
  else
  {
    return ( bleAlreadyInRequestedMode );
  }
}

/*
 * WdmmService_SetParameter - Set a WdmmService parameter.
 *
 *    param - Profile parameter ID
 *    len   - length of data to write
 *    value - pointer to data to write.  This is dependent on
 *            the parameter ID and may be cast to the appropriate 
 *            data type (example: data type of uint16_t will be cast to 
 *            uint16_t pointer).
 */
bStatus_t WdmmService_SetParameter( uint8_t param, uint16_t len, void *value )
{
  bStatus_t ret = SUCCESS;
  switch ( param )
  {
    case WS_DC_READING_ID:
      if ( len <= WS_DC_READING_LEN &&
           len >= WS_DC_READING_LEN_MIN ) 
      {
        memcpy(ws_DC_ReadingVal, value, len);
        ws_DC_ReadingValLen = len; // Update length for read and get.

        // Try to send notification.
        GATTServApp_ProcessCharCfg( ws_DC_ReadingConfig, (uint8_t *)&ws_DC_ReadingVal, FALSE,
                                    WDMM_ServiceAttrTbl, GATT_NUM_ATTRS( WDMM_ServiceAttrTbl ),
                                    INVALID_TASK_ID,  WDMM_Service_ReadAttrCB);
      }
      else
      {
        ret = bleInvalidRange;
      }
      break;

    case WS_AC_READING_ID:
      if ( len <= WS_AC_READING_LEN &&
           len >= WS_AC_READING_LEN_MIN ) 
      {
        memcpy(ws_AC_ReadingVal, value, len);
        ws_AC_ReadingValLen = len; // Update length for read and get.

        // Try to send notification.
        GATTServApp_ProcessCharCfg( ws_AC_ReadingConfig, (uint8_t *)&ws_AC_ReadingVal, FALSE,
                                    WDMM_ServiceAttrTbl, GATT_NUM_ATTRS( WDMM_ServiceAttrTbl ),
                                    INVALID_TASK_ID,  WDMM_Service_ReadAttrCB);
      }
      else
      {
        ret = bleInvalidRange;
      }
      break;

    case WS_VOLTAGE_RANGE_1_CAL_CONSTANTS_ID:
      if ( len <= WS_VOLTAGE_RANGE_1_CAL_CONSTANTS_LEN &&
           len >= WS_VOLTAGE_RANGE_1_CAL_CONSTANTS_LEN_MIN ) 
      {
        memcpy(ws_Voltage_Range_1_Cal_ConstantsVal, value, len);
        ws_Voltage_Range_1_Cal_ConstantsValLen = len; // Update length for read and get.
      }
      else
      {
        ret = bleInvalidRange;
      }
      break;

    case WS_VOLTAGE_RANGE_2_CAL_CONSTANTS_ID:
      if ( len <= WS_VOLTAGE_RANGE_2_CAL_CONSTANTS_LEN &&
           len >= WS_VOLTAGE_RANGE_2_CAL_CONSTANTS_LEN_MIN ) 
      {
        memcpy(ws_Voltage_Range_2_Cal_ConstantsVal, value, len);
        ws_Voltage_Range_2_Cal_ConstantsValLen = len; // Update length for read and get.
      }
      else
      {
        ret = bleInvalidRange;
      }
      break;

    case WS_VOLTAGE_RANGE_3_CAL_CONSTANTS_ID:
      if ( len <= WS_VOLTAGE_RANGE_3_CAL_CONSTANTS_LEN &&
           len >= WS_VOLTAGE_RANGE_3_CAL_CONSTANTS_LEN_MIN ) 
      {
        memcpy(ws_Voltage_Range_3_Cal_ConstantsVal, value, len);
        ws_Voltage_Range_3_Cal_ConstantsValLen = len; // Update length for read and get.
      }
      else
      {
        ret = bleInvalidRange;
      }
      break;

    case WS_VOLTAGE_RANGE_4_CAL_CONSTANTS_ID:
      if ( len <= WS_VOLTAGE_RANGE_4_CAL_CONSTANTS_LEN &&
           len >= WS_VOLTAGE_RANGE_4_CAL_CONSTANTS_LEN_MIN ) 
      {
        memcpy(ws_Voltage_Range_4_Cal_ConstantsVal, value, len);
        ws_Voltage_Range_4_Cal_ConstantsValLen = len; // Update length for read and get.
      }
      else
      {
        ret = bleInvalidRange;
      }
      break;

    case WS_CURRENT_RANGE_1_CAL_CONSTANTS_ID:
      if ( len <= WS_CURRENT_RANGE_1_CAL_CONSTANTS_LEN &&
           len >= WS_CURRENT_RANGE_1_CAL_CONSTANTS_LEN_MIN ) 
      {
        memcpy(ws_Current_Range_1_Cal_ConstantsVal, value, len);
        ws_Current_Range_1_Cal_ConstantsValLen = len; // Update length for read and get.
      }
      else
      {
        ret = bleInvalidRange;
      }
      break;

    case WS_CURRENT_RANGE_2_CAL_CONSTANTS_ID:
      if ( len <= WS_CURRENT_RANGE_2_CAL_CONSTANTS_LEN &&
           len >= WS_CURRENT_RANGE_2_CAL_CONSTANTS_LEN_MIN ) 
      {
        memcpy(ws_Current_Range_2_Cal_ConstantsVal, value, len);
        ws_Current_Range_2_Cal_ConstantsValLen = len; // Update length for read and get.
      }
      else
      {
        ret = bleInvalidRange;
      }
      break;

    case WS_VOLTAGE_RANGE_MODE_ID:
      if ( len <= WS_VOLTAGE_RANGE_MODE_LEN &&
           len >= WS_VOLTAGE_RANGE_MODE_LEN_MIN ) 
      {
        memcpy(ws_Voltage_Range_ModeVal, value, len);
        ws_Voltage_Range_ModeValLen = len; // Update length for read and get.

        // Try to send notification.
        GATTServApp_ProcessCharCfg( ws_Voltage_Range_ModeConfig, (uint8_t *)&ws_Voltage_Range_ModeVal, FALSE,
                                    WDMM_ServiceAttrTbl, GATT_NUM_ATTRS( WDMM_ServiceAttrTbl ),
                                    INVALID_TASK_ID,  WDMM_Service_ReadAttrCB);
      }
      else
      {
        ret = bleInvalidRange;
      }
      break;

    case WS_MEASUREMENT_MODE_ID:
      if ( len <= WS_MEASUREMENT_MODE_LEN &&
           len >= WS_MEASUREMENT_MODE_LEN_MIN ) 
      {
        memcpy(ws_Measurement_ModeVal, value, len);
        ws_Measurement_ModeValLen = len; // Update length for read and get.

        // Try to send notification.
        GATTServApp_ProcessCharCfg( ws_Measurement_ModeConfig, (uint8_t *)&ws_Measurement_ModeVal, FALSE,
                                    WDMM_ServiceAttrTbl, GATT_NUM_ATTRS( WDMM_ServiceAttrTbl ),
                                    INVALID_TASK_ID,  WDMM_Service_ReadAttrCB);
      }
      else
      {
        ret = bleInvalidRange;
      }
      break;

    case WS_BATTERY_CAPACITY_LEVEL_ID:
      if ( len <= WS_BATTERY_CAPACITY_LEVEL_LEN &&
           len >= WS_BATTERY_CAPACITY_LEVEL_LEN_MIN ) 
      {
        memcpy(ws_Battery_Capacity_LevelVal, value, len);
        ws_Battery_Capacity_LevelValLen = len; // Update length for read and get.

        // Try to send notification.
        GATTServApp_ProcessCharCfg( ws_Battery_Capacity_LevelConfig, (uint8_t *)&ws_Battery_Capacity_LevelVal, FALSE,
                                    WDMM_ServiceAttrTbl, GATT_NUM_ATTRS( WDMM_ServiceAttrTbl ),
                                    INVALID_TASK_ID,  WDMM_Service_ReadAttrCB);
      }
      else
      {
        ret = bleInvalidRange;
      }
      break;

    case WS_BATTERY_VOLTAGE_LEVEL_ID:
      if ( len <= WS_BATTERY_VOLTAGE_LEVEL_LEN &&
           len >= WS_BATTERY_VOLTAGE_LEVEL_LEN_MIN ) 
      {
        memcpy(ws_Battery_Voltage_LevelVal, value, len);
        ws_Battery_Voltage_LevelValLen = len; // Update length for read and get.

        // Try to send notification.
        GATTServApp_ProcessCharCfg( ws_Battery_Voltage_LevelConfig, (uint8_t *)&ws_Battery_Voltage_LevelVal, FALSE,
                                    WDMM_ServiceAttrTbl, GATT_NUM_ATTRS( WDMM_ServiceAttrTbl ),
                                    INVALID_TASK_ID,  WDMM_Service_ReadAttrCB);
      }
      else
      {
        ret = bleInvalidRange;
      }
      break;

    case WS_CAPTIVATE_SENSING_ID:
      if ( len <= WS_CAPTIVATE_SENSING_LEN &&
           len >= WS_CAPTIVATE_SENSING_LEN_MIN ) 
      {
        memcpy(ws_CapTIvate_SensingVal, value, len);
        ws_CapTIvate_SensingValLen = len; // Update length for read and get.

        // Try to send notification.
        GATTServApp_ProcessCharCfg( ws_CapTIvate_SensingConfig, (uint8_t *)&ws_CapTIvate_SensingVal, FALSE,
                                    WDMM_ServiceAttrTbl, GATT_NUM_ATTRS( WDMM_ServiceAttrTbl ),
                                    INVALID_TASK_ID,  WDMM_Service_ReadAttrCB);
      }
      else
      {
        ret = bleInvalidRange;
      }
      break;

    case WS_TEMP_COMP_V1_ID:
      if ( len <= WS_TEMP_COMP_V1_LEN &&
           len >= WS_TEMP_COMP_V1_LEN_MIN ) 
      {
        memcpy(ws_Temp_Comp_V1Val, value, len);
        ws_Temp_Comp_V1ValLen = len; // Update length for read and get.
      }
      else
      {
        ret = bleInvalidRange;
      }
      break;

    case WS_TEMP_COMP_V2_ID:
      if ( len <= WS_TEMP_COMP_V2_LEN &&
           len >= WS_TEMP_COMP_V2_LEN_MIN ) 
      {
        memcpy(ws_Temp_Comp_V2Val, value, len);
        ws_Temp_Comp_V2ValLen = len; // Update length for read and get.
      }
      else
      {
        ret = bleInvalidRange;
      }
      break;

    case WS_TEMP_COMP_V3_ID:
      if ( len <= WS_TEMP_COMP_V3_LEN &&
           len >= WS_TEMP_COMP_V3_LEN_MIN ) 
      {
        memcpy(ws_Temp_Comp_V3Val, value, len);
        ws_Temp_Comp_V3ValLen = len; // Update length for read and get.
      }
      else
      {
        ret = bleInvalidRange;
      }
      break;

    case WS_TEMP_COMP_V4_ID:
      if ( len <= WS_TEMP_COMP_V4_LEN &&
           len >= WS_TEMP_COMP_V4_LEN_MIN ) 
      {
        memcpy(ws_Temp_Comp_V4Val, value, len);
        ws_Temp_Comp_V4ValLen = len; // Update length for read and get.
      }
      else
      {
        ret = bleInvalidRange;
      }
      break;

    case WS_TEMP_COMP_I1_ID:
      if ( len <= WS_TEMP_COMP_I1_LEN &&
           len >= WS_TEMP_COMP_I1_LEN_MIN ) 
      {
        memcpy(ws_Temp_Comp_I1Val, value, len);
        ws_Temp_Comp_I1ValLen = len; // Update length for read and get.
      }
      else
      {
        ret = bleInvalidRange;
      }
      break;

    case WS_TEMP_COMP_I2_ID:
      if ( len <= WS_TEMP_COMP_I2_LEN &&
           len >= WS_TEMP_COMP_I2_LEN_MIN ) 
      {
        memcpy(ws_Temp_Comp_I2Val, value, len);
        ws_Temp_Comp_I2ValLen = len; // Update length for read and get.
      }
      else
      {
        ret = bleInvalidRange;
      }
      break;

    case WS_RESERVED_1_ID:
      if ( len <= WS_RESERVED_1_LEN &&
           len >= WS_RESERVED_1_LEN_MIN ) 
      {
        memcpy(ws_Reserved_1Val, value, len);
        ws_Reserved_1ValLen = len; // Update length for read and get.

        // Try to send notification.
        GATTServApp_ProcessCharCfg( ws_Reserved_1Config, (uint8_t *)&ws_Reserved_1Val, FALSE,
                                    WDMM_ServiceAttrTbl, GATT_NUM_ATTRS( WDMM_ServiceAttrTbl ),
                                    INVALID_TASK_ID,  WDMM_Service_ReadAttrCB);
      }
      else
      {
        ret = bleInvalidRange;
      }
      break;

    case WS_RESERVED_2_ID:
      if ( len <= WS_RESERVED_2_LEN &&
           len >= WS_RESERVED_2_LEN_MIN ) 
      {
        memcpy(ws_Reserved_2Val, value, len);
        ws_Reserved_2ValLen = len; // Update length for read and get.

        // Try to send notification.
        GATTServApp_ProcessCharCfg( ws_Reserved_2Config, (uint8_t *)&ws_Reserved_2Val, FALSE,
                                    WDMM_ServiceAttrTbl, GATT_NUM_ATTRS( WDMM_ServiceAttrTbl ),
                                    INVALID_TASK_ID,  WDMM_Service_ReadAttrCB);
      }
      else
      {
        ret = bleInvalidRange;
      }
      break;

    default:
      ret = INVALIDPARAMETER;
      break;
  }
  return ret;
}


/*
 * WdmmService_GetParameter - Get a WdmmService parameter.
 *
 *    param - Profile parameter ID
 *    len   - pointer to a variable that contains the maximum length that can be written to *value.
              After the call, this value will contain the actual returned length.
 *    value - pointer to data to write.  This is dependent on
 *            the parameter ID and may be cast to the appropriate 
 *            data type (example: data type of uint16_t will be cast to 
 *            uint16_t pointer).
 */
bStatus_t WdmmService_GetParameter( uint8_t param, uint16_t *len, void *value )
{
  bStatus_t ret = SUCCESS;
  switch ( param )
  {
    case WS_VOLTAGE_RANGE_1_CAL_CONSTANTS_ID:
      *len = MIN(*len, ws_Voltage_Range_1_Cal_ConstantsValLen);
      memcpy(value, ws_Voltage_Range_1_Cal_ConstantsVal, *len);
      break;

    case WS_VOLTAGE_RANGE_2_CAL_CONSTANTS_ID:
      *len = MIN(*len, ws_Voltage_Range_2_Cal_ConstantsValLen);
      memcpy(value, ws_Voltage_Range_2_Cal_ConstantsVal, *len);
      break;

    case WS_VOLTAGE_RANGE_3_CAL_CONSTANTS_ID:
      *len = MIN(*len, ws_Voltage_Range_3_Cal_ConstantsValLen);
      memcpy(value, ws_Voltage_Range_3_Cal_ConstantsVal, *len);
      break;

    case WS_VOLTAGE_RANGE_4_CAL_CONSTANTS_ID:
      *len = MIN(*len, ws_Voltage_Range_4_Cal_ConstantsValLen);
      memcpy(value, ws_Voltage_Range_4_Cal_ConstantsVal, *len);
      break;

    case WS_CURRENT_RANGE_1_CAL_CONSTANTS_ID:
      *len = MIN(*len, ws_Current_Range_1_Cal_ConstantsValLen);
      memcpy(value, ws_Current_Range_1_Cal_ConstantsVal, *len);
      break;

    case WS_CURRENT_RANGE_2_CAL_CONSTANTS_ID:
      *len = MIN(*len, ws_Current_Range_2_Cal_ConstantsValLen);
      memcpy(value, ws_Current_Range_2_Cal_ConstantsVal, *len);
      break;

    case WS_INITIATE_POWER_DOWN_ID:
      *len = MIN(*len, ws_Initiate_Power_DownValLen);
      memcpy(value, ws_Initiate_Power_DownVal, *len);
      break;

    case WS_VOLTAGE_RANGE_SELECT_ID:
      *len = MIN(*len, ws_Voltage_Range_SelectValLen);
      memcpy(value, ws_Voltage_Range_SelectVal, *len);
      break;

    case WS_CURRENT_RANGE_SELECT_ID:
      *len = MIN(*len, ws_Current_Range_SelectValLen);
      memcpy(value, ws_Current_Range_SelectVal, *len);
      break;

    case WS_SAMPLING_RATE_SELECT_ID:
      *len = MIN(*len, ws_Sampling_Rate_SelectValLen);
      memcpy(value, ws_Sampling_Rate_SelectVal, *len);
      break;

    case WS_REPORTING_RATE_SELECT_ID:
      *len = MIN(*len, ws_Reporting_Rate_SelectValLen);
      memcpy(value, ws_Reporting_Rate_SelectVal, *len);
      break;

    case WS_TEMP_COMP_V1_ID:
      *len = MIN(*len, ws_Temp_Comp_V1ValLen);
      memcpy(value, ws_Temp_Comp_V1Val, *len);
      break;

    case WS_TEMP_COMP_V2_ID:
      *len = MIN(*len, ws_Temp_Comp_V2ValLen);
      memcpy(value, ws_Temp_Comp_V2Val, *len);
      break;

    case WS_TEMP_COMP_V3_ID:
      *len = MIN(*len, ws_Temp_Comp_V3ValLen);
      memcpy(value, ws_Temp_Comp_V3Val, *len);
      break;

    case WS_TEMP_COMP_V4_ID:
      *len = MIN(*len, ws_Temp_Comp_V4ValLen);
      memcpy(value, ws_Temp_Comp_V4Val, *len);
      break;

    case WS_TEMP_COMP_I1_ID:
      *len = MIN(*len, ws_Temp_Comp_I1ValLen);
      memcpy(value, ws_Temp_Comp_I1Val, *len);
      break;

    case WS_TEMP_COMP_I2_ID:
      *len = MIN(*len, ws_Temp_Comp_I2ValLen);
      memcpy(value, ws_Temp_Comp_I2Val, *len);
      break;

    default:
      ret = INVALIDPARAMETER;
      break;
  }
  return ret;
}


/*********************************************************************
 * @fn          WDMM_Service_ReadAttrCB
 *
 * @brief       Read an attribute.
 *
 * @param       connHandle - connection message was received on
 * @param       pAttr - pointer to attribute
 * @param       pValue - pointer to data to be read
 * @param       pLen - length of data to be read
 * @param       offset - offset of the first octet to be read
 * @param       maxLen - maximum length of data to be read
 * @param       method - type of read message
 *
 * @return      SUCCESS, blePending or Failure
 */
static bStatus_t WDMM_Service_ReadAttrCB( uint16_t connHandle, gattAttribute_t *pAttr, 
                                       uint8_t *pValue, uint16_t *pLen, uint16_t offset,
                                       uint16_t maxLen, uint8_t method )
{
  bStatus_t status = SUCCESS;

  // See if request is regarding the DC_Reading Characteristic Value
if ( ! memcmp(pAttr->type.uuid, ws_DC_ReadingUUID, pAttr->type.len) )
  {
    if ( offset > ws_DC_ReadingValLen )  // Prevent malicious ATT ReadBlob offsets.
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else
    {
      *pLen = MIN(maxLen, ws_DC_ReadingValLen - offset);  // Transmit as much as possible
      memcpy(pValue, pAttr->pValue + offset, *pLen);
    }
  }
  // See if request is regarding the AC_Reading Characteristic Value
else if ( ! memcmp(pAttr->type.uuid, ws_AC_ReadingUUID, pAttr->type.len) )
  {
    if ( offset > ws_AC_ReadingValLen )  // Prevent malicious ATT ReadBlob offsets.
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else
    {
      *pLen = MIN(maxLen, ws_AC_ReadingValLen - offset);  // Transmit as much as possible
      memcpy(pValue, pAttr->pValue + offset, *pLen);
    }
  }
  // See if request is regarding the Voltage_Range_1_Cal_Constants Characteristic Value
else if ( ! memcmp(pAttr->type.uuid, ws_Voltage_Range_1_Cal_ConstantsUUID, pAttr->type.len) )
  {
    if ( offset > ws_Voltage_Range_1_Cal_ConstantsValLen )  // Prevent malicious ATT ReadBlob offsets.
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else
    {
      *pLen = MIN(maxLen, ws_Voltage_Range_1_Cal_ConstantsValLen - offset);  // Transmit as much as possible
      memcpy(pValue, pAttr->pValue + offset, *pLen);
    }
  }
  // See if request is regarding the Voltage_Range_2_Cal_Constants Characteristic Value
else if ( ! memcmp(pAttr->type.uuid, ws_Voltage_Range_2_Cal_ConstantsUUID, pAttr->type.len) )
  {
    if ( offset > ws_Voltage_Range_2_Cal_ConstantsValLen )  // Prevent malicious ATT ReadBlob offsets.
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else
    {
      *pLen = MIN(maxLen, ws_Voltage_Range_2_Cal_ConstantsValLen - offset);  // Transmit as much as possible
      memcpy(pValue, pAttr->pValue + offset, *pLen);
    }
  }
  // See if request is regarding the Voltage_Range_3_Cal_Constants Characteristic Value
else if ( ! memcmp(pAttr->type.uuid, ws_Voltage_Range_3_Cal_ConstantsUUID, pAttr->type.len) )
  {
    if ( offset > ws_Voltage_Range_3_Cal_ConstantsValLen )  // Prevent malicious ATT ReadBlob offsets.
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else
    {
      *pLen = MIN(maxLen, ws_Voltage_Range_3_Cal_ConstantsValLen - offset);  // Transmit as much as possible
      memcpy(pValue, pAttr->pValue + offset, *pLen);
    }
  }
  // See if request is regarding the Voltage_Range_4_Cal_Constants Characteristic Value
else if ( ! memcmp(pAttr->type.uuid, ws_Voltage_Range_4_Cal_ConstantsUUID, pAttr->type.len) )
  {
    if ( offset > ws_Voltage_Range_4_Cal_ConstantsValLen )  // Prevent malicious ATT ReadBlob offsets.
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else
    {
      *pLen = MIN(maxLen, ws_Voltage_Range_4_Cal_ConstantsValLen - offset);  // Transmit as much as possible
      memcpy(pValue, pAttr->pValue + offset, *pLen);
    }
  }
  // See if request is regarding the Current_Range_1_Cal_Constants Characteristic Value
else if ( ! memcmp(pAttr->type.uuid, ws_Current_Range_1_Cal_ConstantsUUID, pAttr->type.len) )
  {
    if ( offset > ws_Current_Range_1_Cal_ConstantsValLen )  // Prevent malicious ATT ReadBlob offsets.
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else
    {
      *pLen = MIN(maxLen, ws_Current_Range_1_Cal_ConstantsValLen - offset);  // Transmit as much as possible
      memcpy(pValue, pAttr->pValue + offset, *pLen);
    }
  }
  // See if request is regarding the Current_Range_2_Cal_Constants Characteristic Value
else if ( ! memcmp(pAttr->type.uuid, ws_Current_Range_2_Cal_ConstantsUUID, pAttr->type.len) )
  {
    if ( offset > ws_Current_Range_2_Cal_ConstantsValLen )  // Prevent malicious ATT ReadBlob offsets.
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else
    {
      *pLen = MIN(maxLen, ws_Current_Range_2_Cal_ConstantsValLen - offset);  // Transmit as much as possible
      memcpy(pValue, pAttr->pValue + offset, *pLen);
    }
  }
  // See if request is regarding the Voltage_Range_Mode Characteristic Value
else if ( ! memcmp(pAttr->type.uuid, ws_Voltage_Range_ModeUUID, pAttr->type.len) )
  {
    if ( offset > ws_Voltage_Range_ModeValLen )  // Prevent malicious ATT ReadBlob offsets.
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else
    {
      *pLen = MIN(maxLen, ws_Voltage_Range_ModeValLen - offset);  // Transmit as much as possible
      memcpy(pValue, pAttr->pValue + offset, *pLen);
    }
  }
  // See if request is regarding the Measurement_Mode Characteristic Value
else if ( ! memcmp(pAttr->type.uuid, ws_Measurement_ModeUUID, pAttr->type.len) )
  {
    if ( offset > ws_Measurement_ModeValLen )  // Prevent malicious ATT ReadBlob offsets.
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else
    {
      *pLen = MIN(maxLen, ws_Measurement_ModeValLen - offset);  // Transmit as much as possible
      memcpy(pValue, pAttr->pValue + offset, *pLen);
    }
  }
  // See if request is regarding the Battery_Capacity_Level Characteristic Value
else if ( ! memcmp(pAttr->type.uuid, ws_Battery_Capacity_LevelUUID, pAttr->type.len) )
  {
    if ( offset > ws_Battery_Capacity_LevelValLen )  // Prevent malicious ATT ReadBlob offsets.
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else
    {
      *pLen = MIN(maxLen, ws_Battery_Capacity_LevelValLen - offset);  // Transmit as much as possible
      memcpy(pValue, pAttr->pValue + offset, *pLen);
    }
  }
  // See if request is regarding the Battery_Voltage_Level Characteristic Value
else if ( ! memcmp(pAttr->type.uuid, ws_Battery_Voltage_LevelUUID, pAttr->type.len) )
  {
    if ( offset > ws_Battery_Voltage_LevelValLen )  // Prevent malicious ATT ReadBlob offsets.
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else
    {
      *pLen = MIN(maxLen, ws_Battery_Voltage_LevelValLen - offset);  // Transmit as much as possible
      memcpy(pValue, pAttr->pValue + offset, *pLen);
    }
  }
  // See if request is regarding the CapTIvate_Sensing Characteristic Value
else if ( ! memcmp(pAttr->type.uuid, ws_CapTIvate_SensingUUID, pAttr->type.len) )
  {
    if ( offset > ws_CapTIvate_SensingValLen )  // Prevent malicious ATT ReadBlob offsets.
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else
    {
      *pLen = MIN(maxLen, ws_CapTIvate_SensingValLen - offset);  // Transmit as much as possible
      memcpy(pValue, pAttr->pValue + offset, *pLen);
    }
  }
  // See if request is regarding the Temp_Comp_V1 Characteristic Value
else if ( ! memcmp(pAttr->type.uuid, ws_Temp_Comp_V1UUID, pAttr->type.len) )
  {
    if ( offset > ws_Temp_Comp_V1ValLen )  // Prevent malicious ATT ReadBlob offsets.
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else
    {
      *pLen = MIN(maxLen, ws_Temp_Comp_V1ValLen - offset);  // Transmit as much as possible
      memcpy(pValue, pAttr->pValue + offset, *pLen);
    }
  }
  // See if request is regarding the Temp_Comp_V2 Characteristic Value
else if ( ! memcmp(pAttr->type.uuid, ws_Temp_Comp_V2UUID, pAttr->type.len) )
  {
    if ( offset > ws_Temp_Comp_V2ValLen )  // Prevent malicious ATT ReadBlob offsets.
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else
    {
      *pLen = MIN(maxLen, ws_Temp_Comp_V2ValLen - offset);  // Transmit as much as possible
      memcpy(pValue, pAttr->pValue + offset, *pLen);
    }
  }
  // See if request is regarding the Temp_Comp_V3 Characteristic Value
else if ( ! memcmp(pAttr->type.uuid, ws_Temp_Comp_V3UUID, pAttr->type.len) )
  {
    if ( offset > ws_Temp_Comp_V3ValLen )  // Prevent malicious ATT ReadBlob offsets.
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else
    {
      *pLen = MIN(maxLen, ws_Temp_Comp_V3ValLen - offset);  // Transmit as much as possible
      memcpy(pValue, pAttr->pValue + offset, *pLen);
    }
  }
  // See if request is regarding the Temp_Comp_V4 Characteristic Value
else if ( ! memcmp(pAttr->type.uuid, ws_Temp_Comp_V4UUID, pAttr->type.len) )
  {
    if ( offset > ws_Temp_Comp_V4ValLen )  // Prevent malicious ATT ReadBlob offsets.
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else
    {
      *pLen = MIN(maxLen, ws_Temp_Comp_V4ValLen - offset);  // Transmit as much as possible
      memcpy(pValue, pAttr->pValue + offset, *pLen);
    }
  }
  // See if request is regarding the Temp_Comp_I1 Characteristic Value
else if ( ! memcmp(pAttr->type.uuid, ws_Temp_Comp_I1UUID, pAttr->type.len) )
  {
    if ( offset > ws_Temp_Comp_I1ValLen )  // Prevent malicious ATT ReadBlob offsets.
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else
    {
      *pLen = MIN(maxLen, ws_Temp_Comp_I1ValLen - offset);  // Transmit as much as possible
      memcpy(pValue, pAttr->pValue + offset, *pLen);
    }
  }
  // See if request is regarding the Temp_Comp_I2 Characteristic Value
else if ( ! memcmp(pAttr->type.uuid, ws_Temp_Comp_I2UUID, pAttr->type.len) )
  {
    if ( offset > ws_Temp_Comp_I2ValLen )  // Prevent malicious ATT ReadBlob offsets.
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else
    {
      *pLen = MIN(maxLen, ws_Temp_Comp_I2ValLen - offset);  // Transmit as much as possible
      memcpy(pValue, pAttr->pValue + offset, *pLen);
    }
  }
  // See if request is regarding the Reserved_1 Characteristic Value
else if ( ! memcmp(pAttr->type.uuid, ws_Reserved_1UUID, pAttr->type.len) )
  {
    if ( offset > ws_Reserved_1ValLen )  // Prevent malicious ATT ReadBlob offsets.
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else
    {
      *pLen = MIN(maxLen, ws_Reserved_1ValLen - offset);  // Transmit as much as possible
      memcpy(pValue, pAttr->pValue + offset, *pLen);
    }
  }
  // See if request is regarding the Reserved_2 Characteristic Value
else if ( ! memcmp(pAttr->type.uuid, ws_Reserved_2UUID, pAttr->type.len) )
  {
    if ( offset > ws_Reserved_2ValLen )  // Prevent malicious ATT ReadBlob offsets.
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else
    {
      *pLen = MIN(maxLen, ws_Reserved_2ValLen - offset);  // Transmit as much as possible
      memcpy(pValue, pAttr->pValue + offset, *pLen);
    }
  }
  else
  {
    // If we get here, that means you've forgotten to add an if clause for a
    // characteristic value attribute in the attribute table that has READ permissions.
    *pLen = 0;
    status = ATT_ERR_ATTR_NOT_FOUND;
  }

  return status;
}


/*********************************************************************
 * @fn      WDMM_Service_WriteAttrCB
 *
 * @brief   Validate attribute data prior to a write operation
 *
 * @param   connHandle - connection message was received on
 * @param   pAttr - pointer to attribute
 * @param   pValue - pointer to data to be written
 * @param   len - length of data
 * @param   offset - offset of the first octet to be written
 * @param   method - type of write message
 *
 * @return  SUCCESS, blePending or Failure
 */
static bStatus_t WDMM_Service_WriteAttrCB( uint16_t connHandle, gattAttribute_t *pAttr,
                                        uint8_t *pValue, uint16_t len, uint16_t offset,
                                        uint8_t method )
{
  bStatus_t status  = SUCCESS;
  uint8_t   paramID = 0xFF;

  // See if request is regarding a Client Characterisic Configuration
  if ( ! memcmp(pAttr->type.uuid, clientCharCfgUUID, pAttr->type.len) )
  {
    // Allow notification and indication, but do not check if really allowed per CCCD.
    status = GATTServApp_ProcessCCCWriteReq( connHandle, pAttr, pValue, len,
                                             offset, GATT_CLIENT_CFG_NOTIFY |
                                                     GATT_CLIENT_CFG_INDICATE );
  }
  // See if request is regarding the Voltage_Range_1_Cal_Constants Characteristic Value
  else if ( ! memcmp(pAttr->type.uuid, ws_Voltage_Range_1_Cal_ConstantsUUID, pAttr->type.len) )
  {
    if ( offset >= WS_VOLTAGE_RANGE_1_CAL_CONSTANTS_LEN )
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else if ( offset + len > WS_VOLTAGE_RANGE_1_CAL_CONSTANTS_LEN )
    {
      status = ATT_ERR_INVALID_VALUE_SIZE;
    }
    else if ( offset + len < WS_VOLTAGE_RANGE_1_CAL_CONSTANTS_LEN_MIN && 
              ( method == ATT_EXECUTE_WRITE_REQ || method == ATT_WRITE_REQ ) )
    {
      // Refuse writes that are lower than minimum.
      // Note: Cannot determine if a Reliable Write (to several chars) is finished, so those will
      //       only be refused if this attribute is the last in the queue (method is execute).
      //       Otherwise, reliable writes are accepted and parsed piecemeal.
      status = ATT_ERR_INVALID_VALUE_SIZE;
    }
    else
    {
      // Copy pValue into the variable we point to from the attribute table.
      memcpy(pAttr->pValue + offset, pValue, len);

      // Only notify application and update length if enough data is written.
      //
      // Note: If reliable writes are used (meaning several attributes are written to using ATT PrepareWrite),
      //       the application will get a callback for every write with an offset + len larger than _LEN_MIN.
      // Note: For Long Writes (ATT Prepare + Execute towards only one attribute) only one callback will be issued,
      //       because the write fragments are concatenated before being sent here.
      if ( offset + len >= WS_VOLTAGE_RANGE_1_CAL_CONSTANTS_LEN_MIN)
      {
        paramID = WS_VOLTAGE_RANGE_1_CAL_CONSTANTS_ID;
        ws_Voltage_Range_1_Cal_ConstantsValLen = offset + len; // Update data length.
      }
    }
  }
  // See if request is regarding the Voltage_Range_2_Cal_Constants Characteristic Value
  else if ( ! memcmp(pAttr->type.uuid, ws_Voltage_Range_2_Cal_ConstantsUUID, pAttr->type.len) )
  {
    if ( offset >= WS_VOLTAGE_RANGE_2_CAL_CONSTANTS_LEN )
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else if ( offset + len > WS_VOLTAGE_RANGE_2_CAL_CONSTANTS_LEN )
    {
      status = ATT_ERR_INVALID_VALUE_SIZE;
    }
    else if ( offset + len < WS_VOLTAGE_RANGE_2_CAL_CONSTANTS_LEN_MIN && 
              ( method == ATT_EXECUTE_WRITE_REQ || method == ATT_WRITE_REQ ) )
    {
      // Refuse writes that are lower than minimum.
      // Note: Cannot determine if a Reliable Write (to several chars) is finished, so those will
      //       only be refused if this attribute is the last in the queue (method is execute).
      //       Otherwise, reliable writes are accepted and parsed piecemeal.
      status = ATT_ERR_INVALID_VALUE_SIZE;
    }
    else
    {
      // Copy pValue into the variable we point to from the attribute table.
      memcpy(pAttr->pValue + offset, pValue, len);

      // Only notify application and update length if enough data is written.
      //
      // Note: If reliable writes are used (meaning several attributes are written to using ATT PrepareWrite),
      //       the application will get a callback for every write with an offset + len larger than _LEN_MIN.
      // Note: For Long Writes (ATT Prepare + Execute towards only one attribute) only one callback will be issued,
      //       because the write fragments are concatenated before being sent here.
      if ( offset + len >= WS_VOLTAGE_RANGE_2_CAL_CONSTANTS_LEN_MIN)
      {
        paramID = WS_VOLTAGE_RANGE_2_CAL_CONSTANTS_ID;
        ws_Voltage_Range_2_Cal_ConstantsValLen = offset + len; // Update data length.
      }
    }
  }
  // See if request is regarding the Voltage_Range_3_Cal_Constants Characteristic Value
  else if ( ! memcmp(pAttr->type.uuid, ws_Voltage_Range_3_Cal_ConstantsUUID, pAttr->type.len) )
  {
    if ( offset >= WS_VOLTAGE_RANGE_3_CAL_CONSTANTS_LEN )
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else if ( offset + len > WS_VOLTAGE_RANGE_3_CAL_CONSTANTS_LEN )
    {
      status = ATT_ERR_INVALID_VALUE_SIZE;
    }
    else if ( offset + len < WS_VOLTAGE_RANGE_3_CAL_CONSTANTS_LEN_MIN && 
              ( method == ATT_EXECUTE_WRITE_REQ || method == ATT_WRITE_REQ ) )
    {
      // Refuse writes that are lower than minimum.
      // Note: Cannot determine if a Reliable Write (to several chars) is finished, so those will
      //       only be refused if this attribute is the last in the queue (method is execute).
      //       Otherwise, reliable writes are accepted and parsed piecemeal.
      status = ATT_ERR_INVALID_VALUE_SIZE;
    }
    else
    {
      // Copy pValue into the variable we point to from the attribute table.
      memcpy(pAttr->pValue + offset, pValue, len);

      // Only notify application and update length if enough data is written.
      //
      // Note: If reliable writes are used (meaning several attributes are written to using ATT PrepareWrite),
      //       the application will get a callback for every write with an offset + len larger than _LEN_MIN.
      // Note: For Long Writes (ATT Prepare + Execute towards only one attribute) only one callback will be issued,
      //       because the write fragments are concatenated before being sent here.
      if ( offset + len >= WS_VOLTAGE_RANGE_3_CAL_CONSTANTS_LEN_MIN)
      {
        paramID = WS_VOLTAGE_RANGE_3_CAL_CONSTANTS_ID;
        ws_Voltage_Range_3_Cal_ConstantsValLen = offset + len; // Update data length.
      }
    }
  }
  // See if request is regarding the Voltage_Range_4_Cal_Constants Characteristic Value
  else if ( ! memcmp(pAttr->type.uuid, ws_Voltage_Range_4_Cal_ConstantsUUID, pAttr->type.len) )
  {
    if ( offset >= WS_VOLTAGE_RANGE_4_CAL_CONSTANTS_LEN )
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else if ( offset + len > WS_VOLTAGE_RANGE_4_CAL_CONSTANTS_LEN )
    {
      status = ATT_ERR_INVALID_VALUE_SIZE;
    }
    else if ( offset + len < WS_VOLTAGE_RANGE_4_CAL_CONSTANTS_LEN_MIN && 
              ( method == ATT_EXECUTE_WRITE_REQ || method == ATT_WRITE_REQ ) )
    {
      // Refuse writes that are lower than minimum.
      // Note: Cannot determine if a Reliable Write (to several chars) is finished, so those will
      //       only be refused if this attribute is the last in the queue (method is execute).
      //       Otherwise, reliable writes are accepted and parsed piecemeal.
      status = ATT_ERR_INVALID_VALUE_SIZE;
    }
    else
    {
      // Copy pValue into the variable we point to from the attribute table.
      memcpy(pAttr->pValue + offset, pValue, len);

      // Only notify application and update length if enough data is written.
      //
      // Note: If reliable writes are used (meaning several attributes are written to using ATT PrepareWrite),
      //       the application will get a callback for every write with an offset + len larger than _LEN_MIN.
      // Note: For Long Writes (ATT Prepare + Execute towards only one attribute) only one callback will be issued,
      //       because the write fragments are concatenated before being sent here.
      if ( offset + len >= WS_VOLTAGE_RANGE_4_CAL_CONSTANTS_LEN_MIN)
      {
        paramID = WS_VOLTAGE_RANGE_4_CAL_CONSTANTS_ID;
        ws_Voltage_Range_4_Cal_ConstantsValLen = offset + len; // Update data length.
      }
    }
  }
  // See if request is regarding the Current_Range_1_Cal_Constants Characteristic Value
  else if ( ! memcmp(pAttr->type.uuid, ws_Current_Range_1_Cal_ConstantsUUID, pAttr->type.len) )
  {
    if ( offset >= WS_CURRENT_RANGE_1_CAL_CONSTANTS_LEN )
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else if ( offset + len > WS_CURRENT_RANGE_1_CAL_CONSTANTS_LEN )
    {
      status = ATT_ERR_INVALID_VALUE_SIZE;
    }
    else if ( offset + len < WS_CURRENT_RANGE_1_CAL_CONSTANTS_LEN_MIN && 
              ( method == ATT_EXECUTE_WRITE_REQ || method == ATT_WRITE_REQ ) )
    {
      // Refuse writes that are lower than minimum.
      // Note: Cannot determine if a Reliable Write (to several chars) is finished, so those will
      //       only be refused if this attribute is the last in the queue (method is execute).
      //       Otherwise, reliable writes are accepted and parsed piecemeal.
      status = ATT_ERR_INVALID_VALUE_SIZE;
    }
    else
    {
      // Copy pValue into the variable we point to from the attribute table.
      memcpy(pAttr->pValue + offset, pValue, len);

      // Only notify application and update length if enough data is written.
      //
      // Note: If reliable writes are used (meaning several attributes are written to using ATT PrepareWrite),
      //       the application will get a callback for every write with an offset + len larger than _LEN_MIN.
      // Note: For Long Writes (ATT Prepare + Execute towards only one attribute) only one callback will be issued,
      //       because the write fragments are concatenated before being sent here.
      if ( offset + len >= WS_CURRENT_RANGE_1_CAL_CONSTANTS_LEN_MIN)
      {
        paramID = WS_CURRENT_RANGE_1_CAL_CONSTANTS_ID;
        ws_Current_Range_1_Cal_ConstantsValLen = offset + len; // Update data length.
      }
    }
  }
  // See if request is regarding the Current_Range_2_Cal_Constants Characteristic Value
  else if ( ! memcmp(pAttr->type.uuid, ws_Current_Range_2_Cal_ConstantsUUID, pAttr->type.len) )
  {
    if ( offset >= WS_CURRENT_RANGE_2_CAL_CONSTANTS_LEN )
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else if ( offset + len > WS_CURRENT_RANGE_2_CAL_CONSTANTS_LEN )
    {
      status = ATT_ERR_INVALID_VALUE_SIZE;
    }
    else if ( offset + len < WS_CURRENT_RANGE_2_CAL_CONSTANTS_LEN_MIN && 
              ( method == ATT_EXECUTE_WRITE_REQ || method == ATT_WRITE_REQ ) )
    {
      // Refuse writes that are lower than minimum.
      // Note: Cannot determine if a Reliable Write (to several chars) is finished, so those will
      //       only be refused if this attribute is the last in the queue (method is execute).
      //       Otherwise, reliable writes are accepted and parsed piecemeal.
      status = ATT_ERR_INVALID_VALUE_SIZE;
    }
    else
    {
      // Copy pValue into the variable we point to from the attribute table.
      memcpy(pAttr->pValue + offset, pValue, len);

      // Only notify application and update length if enough data is written.
      //
      // Note: If reliable writes are used (meaning several attributes are written to using ATT PrepareWrite),
      //       the application will get a callback for every write with an offset + len larger than _LEN_MIN.
      // Note: For Long Writes (ATT Prepare + Execute towards only one attribute) only one callback will be issued,
      //       because the write fragments are concatenated before being sent here.
      if ( offset + len >= WS_CURRENT_RANGE_2_CAL_CONSTANTS_LEN_MIN)
      {
        paramID = WS_CURRENT_RANGE_2_CAL_CONSTANTS_ID;
        ws_Current_Range_2_Cal_ConstantsValLen = offset + len; // Update data length.
      }
    }
  }
  // See if request is regarding the Initiate_Power_Down Characteristic Value
  else if ( ! memcmp(pAttr->type.uuid, ws_Initiate_Power_DownUUID, pAttr->type.len) )
  {
    if ( offset >= WS_INITIATE_POWER_DOWN_LEN )
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else if ( offset + len > WS_INITIATE_POWER_DOWN_LEN )
    {
      status = ATT_ERR_INVALID_VALUE_SIZE;
    }
    else if ( offset + len < WS_INITIATE_POWER_DOWN_LEN_MIN && 
              ( method == ATT_EXECUTE_WRITE_REQ || method == ATT_WRITE_REQ ) )
    {
      // Refuse writes that are lower than minimum.
      // Note: Cannot determine if a Reliable Write (to several chars) is finished, so those will
      //       only be refused if this attribute is the last in the queue (method is execute).
      //       Otherwise, reliable writes are accepted and parsed piecemeal.
      status = ATT_ERR_INVALID_VALUE_SIZE;
    }
    else
    {
      // Copy pValue into the variable we point to from the attribute table.
      memcpy(pAttr->pValue + offset, pValue, len);

      // Only notify application and update length if enough data is written.
      //
      // Note: If reliable writes are used (meaning several attributes are written to using ATT PrepareWrite),
      //       the application will get a callback for every write with an offset + len larger than _LEN_MIN.
      // Note: For Long Writes (ATT Prepare + Execute towards only one attribute) only one callback will be issued,
      //       because the write fragments are concatenated before being sent here.
      if ( offset + len >= WS_INITIATE_POWER_DOWN_LEN_MIN)
      {
        paramID = WS_INITIATE_POWER_DOWN_ID;
        ws_Initiate_Power_DownValLen = offset + len; // Update data length.
      }
    }
  }
  // See if request is regarding the Voltage_Range_Select Characteristic Value
  else if ( ! memcmp(pAttr->type.uuid, ws_Voltage_Range_SelectUUID, pAttr->type.len) )
  {
    if ( offset >= WS_VOLTAGE_RANGE_SELECT_LEN )
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else if ( offset + len > WS_VOLTAGE_RANGE_SELECT_LEN )
    {
      status = ATT_ERR_INVALID_VALUE_SIZE;
    }
    else if ( offset + len < WS_VOLTAGE_RANGE_SELECT_LEN_MIN && 
              ( method == ATT_EXECUTE_WRITE_REQ || method == ATT_WRITE_REQ ) )
    {
      // Refuse writes that are lower than minimum.
      // Note: Cannot determine if a Reliable Write (to several chars) is finished, so those will
      //       only be refused if this attribute is the last in the queue (method is execute).
      //       Otherwise, reliable writes are accepted and parsed piecemeal.
      status = ATT_ERR_INVALID_VALUE_SIZE;
    }
    else
    {
      // Copy pValue into the variable we point to from the attribute table.
      memcpy(pAttr->pValue + offset, pValue, len);

      // Only notify application and update length if enough data is written.
      //
      // Note: If reliable writes are used (meaning several attributes are written to using ATT PrepareWrite),
      //       the application will get a callback for every write with an offset + len larger than _LEN_MIN.
      // Note: For Long Writes (ATT Prepare + Execute towards only one attribute) only one callback will be issued,
      //       because the write fragments are concatenated before being sent here.
      if ( offset + len >= WS_VOLTAGE_RANGE_SELECT_LEN_MIN)
      {
        paramID = WS_VOLTAGE_RANGE_SELECT_ID;
        ws_Voltage_Range_SelectValLen = offset + len; // Update data length.
      }
    }
  }
  // See if request is regarding the Current_Range_Select Characteristic Value
  else if ( ! memcmp(pAttr->type.uuid, ws_Current_Range_SelectUUID, pAttr->type.len) )
  {
    if ( offset >= WS_CURRENT_RANGE_SELECT_LEN )
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else if ( offset + len > WS_CURRENT_RANGE_SELECT_LEN )
    {
      status = ATT_ERR_INVALID_VALUE_SIZE;
    }
    else if ( offset + len < WS_CURRENT_RANGE_SELECT_LEN_MIN && 
              ( method == ATT_EXECUTE_WRITE_REQ || method == ATT_WRITE_REQ ) )
    {
      // Refuse writes that are lower than minimum.
      // Note: Cannot determine if a Reliable Write (to several chars) is finished, so those will
      //       only be refused if this attribute is the last in the queue (method is execute).
      //       Otherwise, reliable writes are accepted and parsed piecemeal.
      status = ATT_ERR_INVALID_VALUE_SIZE;
    }
    else
    {
      // Copy pValue into the variable we point to from the attribute table.
      memcpy(pAttr->pValue + offset, pValue, len);

      // Only notify application and update length if enough data is written.
      //
      // Note: If reliable writes are used (meaning several attributes are written to using ATT PrepareWrite),
      //       the application will get a callback for every write with an offset + len larger than _LEN_MIN.
      // Note: For Long Writes (ATT Prepare + Execute towards only one attribute) only one callback will be issued,
      //       because the write fragments are concatenated before being sent here.
      if ( offset + len >= WS_CURRENT_RANGE_SELECT_LEN_MIN)
      {
        paramID = WS_CURRENT_RANGE_SELECT_ID;
        ws_Current_Range_SelectValLen = offset + len; // Update data length.
      }
    }
  }
  // See if request is regarding the Sampling_Rate_Select Characteristic Value
  else if ( ! memcmp(pAttr->type.uuid, ws_Sampling_Rate_SelectUUID, pAttr->type.len) )
  {
    if ( offset >= WS_SAMPLING_RATE_SELECT_LEN )
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else if ( offset + len > WS_SAMPLING_RATE_SELECT_LEN )
    {
      status = ATT_ERR_INVALID_VALUE_SIZE;
    }
    else if ( offset + len < WS_SAMPLING_RATE_SELECT_LEN_MIN && 
              ( method == ATT_EXECUTE_WRITE_REQ || method == ATT_WRITE_REQ ) )
    {
      // Refuse writes that are lower than minimum.
      // Note: Cannot determine if a Reliable Write (to several chars) is finished, so those will
      //       only be refused if this attribute is the last in the queue (method is execute).
      //       Otherwise, reliable writes are accepted and parsed piecemeal.
      status = ATT_ERR_INVALID_VALUE_SIZE;
    }
    else
    {
      // Copy pValue into the variable we point to from the attribute table.
      memcpy(pAttr->pValue + offset, pValue, len);

      // Only notify application and update length if enough data is written.
      //
      // Note: If reliable writes are used (meaning several attributes are written to using ATT PrepareWrite),
      //       the application will get a callback for every write with an offset + len larger than _LEN_MIN.
      // Note: For Long Writes (ATT Prepare + Execute towards only one attribute) only one callback will be issued,
      //       because the write fragments are concatenated before being sent here.
      if ( offset + len >= WS_SAMPLING_RATE_SELECT_LEN_MIN)
      {
        paramID = WS_SAMPLING_RATE_SELECT_ID;
        ws_Sampling_Rate_SelectValLen = offset + len; // Update data length.
      }
    }
  }
  // See if request is regarding the Reporting_Rate_Select Characteristic Value
  else if ( ! memcmp(pAttr->type.uuid, ws_Reporting_Rate_SelectUUID, pAttr->type.len) )
  {
    if ( offset >= WS_REPORTING_RATE_SELECT_LEN )
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else if ( offset + len > WS_REPORTING_RATE_SELECT_LEN )
    {
      status = ATT_ERR_INVALID_VALUE_SIZE;
    }
    else if ( offset + len < WS_REPORTING_RATE_SELECT_LEN_MIN && 
              ( method == ATT_EXECUTE_WRITE_REQ || method == ATT_WRITE_REQ ) )
    {
      // Refuse writes that are lower than minimum.
      // Note: Cannot determine if a Reliable Write (to several chars) is finished, so those will
      //       only be refused if this attribute is the last in the queue (method is execute).
      //       Otherwise, reliable writes are accepted and parsed piecemeal.
      status = ATT_ERR_INVALID_VALUE_SIZE;
    }
    else
    {
      // Copy pValue into the variable we point to from the attribute table.
      memcpy(pAttr->pValue + offset, pValue, len);

      // Only notify application and update length if enough data is written.
      //
      // Note: If reliable writes are used (meaning several attributes are written to using ATT PrepareWrite),
      //       the application will get a callback for every write with an offset + len larger than _LEN_MIN.
      // Note: For Long Writes (ATT Prepare + Execute towards only one attribute) only one callback will be issued,
      //       because the write fragments are concatenated before being sent here.
      if ( offset + len >= WS_REPORTING_RATE_SELECT_LEN_MIN)
      {
        paramID = WS_REPORTING_RATE_SELECT_ID;
        ws_Reporting_Rate_SelectValLen = offset + len; // Update data length.
      }
    }
  }
  // See if request is regarding the Temp_Comp_V1 Characteristic Value
  else if ( ! memcmp(pAttr->type.uuid, ws_Temp_Comp_V1UUID, pAttr->type.len) )
  {
    if ( offset >= WS_TEMP_COMP_V1_LEN )
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else if ( offset + len > WS_TEMP_COMP_V1_LEN )
    {
      status = ATT_ERR_INVALID_VALUE_SIZE;
    }
    else if ( offset + len < WS_TEMP_COMP_V1_LEN_MIN && 
              ( method == ATT_EXECUTE_WRITE_REQ || method == ATT_WRITE_REQ ) )
    {
      // Refuse writes that are lower than minimum.
      // Note: Cannot determine if a Reliable Write (to several chars) is finished, so those will
      //       only be refused if this attribute is the last in the queue (method is execute).
      //       Otherwise, reliable writes are accepted and parsed piecemeal.
      status = ATT_ERR_INVALID_VALUE_SIZE;
    }
    else
    {
      // Copy pValue into the variable we point to from the attribute table.
      memcpy(pAttr->pValue + offset, pValue, len);

      // Only notify application and update length if enough data is written.
      //
      // Note: If reliable writes are used (meaning several attributes are written to using ATT PrepareWrite),
      //       the application will get a callback for every write with an offset + len larger than _LEN_MIN.
      // Note: For Long Writes (ATT Prepare + Execute towards only one attribute) only one callback will be issued,
      //       because the write fragments are concatenated before being sent here.
      if ( offset + len >= WS_TEMP_COMP_V1_LEN_MIN)
      {
        paramID = WS_TEMP_COMP_V1_ID;
        ws_Temp_Comp_V1ValLen = offset + len; // Update data length.
      }
    }
  }
  // See if request is regarding the Temp_Comp_V2 Characteristic Value
  else if ( ! memcmp(pAttr->type.uuid, ws_Temp_Comp_V2UUID, pAttr->type.len) )
  {
    if ( offset >= WS_TEMP_COMP_V2_LEN )
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else if ( offset + len > WS_TEMP_COMP_V2_LEN )
    {
      status = ATT_ERR_INVALID_VALUE_SIZE;
    }
    else if ( offset + len < WS_TEMP_COMP_V2_LEN_MIN && 
              ( method == ATT_EXECUTE_WRITE_REQ || method == ATT_WRITE_REQ ) )
    {
      // Refuse writes that are lower than minimum.
      // Note: Cannot determine if a Reliable Write (to several chars) is finished, so those will
      //       only be refused if this attribute is the last in the queue (method is execute).
      //       Otherwise, reliable writes are accepted and parsed piecemeal.
      status = ATT_ERR_INVALID_VALUE_SIZE;
    }
    else
    {
      // Copy pValue into the variable we point to from the attribute table.
      memcpy(pAttr->pValue + offset, pValue, len);

      // Only notify application and update length if enough data is written.
      //
      // Note: If reliable writes are used (meaning several attributes are written to using ATT PrepareWrite),
      //       the application will get a callback for every write with an offset + len larger than _LEN_MIN.
      // Note: For Long Writes (ATT Prepare + Execute towards only one attribute) only one callback will be issued,
      //       because the write fragments are concatenated before being sent here.
      if ( offset + len >= WS_TEMP_COMP_V2_LEN_MIN)
      {
        paramID = WS_TEMP_COMP_V2_ID;
        ws_Temp_Comp_V2ValLen = offset + len; // Update data length.
      }
    }
  }
  // See if request is regarding the Temp_Comp_V3 Characteristic Value
  else if ( ! memcmp(pAttr->type.uuid, ws_Temp_Comp_V3UUID, pAttr->type.len) )
  {
    if ( offset >= WS_TEMP_COMP_V3_LEN )
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else if ( offset + len > WS_TEMP_COMP_V3_LEN )
    {
      status = ATT_ERR_INVALID_VALUE_SIZE;
    }
    else if ( offset + len < WS_TEMP_COMP_V3_LEN_MIN && 
              ( method == ATT_EXECUTE_WRITE_REQ || method == ATT_WRITE_REQ ) )
    {
      // Refuse writes that are lower than minimum.
      // Note: Cannot determine if a Reliable Write (to several chars) is finished, so those will
      //       only be refused if this attribute is the last in the queue (method is execute).
      //       Otherwise, reliable writes are accepted and parsed piecemeal.
      status = ATT_ERR_INVALID_VALUE_SIZE;
    }
    else
    {
      // Copy pValue into the variable we point to from the attribute table.
      memcpy(pAttr->pValue + offset, pValue, len);

      // Only notify application and update length if enough data is written.
      //
      // Note: If reliable writes are used (meaning several attributes are written to using ATT PrepareWrite),
      //       the application will get a callback for every write with an offset + len larger than _LEN_MIN.
      // Note: For Long Writes (ATT Prepare + Execute towards only one attribute) only one callback will be issued,
      //       because the write fragments are concatenated before being sent here.
      if ( offset + len >= WS_TEMP_COMP_V3_LEN_MIN)
      {
        paramID = WS_TEMP_COMP_V3_ID;
        ws_Temp_Comp_V3ValLen = offset + len; // Update data length.
      }
    }
  }
  // See if request is regarding the Temp_Comp_V4 Characteristic Value
  else if ( ! memcmp(pAttr->type.uuid, ws_Temp_Comp_V4UUID, pAttr->type.len) )
  {
    if ( offset >= WS_TEMP_COMP_V4_LEN )
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else if ( offset + len > WS_TEMP_COMP_V4_LEN )
    {
      status = ATT_ERR_INVALID_VALUE_SIZE;
    }
    else if ( offset + len < WS_TEMP_COMP_V4_LEN_MIN && 
              ( method == ATT_EXECUTE_WRITE_REQ || method == ATT_WRITE_REQ ) )
    {
      // Refuse writes that are lower than minimum.
      // Note: Cannot determine if a Reliable Write (to several chars) is finished, so those will
      //       only be refused if this attribute is the last in the queue (method is execute).
      //       Otherwise, reliable writes are accepted and parsed piecemeal.
      status = ATT_ERR_INVALID_VALUE_SIZE;
    }
    else
    {
      // Copy pValue into the variable we point to from the attribute table.
      memcpy(pAttr->pValue + offset, pValue, len);

      // Only notify application and update length if enough data is written.
      //
      // Note: If reliable writes are used (meaning several attributes are written to using ATT PrepareWrite),
      //       the application will get a callback for every write with an offset + len larger than _LEN_MIN.
      // Note: For Long Writes (ATT Prepare + Execute towards only one attribute) only one callback will be issued,
      //       because the write fragments are concatenated before being sent here.
      if ( offset + len >= WS_TEMP_COMP_V4_LEN_MIN)
      {
        paramID = WS_TEMP_COMP_V4_ID;
        ws_Temp_Comp_V4ValLen = offset + len; // Update data length.
      }
    }
  }
  // See if request is regarding the Temp_Comp_I1 Characteristic Value
  else if ( ! memcmp(pAttr->type.uuid, ws_Temp_Comp_I1UUID, pAttr->type.len) )
  {
    if ( offset >= WS_TEMP_COMP_I1_LEN )
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else if ( offset + len > WS_TEMP_COMP_I1_LEN )
    {
      status = ATT_ERR_INVALID_VALUE_SIZE;
    }
    else if ( offset + len < WS_TEMP_COMP_I1_LEN_MIN && 
              ( method == ATT_EXECUTE_WRITE_REQ || method == ATT_WRITE_REQ ) )
    {
      // Refuse writes that are lower than minimum.
      // Note: Cannot determine if a Reliable Write (to several chars) is finished, so those will
      //       only be refused if this attribute is the last in the queue (method is execute).
      //       Otherwise, reliable writes are accepted and parsed piecemeal.
      status = ATT_ERR_INVALID_VALUE_SIZE;
    }
    else
    {
      // Copy pValue into the variable we point to from the attribute table.
      memcpy(pAttr->pValue + offset, pValue, len);

      // Only notify application and update length if enough data is written.
      //
      // Note: If reliable writes are used (meaning several attributes are written to using ATT PrepareWrite),
      //       the application will get a callback for every write with an offset + len larger than _LEN_MIN.
      // Note: For Long Writes (ATT Prepare + Execute towards only one attribute) only one callback will be issued,
      //       because the write fragments are concatenated before being sent here.
      if ( offset + len >= WS_TEMP_COMP_I1_LEN_MIN)
      {
        paramID = WS_TEMP_COMP_I1_ID;
        ws_Temp_Comp_I1ValLen = offset + len; // Update data length.
      }
    }
  }
  // See if request is regarding the Temp_Comp_I2 Characteristic Value
  else if ( ! memcmp(pAttr->type.uuid, ws_Temp_Comp_I2UUID, pAttr->type.len) )
  {
    if ( offset >= WS_TEMP_COMP_I2_LEN )
    {
      status = ATT_ERR_INVALID_OFFSET;
    }
    else if ( offset + len > WS_TEMP_COMP_I2_LEN )
    {
      status = ATT_ERR_INVALID_VALUE_SIZE;
    }
    else if ( offset + len < WS_TEMP_COMP_I2_LEN_MIN && 
              ( method == ATT_EXECUTE_WRITE_REQ || method == ATT_WRITE_REQ ) )
    {
      // Refuse writes that are lower than minimum.
      // Note: Cannot determine if a Reliable Write (to several chars) is finished, so those will
      //       only be refused if this attribute is the last in the queue (method is execute).
      //       Otherwise, reliable writes are accepted and parsed piecemeal.
      status = ATT_ERR_INVALID_VALUE_SIZE;
    }
    else
    {
      // Copy pValue into the variable we point to from the attribute table.
      memcpy(pAttr->pValue + offset, pValue, len);

      // Only notify application and update length if enough data is written.
      //
      // Note: If reliable writes are used (meaning several attributes are written to using ATT PrepareWrite),
      //       the application will get a callback for every write with an offset + len larger than _LEN_MIN.
      // Note: For Long Writes (ATT Prepare + Execute towards only one attribute) only one callback will be issued,
      //       because the write fragments are concatenated before being sent here.
      if ( offset + len >= WS_TEMP_COMP_I2_LEN_MIN)
      {
        paramID = WS_TEMP_COMP_I2_ID;
        ws_Temp_Comp_I2ValLen = offset + len; // Update data length.
      }
    }
  }
  else
  {
    // If we get here, that means you've forgotten to add an if clause for a
    // characteristic value attribute in the attribute table that has WRITE permissions.
    status = ATT_ERR_ATTR_NOT_FOUND;
  }

  // Let the application know something changed (if it did) by using the
   // callback it registered earlier (if it did).
   if (paramID != 0xFF)
     if ( pAppCBs && pAppCBs->pfnChangeCb )
     	pAppCBs->pfnChangeCb( connHandle, WDMM_SERVICE_SERV_UUID, paramID, pValue, len+offset ); // Call app function from stack task context.

   return status;
 }

