/**********************************************************************************************
 * Filename:       WDMM_Service.h
 *
 * Description:    This file contains the WDMM_Service service definitions and
 *                 prototypes.
 *
 *                 Generated by:
 *                 BDS version: 1.1.3066.0
 *                 Plugin:      Texas Instruments CC26xx BLE SDK v2.1 GATT Server plugin 1.0.5 beta
 *                 Time:        Thu Nov 10 2016 15:16:39 GMT-06:00
 *

 * Copyright (c) 2015, Texas Instruments Incorporated
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * *  Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * *  Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * *  Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *************************************************************************************************/

#ifndef _WDMM_SERVICE_H_
#define _WDMM_SERVICE_H_

#ifdef __cplusplus
extern "C"
{
#endif

/*********************************************************************
 * INCLUDES
 */

/*********************************************************************
 * CONSTANTS
 */

/*********************************************************************
* CONSTANTS
*/
// Service UUID
#define WDMM_SERVICE_SERV_UUID 0xE375
#define WDMM_SERVICE_SERV_UUID_BASE128(uuid) 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB0, 0x00, 0x40, 0x51, 0x04, LO_UINT16(uuid), HI_UINT16(uuid), 0x00, 0xF0

// DC_Reading Characteristic defines
#define WS_DC_READING_ID                 0
#define WS_DC_READING_UUID               0x1F2B
#define WS_DC_READING_UUID_BASE128(uuid) 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB0, 0x00, 0x40, 0x51, 0x04, LO_UINT16(uuid), HI_UINT16(uuid), 0x00, 0xF0
#define WS_DC_READING_LEN                4
#define WS_DC_READING_LEN_MIN            4

// AC_Reading Characteristic defines
#define WS_AC_READING_ID                 1
#define WS_AC_READING_UUID               0xDE2F
#define WS_AC_READING_UUID_BASE128(uuid) 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB0, 0x00, 0x40, 0x51, 0x04, LO_UINT16(uuid), HI_UINT16(uuid), 0x00, 0xF0
#define WS_AC_READING_LEN                8
#define WS_AC_READING_LEN_MIN            8

// Voltage_Range_1_Cal_Constants Characteristic defines
#define WS_VOLTAGE_RANGE_1_CAL_CONSTANTS_ID                 2
#define WS_VOLTAGE_RANGE_1_CAL_CONSTANTS_UUID               0x5D3D
#define WS_VOLTAGE_RANGE_1_CAL_CONSTANTS_UUID_BASE128(uuid) 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB0, 0x00, 0x40, 0x51, 0x04, LO_UINT16(uuid), HI_UINT16(uuid), 0x00, 0xF0
#define WS_VOLTAGE_RANGE_1_CAL_CONSTANTS_LEN                12
#define WS_VOLTAGE_RANGE_1_CAL_CONSTANTS_LEN_MIN            12

// Voltage_Range_2_Cal_Constants Characteristic defines
#define WS_VOLTAGE_RANGE_2_CAL_CONSTANTS_ID                 3
#define WS_VOLTAGE_RANGE_2_CAL_CONSTANTS_UUID               0x44B6
#define WS_VOLTAGE_RANGE_2_CAL_CONSTANTS_UUID_BASE128(uuid) 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB0, 0x00, 0x40, 0x51, 0x04, LO_UINT16(uuid), HI_UINT16(uuid), 0x00, 0xF0
#define WS_VOLTAGE_RANGE_2_CAL_CONSTANTS_LEN                12
#define WS_VOLTAGE_RANGE_2_CAL_CONSTANTS_LEN_MIN            12

// Voltage_Range_3_Cal_Constants Characteristic defines
#define WS_VOLTAGE_RANGE_3_CAL_CONSTANTS_ID                 4
#define WS_VOLTAGE_RANGE_3_CAL_CONSTANTS_UUID               0xDB69
#define WS_VOLTAGE_RANGE_3_CAL_CONSTANTS_UUID_BASE128(uuid) 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB0, 0x00, 0x40, 0x51, 0x04, LO_UINT16(uuid), HI_UINT16(uuid), 0x00, 0xF0
#define WS_VOLTAGE_RANGE_3_CAL_CONSTANTS_LEN                12
#define WS_VOLTAGE_RANGE_3_CAL_CONSTANTS_LEN_MIN            12

// Voltage_Range_4_Cal_Constants Characteristic defines
#define WS_VOLTAGE_RANGE_4_CAL_CONSTANTS_ID                 5
#define WS_VOLTAGE_RANGE_4_CAL_CONSTANTS_UUID               0x0602
#define WS_VOLTAGE_RANGE_4_CAL_CONSTANTS_UUID_BASE128(uuid) 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB0, 0x00, 0x40, 0x51, 0x04, LO_UINT16(uuid), HI_UINT16(uuid), 0x00, 0xF0
#define WS_VOLTAGE_RANGE_4_CAL_CONSTANTS_LEN                12
#define WS_VOLTAGE_RANGE_4_CAL_CONSTANTS_LEN_MIN            12

// Current_Range_1_Cal_Constants Characteristic defines
#define WS_CURRENT_RANGE_1_CAL_CONSTANTS_ID                 6
#define WS_CURRENT_RANGE_1_CAL_CONSTANTS_UUID               0x4084
#define WS_CURRENT_RANGE_1_CAL_CONSTANTS_UUID_BASE128(uuid) 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB0, 0x00, 0x40, 0x51, 0x04, LO_UINT16(uuid), HI_UINT16(uuid), 0x00, 0xF0
#define WS_CURRENT_RANGE_1_CAL_CONSTANTS_LEN                12
#define WS_CURRENT_RANGE_1_CAL_CONSTANTS_LEN_MIN            12

// Current_Range_2_Cal_Constants Characteristic defines
#define WS_CURRENT_RANGE_2_CAL_CONSTANTS_ID                 7
#define WS_CURRENT_RANGE_2_CAL_CONSTANTS_UUID               0xD358
#define WS_CURRENT_RANGE_2_CAL_CONSTANTS_UUID_BASE128(uuid) 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB0, 0x00, 0x40, 0x51, 0x04, LO_UINT16(uuid), HI_UINT16(uuid), 0x00, 0xF0
#define WS_CURRENT_RANGE_2_CAL_CONSTANTS_LEN                12
#define WS_CURRENT_RANGE_2_CAL_CONSTANTS_LEN_MIN            12

// Initiate_Power_Down Characteristic defines
#define WS_INITIATE_POWER_DOWN_ID                 8
#define WS_INITIATE_POWER_DOWN_UUID               0xACE3
#define WS_INITIATE_POWER_DOWN_UUID_BASE128(uuid) 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB0, 0x00, 0x40, 0x51, 0x04, LO_UINT16(uuid), HI_UINT16(uuid), 0x00, 0xF0
#define WS_INITIATE_POWER_DOWN_LEN                1
#define WS_INITIATE_POWER_DOWN_LEN_MIN            1

// Voltage_Range_Select Characteristic defines
#define WS_VOLTAGE_RANGE_SELECT_ID                 9
#define WS_VOLTAGE_RANGE_SELECT_UUID               0xE636
#define WS_VOLTAGE_RANGE_SELECT_UUID_BASE128(uuid) 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB0, 0x00, 0x40, 0x51, 0x04, LO_UINT16(uuid), HI_UINT16(uuid), 0x00, 0xF0
#define WS_VOLTAGE_RANGE_SELECT_LEN                1
#define WS_VOLTAGE_RANGE_SELECT_LEN_MIN            1

// Voltage_Range_Mode Characteristic defines
#define WS_VOLTAGE_RANGE_MODE_ID                 10
#define WS_VOLTAGE_RANGE_MODE_UUID               0x76FF
#define WS_VOLTAGE_RANGE_MODE_UUID_BASE128(uuid) 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB0, 0x00, 0x40, 0x51, 0x04, LO_UINT16(uuid), HI_UINT16(uuid), 0x00, 0xF0
#define WS_VOLTAGE_RANGE_MODE_LEN                1
#define WS_VOLTAGE_RANGE_MODE_LEN_MIN            1

// Measurement_Mode Characteristic defines
#define WS_MEASUREMENT_MODE_ID                 11
#define WS_MEASUREMENT_MODE_UUID               0xDB7F
#define WS_MEASUREMENT_MODE_UUID_BASE128(uuid) 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB0, 0x00, 0x40, 0x51, 0x04, LO_UINT16(uuid), HI_UINT16(uuid), 0x00, 0xF0
#define WS_MEASUREMENT_MODE_LEN                1
#define WS_MEASUREMENT_MODE_LEN_MIN            1

// Current_Range_Select Characteristic defines
#define WS_CURRENT_RANGE_SELECT_ID                 12
#define WS_CURRENT_RANGE_SELECT_UUID               0x4323
#define WS_CURRENT_RANGE_SELECT_UUID_BASE128(uuid) 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB0, 0x00, 0x40, 0x51, 0x04, LO_UINT16(uuid), HI_UINT16(uuid), 0x00, 0xF0
#define WS_CURRENT_RANGE_SELECT_LEN                1
#define WS_CURRENT_RANGE_SELECT_LEN_MIN            1

// Battery Capacity Level Characteristic defines
#define WS_BATTERY_CAPACITY_LEVEL_ID                 13
#define WS_BATTERY_CAPACITY_LEVEL_UUID               0xA367
#define WS_BATTERY_CAPACITY_LEVEL_UUID_BASE128(uuid) 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB0, 0x00, 0x40, 0x51, 0x04, LO_UINT16(uuid), HI_UINT16(uuid), 0x00, 0xF0
#define WS_BATTERY_CAPACITY_LEVEL_LEN                2
#define WS_BATTERY_CAPACITY_LEVEL_LEN_MIN            2

// Battery Voltage Level Characteristic defines
#define WS_BATTERY_VOLTAGE_LEVEL_ID                 14
#define WS_BATTERY_VOLTAGE_LEVEL_UUID               0x9117
#define WS_BATTERY_VOLTAGE_LEVEL_UUID_BASE128(uuid) 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB0, 0x00, 0x40, 0x51, 0x04, LO_UINT16(uuid), HI_UINT16(uuid), 0x00, 0xF0
#define WS_BATTERY_VOLTAGE_LEVEL_LEN                2
#define WS_BATTERY_VOLTAGE_LEVEL_LEN_MIN            2

// CapTIvate Sensing Characteristic defines
#define WS_CAPTIVATE_SENSING_ID                 15
#define WS_CAPTIVATE_SENSING_UUID               0xFC10
#define WS_CAPTIVATE_SENSING_UUID_BASE128(uuid) 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB0, 0x00, 0x40, 0x51, 0x04, LO_UINT16(uuid), HI_UINT16(uuid), 0x00, 0xF0
#define WS_CAPTIVATE_SENSING_LEN                1
#define WS_CAPTIVATE_SENSING_LEN_MIN            1

// Sampling_Rate_Select Characteristic defines
#define WS_SAMPLING_RATE_SELECT_ID                 16
#define WS_SAMPLING_RATE_SELECT_UUID               0x8FF2
#define WS_SAMPLING_RATE_SELECT_UUID_BASE128(uuid) 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB0, 0x00, 0x40, 0x51, 0x04, LO_UINT16(uuid), HI_UINT16(uuid), 0x00, 0xF0
#define WS_SAMPLING_RATE_SELECT_LEN                2
#define WS_SAMPLING_RATE_SELECT_LEN_MIN            2

// Reporting_Rate_Select Characteristic defines
#define WS_REPORTING_RATE_SELECT_ID                 17
#define WS_REPORTING_RATE_SELECT_UUID               0x6406
#define WS_REPORTING_RATE_SELECT_UUID_BASE128(uuid) 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB0, 0x00, 0x40, 0x51, 0x04, LO_UINT16(uuid), HI_UINT16(uuid), 0x00, 0xF0
#define WS_REPORTING_RATE_SELECT_LEN                2
#define WS_REPORTING_RATE_SELECT_LEN_MIN            2

// Temp_Comp_V1 Characteristic defines
#define WS_TEMP_COMP_V1_ID                 18
#define WS_TEMP_COMP_V1_UUID               0x7C0F
#define WS_TEMP_COMP_V1_UUID_BASE128(uuid) 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB0, 0x00, 0x40, 0x51, 0x04, LO_UINT16(uuid), HI_UINT16(uuid), 0x00, 0xF0
#define WS_TEMP_COMP_V1_LEN                12
#define WS_TEMP_COMP_V1_LEN_MIN            12

// Temp_Comp_V2 Characteristic defines
#define WS_TEMP_COMP_V2_ID                 19
#define WS_TEMP_COMP_V2_UUID               0x23A4
#define WS_TEMP_COMP_V2_UUID_BASE128(uuid) 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB0, 0x00, 0x40, 0x51, 0x04, LO_UINT16(uuid), HI_UINT16(uuid), 0x00, 0xF0
#define WS_TEMP_COMP_V2_LEN                12
#define WS_TEMP_COMP_V2_LEN_MIN            12

// Temp_Comp_V3 Characteristic defines
#define WS_TEMP_COMP_V3_ID                 20
#define WS_TEMP_COMP_V3_UUID               0x3E68
#define WS_TEMP_COMP_V3_UUID_BASE128(uuid) 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB0, 0x00, 0x40, 0x51, 0x04, LO_UINT16(uuid), HI_UINT16(uuid), 0x00, 0xF0
#define WS_TEMP_COMP_V3_LEN                12
#define WS_TEMP_COMP_V3_LEN_MIN            12

// Temp_Comp_V4 Characteristic defines
#define WS_TEMP_COMP_V4_ID                 21
#define WS_TEMP_COMP_V4_UUID               0x7251
#define WS_TEMP_COMP_V4_UUID_BASE128(uuid) 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB0, 0x00, 0x40, 0x51, 0x04, LO_UINT16(uuid), HI_UINT16(uuid), 0x00, 0xF0
#define WS_TEMP_COMP_V4_LEN                12
#define WS_TEMP_COMP_V4_LEN_MIN            12

// Temp_Comp_I1 Characteristic defines
#define WS_TEMP_COMP_I1_ID                 22
#define WS_TEMP_COMP_I1_UUID               0x8A85
#define WS_TEMP_COMP_I1_UUID_BASE128(uuid) 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB0, 0x00, 0x40, 0x51, 0x04, LO_UINT16(uuid), HI_UINT16(uuid), 0x00, 0xF0
#define WS_TEMP_COMP_I1_LEN                12
#define WS_TEMP_COMP_I1_LEN_MIN            12

// Temp_Comp_I2 Characteristic defines
#define WS_TEMP_COMP_I2_ID                 23
#define WS_TEMP_COMP_I2_UUID               0xFB1D
#define WS_TEMP_COMP_I2_UUID_BASE128(uuid) 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB0, 0x00, 0x40, 0x51, 0x04, LO_UINT16(uuid), HI_UINT16(uuid), 0x00, 0xF0
#define WS_TEMP_COMP_I2_LEN                12
#define WS_TEMP_COMP_I2_LEN_MIN            12

// Reserved_1 Characteristic defines
#define WS_RESERVED_1_ID                 24
#define WS_RESERVED_1_UUID               0xA980
#define WS_RESERVED_1_UUID_BASE128(uuid) 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB0, 0x00, 0x40, 0x51, 0x04, LO_UINT16(uuid), HI_UINT16(uuid), 0x00, 0xF0
#define WS_RESERVED_1_LEN                8
#define WS_RESERVED_1_LEN_MIN            8

// Reserved_2 Characteristic defines
#define WS_RESERVED_2_ID                 25
#define WS_RESERVED_2_UUID               0xEC6D
#define WS_RESERVED_2_UUID_BASE128(uuid) 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB0, 0x00, 0x40, 0x51, 0x04, LO_UINT16(uuid), HI_UINT16(uuid), 0x00, 0xF0
#define WS_RESERVED_2_LEN                8
#define WS_RESERVED_2_LEN_MIN            8

/*********************************************************************
 * TYPEDEFS
 */
//
// Fields in characteristic "DC_Reading"
//   Field "Data_Type" format: sint32, bits: 32
//
// Fields in characteristic "AC_Reading"
//   Field "Data_Type" format: sint64, bits: 64
//
// Fields in characteristic "Voltage_Range_1_Cal_Constants"
//   Field "Gain" format: float32, bits: 32
//   Field "DC_Offset" format: sint32, bits: 32
//   Field "AC_Offset" format: sint32, bits: 32
//
// Fields in characteristic "Voltage_Range_2_Cal_Constants"
//   Field "Gain" format: float32, bits: 32
//   Field "DC_Offset" format: sint32, bits: 32
//   Field "AC_Offset" format: sint32, bits: 32
//
// Fields in characteristic "Voltage_Range_3_Cal_Constants"
//   Field "Gain" format: float32, bits: 32
//   Field "DC_Offset" format: sint32, bits: 32
//   Field "AC_Offset" format: sint32, bits: 32
//
// Fields in characteristic "Voltage_Range_4_Cal_Constants"
//   Field "Gain" format: float32, bits: 32
//   Field "DC_Offset" format: sint32, bits: 32
//   Field "AC_Offset" format: sint32, bits: 32
//
// Fields in characteristic "Current_Range_1_Cal_Constants"
//   Field "Gain" format: float32, bits: 32
//   Field "DC_Offset" format: sint32, bits: 32
//   Field "AC_Offset" format: sint32, bits: 32
//
// Fields in characteristic "Current_Range_2_Cal_Constants"
//   Field "Gain" format: float32, bits: 32
//   Field "DC_Offset" format: sint32, bits: 32
//   Field "AC_Offset" format: sint32, bits: 32
//
// Fields in characteristic "Initiate_Power_Down"
//   Field "Data_Type" format: uint8, bits: 8
//
// Fields in characteristic "Voltage_Range_Select"
//   Field "Data_Type" format: uint8, bits: 8
//
// Fields in characteristic "Voltage_Range_Mode"
//   Field "New_Field" format: uint8, bits: 8
//
// Fields in characteristic "Measurement_Mode"
//   Field "New_Field" format: uint8, bits: 8
//
// Fields in characteristic "Current_Range_Select"
//   Field "New_Field" format: uint8, bits: 8
//
// Fields in characteristic "Battery Capacity Level"
//   Field "Battery_Level" format: uint16, bits: 16
//
// Fields in characteristic "Battery Voltage Level"
//   Field "New_Field" format: uint16, bits: 16
//
// Fields in characteristic "CapTIvate Sensing"
//   Field "New_Field" format: uint8, bits: 8
//
// Fields in characteristic "Sampling_Rate_Select"
//   Field "Data_Type" format: uint16, bits: 16
//
// Fields in characteristic "Reporting_Rate_Select"
//   Field "Data_Type" format: uint16, bits: 16
//
// Fields in characteristic "Temp_Comp_V1"
//   Field "Gain" format: float32, bits: 32
//   Field "DC_Offset" format: sint32, bits: 32
//   Field "AC_Offset" format: sint32, bits: 32
//
// Fields in characteristic "Temp_Comp_V2"
//   Field "Gain" format: float32, bits: 32
//   Field "DC_Offset" format: sint32, bits: 32
//   Field "AC_Offset" format: sint32, bits: 32
//
// Fields in characteristic "Temp_Comp_V3"
//   Field "Gain" format: float32, bits: 32
//   Field "DC_Offset" format: sint32, bits: 32
//   Field "AC_Offset" format: sint32, bits: 32
//
// Fields in characteristic "Temp_Comp_V4"
//   Field "Gain" format: float32, bits: 32
//   Field "DC_Offset" format: sint32, bits: 32
//   Field "AC_Offset" format: sint32, bits: 32
//
// Fields in characteristic "Temp_Comp_I1"
//   Field "Gain" format: float32, bits: 32
//   Field "DC_Offset" format: sint32, bits: 32
//   Field "AC_Offset" format: sint32, bits: 32
//
// Fields in characteristic "Temp_Comp_I2"
//   Field "Gain" format: float32, bits: 32
//   Field "DC_Offset" format: sint32, bits: 32
//   Field "AC_Offset" format: sint32, bits: 32
//
// Fields in characteristic "Reserved_1"
//   Field "Data_Type" format: sint64, bits: 64
//
// Fields in characteristic "Reserved_2"
//   Field "Data_Type" format: sint64, bits: 64
/*********************************************************************
 * MACROS
 */

/*********************************************************************
 * Profile Callbacks
 */

// Callback when a characteristic value has changed
typedef void (*WdmmServiceChange_t)( uint16_t connHandle, uint16_t svcUuid, uint8_t paramID, uint8_t *pValue, uint16_t len );

typedef struct
{
  WdmmServiceChange_t        pfnChangeCb;     // Called when characteristic value changes
  WdmmServiceChange_t        pfnCfgChangeCb;  // Called when characteristic CCCD changes
} WdmmServiceCBs_t;


/*********************************************************************
 * API FUNCTIONS 
 */


/*
 * WdmmService_AddService- Initializes the WdmmService service by registering
 *          GATT attributes with the GATT server.
 *
 */
extern bStatus_t WdmmService_AddService( void );

/*
 * WdmmService_RegisterAppCBs - Registers the application callback function.
 *                    Only call this function once.
 *
 *    appCallbacks - pointer to application callbacks.
 */
extern bStatus_t WdmmService_RegisterAppCBs( WdmmServiceCBs_t *appCallbacks );

/*
 * WdmmService_SetParameter - Set a WdmmService parameter.
 *
 *    param - Profile parameter ID
 *    len   - length of data to write
 *    value - pointer to data to write.  This is dependent on
 *            the parameter ID and may be cast to the appropriate 
 *            data type (example: data type of uint16_t will be cast to 
 *            uint16_t pointer).
 */
extern bStatus_t WdmmService_SetParameter( uint8_t param, uint16_t len, void *value );
  
/*
 * WdmmService_GetParameter - Get a WdmmService parameter.
 *
 *    param - Profile parameter ID
 *    len   - pointer to a variable that contains the maximum length that can be written to *value.
              After the call, this value will contain the actual returned length.
 *    value - pointer to data to write.  This is dependent on
 *            the parameter ID and may be cast to the appropriate 
 *            data type (example: data type of uint16_t will be cast to 
 *            uint16_t pointer).
 */
extern bStatus_t WdmmService_GetParameter( uint8_t param, uint16_t *len, void *value );

/*********************************************************************
*********************************************************************/

#ifdef __cplusplus
}
#endif

#endif /* _WDMM_SERVICE_H_ */
